/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	

/* DO NOT EDIT - THIS FILE GENERATED BY THE packer_bbox.py SCRIPT */

/* These functions pack glVertex functions and also update the bounding box
 * if the cr_packer_globals.updateBBOX variable is non-zero.
 */

#include "packer.h"
#include "cr_opcodes.h"
#include "pack_bbox.h"

#include <float.h>

/**
 * Reset packer bounding box to empty state.
 */
void crPackResetBoundingBox( CRPackContext *pc )
{
	pc->bounds_min.x =  FLT_MAX;
	pc->bounds_min.y =  FLT_MAX;
	pc->bounds_min.z =  FLT_MAX;
	pc->bounds_max.x = -FLT_MAX;
	pc->bounds_max.y = -FLT_MAX;
	pc->bounds_max.z = -FLT_MAX;
	pc->updateBBOX = 1;
}

/**
 * Query current bounding box.
 * 
eturn GL_TRUE if non-empty box, GL_FALSE if empty box.
 */
GLboolean crPackGetBoundingBox( CRPackContext *pc,
                                GLfloat *xmin, GLfloat *ymin, GLfloat *zmin,
                                GLfloat *xmax, GLfloat *ymax, GLfloat *zmax)
{
	if (pc->bounds_min.x != FLT_MAX) {
		*xmin = pc->bounds_min.x;
		*ymin = pc->bounds_min.y;
		*zmin = pc->bounds_min.z;
		*xmax = pc->bounds_max.x;
		*ymax = pc->bounds_max.y;
		*zmax = pc->bounds_max.z;
		return GL_TRUE;
	}
	else {
		return GL_FALSE;
	}
}


void PACK_APIENTRY crPackVertex2dBBOX( GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dvBBOX( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dBBOX_COUNT( GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dvBBOX_COUNT( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dBBOXSWAP( GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dvBBOXSWAP( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dBBOX_COUNTSWAP( GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2dvBBOX_COUNTSWAP( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
}

void PACK_APIENTRY crPackVertex2fBBOX( GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fvBBOX( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fBBOX_COUNT( GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fvBBOX_COUNT( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fBBOXSWAP( GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fvBBOXSWAP( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fBBOX_COUNTSWAP( GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2fvBBOX_COUNTSWAP( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
}

void PACK_APIENTRY crPackVertex2iBBOX( GLint x, GLint y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2ivBBOX( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2iBBOX_COUNT( GLint x, GLint y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2ivBBOX_COUNT( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2iBBOXSWAP( GLint x, GLint y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2ivBBOXSWAP( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2iBBOX_COUNTSWAP( GLint x, GLint y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2ivBBOX_COUNTSWAP( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
}

void PACK_APIENTRY crPackVertex2sBBOX( GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2svBBOX( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2sBBOX_COUNT( GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2svBBOX_COUNT( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2sBBOXSWAP( GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2svBBOXSWAP( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2sBBOX_COUNTSWAP( GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex2svBBOX_COUNTSWAP( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 4 );
	if (pc->updateBBOX)
	{
		UPDATE_2D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
}

void PACK_APIENTRY crPackVertex3dBBOX( GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dvBBOX( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dBBOX_COUNT( GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dvBBOX_COUNT( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dBBOXSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dvBBOXSWAP( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dBBOX_COUNTSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3dvBBOX_COUNTSWAP( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 24 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
}

void PACK_APIENTRY crPackVertex3fBBOX( GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fvBBOX( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fBBOX_COUNT( GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fvBBOX_COUNT( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fBBOXSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fvBBOXSWAP( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fBBOX_COUNTSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3fvBBOX_COUNTSWAP( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
}

void PACK_APIENTRY crPackVertex3iBBOX( GLint x, GLint y, GLint z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3ivBBOX( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3iBBOX_COUNT( GLint x, GLint y, GLint z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3ivBBOX_COUNT( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3iBBOXSWAP( GLint x, GLint y, GLint z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3ivBBOXSWAP( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3iBBOX_COUNTSWAP( GLint x, GLint y, GLint z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3ivBBOX_COUNTSWAP( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
}

void PACK_APIENTRY crPackVertex3sBBOX( GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3svBBOX( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3sBBOX_COUNT( GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3svBBOX_COUNT( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3sBBOXSWAP( GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3svBBOXSWAP( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3sBBOX_COUNTSWAP( GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex3svBBOX_COUNTSWAP( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
}

void PACK_APIENTRY crPackVertex4dBBOX( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dvBBOX( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dBBOX_COUNT( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dvBBOX_COUNT( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dBBOXSWAP( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_SWAPPED_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dvBBOXSWAP( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_SWAPPED_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dBBOX_COUNTSWAP( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_SWAPPED_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4dvBBOX_COUNTSWAP( const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 32 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_SWAPPED_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
}

void PACK_APIENTRY crPackVertex4fBBOX( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_DATA( 12, GLfloat, w );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fvBBOX( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_DATA( 12, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fBBOX_COUNT( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_DATA( 12, GLfloat, w );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fvBBOX_COUNT( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_DATA( 12, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fBBOXSWAP( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fvBBOXSWAP( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fBBOX_COUNTSWAP( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4fvBBOX_COUNTSWAP( const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
}

void PACK_APIENTRY crPackVertex4iBBOX( GLint x, GLint y, GLint z, GLint w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_DATA( 12, GLint, w );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4ivBBOX( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_DATA( 12, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4iBBOX_COUNT( GLint x, GLint y, GLint z, GLint w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_DATA( 12, GLint, w );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4ivBBOX_COUNT( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_DATA( 12, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4iBBOXSWAP( GLint x, GLint y, GLint z, GLint w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_DATA( 12, GLint, SWAP32(w) );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4ivBBOXSWAP( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4iBBOX_COUNTSWAP( GLint x, GLint y, GLint z, GLint w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_DATA( 12, GLint, SWAP32(w) );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4ivBBOX_COUNTSWAP( const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
}

void PACK_APIENTRY crPackVertex4sBBOX( GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_DATA( 6, GLshort, w );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4svBBOX( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_DATA( 6, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4sBBOX_COUNT( GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_DATA( 6, GLshort, w );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4svBBOX_COUNT( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_DATA( 6, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4sBBOXSWAP( GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_DATA( 6, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4svBBOXSWAP( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4sBBOX_COUNTSWAP( GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_DATA( 6, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertex4svBBOX_COUNTSWAP( const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX)
	{
		UPDATE_3D_BBOX();
	}
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dARBBBOX( GLuint index, GLdouble x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dvARBBBOX( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dARBBBOX_COUNT( GLuint index, GLdouble x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dvARBBBOX_COUNT( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dARBBBOXSWAP( GLuint index, GLdouble x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dvARBBBOXSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dARBBBOX_COUNTSWAP( GLuint index, GLdouble x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1dvARBBBOX_COUNTSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fARBBBOX( GLuint index, GLfloat x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fvARBBBOX( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fARBBBOX_COUNT( GLuint index, GLfloat x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fvARBBBOX_COUNT( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fARBBBOXSWAP( GLuint index, GLfloat x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fvARBBBOXSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fARBBBOX_COUNTSWAP( GLuint index, GLfloat x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1fvARBBBOX_COUNTSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1sARBBBOX( GLuint index, GLshort x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1svARBBBOX( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1sARBBBOX_COUNT( GLuint index, GLshort x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1svARBBBOX_COUNT( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1sARBBBOXSWAP( GLuint index, GLshort x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1svARBBBOXSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1sARBBBOX_COUNTSWAP( GLuint index, GLshort x )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib1svARBBBOX_COUNTSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_1D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_1D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dARBBBOX( GLuint index, GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dvARBBBOX( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dARBBBOX_COUNT( GLuint index, GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dvARBBBOX_COUNT( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dARBBBOXSWAP( GLuint index, GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dvARBBBOXSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dARBBBOX_COUNTSWAP( GLuint index, GLdouble x, GLdouble y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2dvARBBBOX_COUNTSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fARBBBOX( GLuint index, GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fvARBBBOX( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fARBBBOX_COUNT( GLuint index, GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fvARBBBOX_COUNT( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fARBBBOXSWAP( GLuint index, GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fvARBBBOXSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fARBBBOX_COUNTSWAP( GLuint index, GLfloat x, GLfloat y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2fvARBBBOX_COUNTSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2sARBBBOX( GLuint index, GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2svARBBBOX( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2sARBBBOX_COUNT( GLuint index, GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2svARBBBOX_COUNT( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2sARBBBOXSWAP( GLuint index, GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2svARBBBOXSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2sARBBBOX_COUNTSWAP( GLuint index, GLshort x, GLshort y )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib2svARBBBOX_COUNTSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_2D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_2D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dARBBBOX( GLuint index, GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_DOUBLE( 20, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dvARBBBOX( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_DOUBLE( 20, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dARBBBOX_COUNT( GLuint index, GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_DOUBLE( 20, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dvARBBBOX_COUNT( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_DOUBLE( 20, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dARBBBOXSWAP( GLuint index, GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_SWAPPED_DOUBLE( 20, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dvARBBBOXSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_SWAPPED_DOUBLE( 20, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dARBBBOX_COUNTSWAP( GLuint index, GLdouble x, GLdouble y, GLdouble z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_SWAPPED_DOUBLE( 20, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3dvARBBBOX_COUNTSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 28 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_SWAPPED_DOUBLE( 20, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fARBBBOX( GLuint index, GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fvARBBBOX( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_DATA( 12, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fARBBBOX_COUNT( GLuint index, GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fvARBBBOX_COUNT( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_DATA( 12, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fARBBBOXSWAP( GLuint index, GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fvARBBBOXSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fARBBBOX_COUNTSWAP( GLuint index, GLfloat x, GLfloat y, GLfloat z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3fvARBBBOX_COUNTSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 16 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3sARBBBOX( GLuint index, GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_DATA( 8, GLshort, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3svARBBBOX( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3sARBBBOX_COUNT( GLuint index, GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_DATA( 8, GLshort, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3svARBBBOX_COUNT( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3sARBBBOXSWAP( GLuint index, GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_DATA( 8, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3svARBBBOXSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3sARBBBOX_COUNTSWAP( GLuint index, GLshort x, GLshort y, GLshort z )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_DATA( 8, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib3svARBBBOX_COUNTSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_3D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dARBBBOX( GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_DOUBLE( 20, z );
	WRITE_DOUBLE( 28, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dvARBBBOX( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_DOUBLE( 20, v[2] );
	WRITE_DOUBLE( 28, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dARBBBOX_COUNT( GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_DOUBLE( 20, z );
	WRITE_DOUBLE( 28, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dvARBBBOX_COUNT( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_DOUBLE( 20, v[2] );
	WRITE_DOUBLE( 28, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dARBBBOXSWAP( GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_SWAPPED_DOUBLE( 20, z );
	WRITE_SWAPPED_DOUBLE( 28, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dvARBBBOXSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_SWAPPED_DOUBLE( 20, v[2] );
	WRITE_SWAPPED_DOUBLE( 28, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dARBBBOX_COUNTSWAP( GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_SWAPPED_DOUBLE( 20, z );
	WRITE_SWAPPED_DOUBLE( 28, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4dvARBBBOX_COUNTSWAP( GLuint index, const GLdouble * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 36 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_SWAPPED_DOUBLE( 20, v[2] );
	WRITE_SWAPPED_DOUBLE( 28, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fARBBBOX( GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_DATA( 16, GLfloat, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fvARBBBOX( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_DATA( 12, GLfloat, v[2] );
	WRITE_DATA( 16, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fARBBBOX_COUNT( GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_DATA( 16, GLfloat, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fvARBBBOX_COUNT( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_DATA( 12, GLfloat, v[2] );
	WRITE_DATA( 16, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fARBBBOXSWAP( GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fvARBBBOXSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fARBBBOX_COUNTSWAP( GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4fvARBBBOX_COUNTSWAP( GLuint index, const GLfloat * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4sARBBBOX( GLuint index, GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_DATA( 8, GLshort, z );
	WRITE_DATA( 10, GLshort, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4svARBBBOX( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_DATA( 10, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4sARBBBOX_COUNT( GLuint index, GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_DATA( 8, GLshort, z );
	WRITE_DATA( 10, GLshort, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4svARBBBOX_COUNT( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_DATA( 10, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4sARBBBOXSWAP( GLuint index, GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_DATA( 8, GLshort, SWAP16(z) );
	WRITE_DATA( 10, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4svARBBBOXSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4sARBBBOX_COUNTSWAP( GLuint index, GLshort x, GLshort y, GLshort z, GLshort w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_DATA( 8, GLshort, SWAP16(z) );
	WRITE_DATA( 10, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4svARBBBOX_COUNTSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ubvARBBBOX( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ubvARBBBOX_COUNT( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ubvARBBBOXSWAP( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ubvARBBBOX_COUNTSWAP( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4usvARBBBOX( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.us4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLushort, v[0] );
	WRITE_DATA( 6, GLushort, v[1] );
	WRITE_DATA( 8, GLushort, v[2] );
	WRITE_DATA( 10, GLushort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4USVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4usvARBBBOX_COUNT( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.us4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLushort, v[0] );
	WRITE_DATA( 6, GLushort, v[1] );
	WRITE_DATA( 8, GLushort, v[2] );
	WRITE_DATA( 10, GLushort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4USVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4usvARBBBOXSWAP( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.us4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLushort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLushort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4USVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4usvARBBBOX_COUNTSWAP( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.us4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLushort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLushort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4USVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4uivARBBBOX( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLuint, v[0] );
	WRITE_DATA( 8, GLuint, v[1] );
	WRITE_DATA( 12, GLuint, v[2] );
	WRITE_DATA( 16, GLuint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4uivARBBBOX_COUNT( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLuint, v[0] );
	WRITE_DATA( 8, GLuint, v[1] );
	WRITE_DATA( 12, GLuint, v[2] );
	WRITE_DATA( 16, GLuint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4uivARBBBOXSWAP( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLuint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLuint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4uivARBBBOX_COUNTSWAP( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.ui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLuint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLuint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4UIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4bvARBBBOX( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.b4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4BVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4bvARBBBOX_COUNT( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.b4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4BVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4bvARBBBOXSWAP( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.b4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4BVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4bvARBBBOX_COUNTSWAP( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.b4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4BVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ivARBBBOX( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.i4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLint, v[0] );
	WRITE_DATA( 8, GLint, v[1] );
	WRITE_DATA( 12, GLint, v[2] );
	WRITE_DATA( 16, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4IVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ivARBBBOX_COUNT( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.i4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLint, v[0] );
	WRITE_DATA( 8, GLint, v[1] );
	WRITE_DATA( 12, GLint, v[2] );
	WRITE_DATA( 16, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4IVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ivARBBBOXSWAP( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.i4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4IVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4ivARBBBOX_COUNTSWAP( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.i4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4IVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NbvARBBBOX( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_B_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nb4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NbvARBBBOX_COUNT( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_B_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nb4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NbvARBBBOXSWAP( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_B_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nb4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NbvARBBBOX_COUNTSWAP( GLuint index, const GLbyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_B_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nb4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLbyte, v[0] );
	WRITE_DATA( 5, GLbyte, v[1] );
	WRITE_DATA( 6, GLbyte, v[2] );
	WRITE_DATA( 7, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NsvARBBBOX( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_S_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ns4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_DATA( 10, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NsvARBBBOX_COUNT( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_S_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ns4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_DATA( 10, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NsvARBBBOXSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_S_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ns4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NsvARBBBOX_COUNTSWAP( GLuint index, const GLshort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_S_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ns4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NivARBBBOX( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_I_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ni4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLint, v[0] );
	WRITE_DATA( 8, GLint, v[1] );
	WRITE_DATA( 12, GLint, v[2] );
	WRITE_DATA( 16, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NivARBBBOX_COUNT( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_I_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ni4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLint, v[0] );
	WRITE_DATA( 8, GLint, v[1] );
	WRITE_DATA( 12, GLint, v[2] );
	WRITE_DATA( 16, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NivARBBBOXSWAP( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_I_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ni4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NivARBBBOX_COUNTSWAP( GLuint index, const GLint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_I_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Ni4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubvARBBBOX( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UB_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubvARBBBOX_COUNT( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UB_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubvARBBBOXSWAP( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UB_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubvARBBBOX_COUNTSWAP( GLuint index, const GLubyte * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UB_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, v[0] );
	WRITE_DATA( 5, GLubyte, v[1] );
	WRITE_DATA( 6, GLubyte, v[2] );
	WRITE_DATA( 7, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NusvARBBBOX( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_US_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nus4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLushort, v[0] );
	WRITE_DATA( 6, GLushort, v[1] );
	WRITE_DATA( 8, GLushort, v[2] );
	WRITE_DATA( 10, GLushort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NusvARBBBOX_COUNT( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_US_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nus4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLushort, v[0] );
	WRITE_DATA( 6, GLushort, v[1] );
	WRITE_DATA( 8, GLushort, v[2] );
	WRITE_DATA( 10, GLushort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NusvARBBBOXSWAP( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_US_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nus4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLushort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLushort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NusvARBBBOX_COUNTSWAP( GLuint index, const GLushort * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_US_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 12 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nus4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLushort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLushort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUSVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NuivARBBBOX( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UI_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLuint, v[0] );
	WRITE_DATA( 8, GLuint, v[1] );
	WRITE_DATA( 12, GLuint, v[2] );
	WRITE_DATA( 16, GLuint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NuivARBBBOX_COUNT( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UI_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLuint, v[0] );
	WRITE_DATA( 8, GLuint, v[1] );
	WRITE_DATA( 12, GLuint, v[2] );
	WRITE_DATA( 16, GLuint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NuivARBBBOXSWAP( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UI_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLuint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLuint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NuivARBBBOX_COUNTSWAP( GLuint index, const GLuint * v )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_VFLOATS_UI_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 20 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nui4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 12, GLuint, SWAP32(v[2]) );
	WRITE_DATA( 16, GLuint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUIVARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubARBBBOX( GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS_UB_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, x );
	WRITE_DATA( 5, GLubyte, y );
	WRITE_DATA( 6, GLubyte, z );
	WRITE_DATA( 7, GLubyte, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubARBBBOX_COUNT( GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS_UB_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, x );
	WRITE_DATA( 5, GLubyte, y );
	WRITE_DATA( 6, GLubyte, z );
	WRITE_DATA( 7, GLubyte, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubARBBBOXSWAP( GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS_UB_NORMALIZED();
	GET_BUFFERED_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, x );
	WRITE_DATA( 5, GLubyte, y );
	WRITE_DATA( 6, GLubyte, z );
	WRITE_DATA( 7, GLubyte, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBARB_OPCODE );
}

void PACK_APIENTRY crPackVertexAttrib4NubARBBBOX_COUNTSWAP( GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w )
{
	GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	CREATE_4D_FLOATS_UB_NORMALIZED();
	GET_BUFFERED_COUNT_POINTER( pc, 8 );
	if (pc->updateBBOX && index == 0)
	{
		UPDATE_3D_BBOX();
	}
	if (index > 0) {
		pc->current.c.vertexAttrib.Nub4[index] = data_ptr + 4;
		pc->current.attribsUsedMask |= (1 << index);
		pc->current.vtx_count--;
	}
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, x );
	WRITE_DATA( 5, GLubyte, y );
	WRITE_DATA( 6, GLubyte, z );
	WRITE_DATA( 7, GLubyte, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBARB_OPCODE );
}

