/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	
#include <stdio.h>
#include "cr_error.h"
#include "cr_string.h"
#include "cr_spu.h"
#include "passthroughspu.h"

SPUNamedFunctionTable _cr_passthrough_table[664];

static void __fillin( int offset, char *name, SPUGenericFunction func )
{
	_cr_passthrough_table[offset].name = crStrdup( name );
	_cr_passthrough_table[offset].fn = func;
}

void BuildPassthroughTable( SPU *child )
{
	__fillin(   0, "Accum", (SPUGenericFunction) child->dispatch_table.Accum );
	__fillin(   1, "ActiveTextureARB", (SPUGenericFunction) child->dispatch_table.ActiveTextureARB );
	__fillin(   2, "AlphaFunc", (SPUGenericFunction) child->dispatch_table.AlphaFunc );
	__fillin(   3, "AreProgramsResidentNV", (SPUGenericFunction) child->dispatch_table.AreProgramsResidentNV );
	__fillin(   4, "AreTexturesResident", (SPUGenericFunction) child->dispatch_table.AreTexturesResident );
	__fillin(   5, "ArrayElement", (SPUGenericFunction) child->dispatch_table.ArrayElement );
	__fillin(   6, "AttachObjectARB", (SPUGenericFunction) child->dispatch_table.AttachObjectARB );
	__fillin(   7, "AttachShader", (SPUGenericFunction) child->dispatch_table.AttachShader );
	__fillin(   8, "BarrierCreateCR", (SPUGenericFunction) child->dispatch_table.BarrierCreateCR );
	__fillin(   9, "BarrierDestroyCR", (SPUGenericFunction) child->dispatch_table.BarrierDestroyCR );
	__fillin(  10, "BarrierExecCR", (SPUGenericFunction) child->dispatch_table.BarrierExecCR );
	__fillin(  11, "Begin", (SPUGenericFunction) child->dispatch_table.Begin );
	__fillin(  12, "BeginQueryARB", (SPUGenericFunction) child->dispatch_table.BeginQueryARB );
	__fillin(  13, "BindAttribLocation", (SPUGenericFunction) child->dispatch_table.BindAttribLocation );
	__fillin(  14, "BindBufferARB", (SPUGenericFunction) child->dispatch_table.BindBufferARB );
	__fillin(  15, "BindProgramARB", (SPUGenericFunction) child->dispatch_table.BindProgramARB );
	__fillin(  16, "BindProgramNV", (SPUGenericFunction) child->dispatch_table.BindProgramNV );
	__fillin(  17, "BindTexture", (SPUGenericFunction) child->dispatch_table.BindTexture );
	__fillin(  18, "Bitmap", (SPUGenericFunction) child->dispatch_table.Bitmap );
	__fillin(  19, "BlendColorEXT", (SPUGenericFunction) child->dispatch_table.BlendColorEXT );
	__fillin(  20, "BlendEquationEXT", (SPUGenericFunction) child->dispatch_table.BlendEquationEXT );
	__fillin(  21, "BlendEquationSeparate", (SPUGenericFunction) child->dispatch_table.BlendEquationSeparate );
	__fillin(  22, "BlendFunc", (SPUGenericFunction) child->dispatch_table.BlendFunc );
	__fillin(  23, "BlendFuncSeparateEXT", (SPUGenericFunction) child->dispatch_table.BlendFuncSeparateEXT );
	__fillin(  24, "BoundsInfoCR", (SPUGenericFunction) child->dispatch_table.BoundsInfoCR );
	__fillin(  25, "BufferDataARB", (SPUGenericFunction) child->dispatch_table.BufferDataARB );
	__fillin(  26, "BufferSubDataARB", (SPUGenericFunction) child->dispatch_table.BufferSubDataARB );
	__fillin(  27, "CallList", (SPUGenericFunction) child->dispatch_table.CallList );
	__fillin(  28, "CallLists", (SPUGenericFunction) child->dispatch_table.CallLists );
	__fillin(  29, "ChromiumParameterfCR", (SPUGenericFunction) child->dispatch_table.ChromiumParameterfCR );
	__fillin(  30, "ChromiumParameteriCR", (SPUGenericFunction) child->dispatch_table.ChromiumParameteriCR );
	__fillin(  31, "ChromiumParametervCR", (SPUGenericFunction) child->dispatch_table.ChromiumParametervCR );
	__fillin(  32, "Clear", (SPUGenericFunction) child->dispatch_table.Clear );
	__fillin(  33, "ClearAccum", (SPUGenericFunction) child->dispatch_table.ClearAccum );
	__fillin(  34, "ClearColor", (SPUGenericFunction) child->dispatch_table.ClearColor );
	__fillin(  35, "ClearDepth", (SPUGenericFunction) child->dispatch_table.ClearDepth );
	__fillin(  36, "ClearIndex", (SPUGenericFunction) child->dispatch_table.ClearIndex );
	__fillin(  37, "ClearStencil", (SPUGenericFunction) child->dispatch_table.ClearStencil );
	__fillin(  38, "ClientActiveTextureARB", (SPUGenericFunction) child->dispatch_table.ClientActiveTextureARB );
	__fillin(  39, "ClipPlane", (SPUGenericFunction) child->dispatch_table.ClipPlane );
	__fillin(  40, "Color3b", (SPUGenericFunction) child->dispatch_table.Color3b );
	__fillin(  41, "Color3bv", (SPUGenericFunction) child->dispatch_table.Color3bv );
	__fillin(  42, "Color3d", (SPUGenericFunction) child->dispatch_table.Color3d );
	__fillin(  43, "Color3dv", (SPUGenericFunction) child->dispatch_table.Color3dv );
	__fillin(  44, "Color3f", (SPUGenericFunction) child->dispatch_table.Color3f );
	__fillin(  45, "Color3fv", (SPUGenericFunction) child->dispatch_table.Color3fv );
	__fillin(  46, "Color3i", (SPUGenericFunction) child->dispatch_table.Color3i );
	__fillin(  47, "Color3iv", (SPUGenericFunction) child->dispatch_table.Color3iv );
	__fillin(  48, "Color3s", (SPUGenericFunction) child->dispatch_table.Color3s );
	__fillin(  49, "Color3sv", (SPUGenericFunction) child->dispatch_table.Color3sv );
	__fillin(  50, "Color3ub", (SPUGenericFunction) child->dispatch_table.Color3ub );
	__fillin(  51, "Color3ubv", (SPUGenericFunction) child->dispatch_table.Color3ubv );
	__fillin(  52, "Color3ui", (SPUGenericFunction) child->dispatch_table.Color3ui );
	__fillin(  53, "Color3uiv", (SPUGenericFunction) child->dispatch_table.Color3uiv );
	__fillin(  54, "Color3us", (SPUGenericFunction) child->dispatch_table.Color3us );
	__fillin(  55, "Color3usv", (SPUGenericFunction) child->dispatch_table.Color3usv );
	__fillin(  56, "Color4b", (SPUGenericFunction) child->dispatch_table.Color4b );
	__fillin(  57, "Color4bv", (SPUGenericFunction) child->dispatch_table.Color4bv );
	__fillin(  58, "Color4d", (SPUGenericFunction) child->dispatch_table.Color4d );
	__fillin(  59, "Color4dv", (SPUGenericFunction) child->dispatch_table.Color4dv );
	__fillin(  60, "Color4f", (SPUGenericFunction) child->dispatch_table.Color4f );
	__fillin(  61, "Color4fv", (SPUGenericFunction) child->dispatch_table.Color4fv );
	__fillin(  62, "Color4i", (SPUGenericFunction) child->dispatch_table.Color4i );
	__fillin(  63, "Color4iv", (SPUGenericFunction) child->dispatch_table.Color4iv );
	__fillin(  64, "Color4s", (SPUGenericFunction) child->dispatch_table.Color4s );
	__fillin(  65, "Color4sv", (SPUGenericFunction) child->dispatch_table.Color4sv );
	__fillin(  66, "Color4ub", (SPUGenericFunction) child->dispatch_table.Color4ub );
	__fillin(  67, "Color4ubv", (SPUGenericFunction) child->dispatch_table.Color4ubv );
	__fillin(  68, "Color4ui", (SPUGenericFunction) child->dispatch_table.Color4ui );
	__fillin(  69, "Color4uiv", (SPUGenericFunction) child->dispatch_table.Color4uiv );
	__fillin(  70, "Color4us", (SPUGenericFunction) child->dispatch_table.Color4us );
	__fillin(  71, "Color4usv", (SPUGenericFunction) child->dispatch_table.Color4usv );
	__fillin(  72, "ColorMask", (SPUGenericFunction) child->dispatch_table.ColorMask );
	__fillin(  73, "ColorMaterial", (SPUGenericFunction) child->dispatch_table.ColorMaterial );
	__fillin(  74, "ColorPointer", (SPUGenericFunction) child->dispatch_table.ColorPointer );
	__fillin(  75, "CombinerInputNV", (SPUGenericFunction) child->dispatch_table.CombinerInputNV );
	__fillin(  76, "CombinerOutputNV", (SPUGenericFunction) child->dispatch_table.CombinerOutputNV );
	__fillin(  77, "CombinerParameterfNV", (SPUGenericFunction) child->dispatch_table.CombinerParameterfNV );
	__fillin(  78, "CombinerParameterfvNV", (SPUGenericFunction) child->dispatch_table.CombinerParameterfvNV );
	__fillin(  79, "CombinerParameteriNV", (SPUGenericFunction) child->dispatch_table.CombinerParameteriNV );
	__fillin(  80, "CombinerParameterivNV", (SPUGenericFunction) child->dispatch_table.CombinerParameterivNV );
	__fillin(  81, "CombinerStageParameterfvNV", (SPUGenericFunction) child->dispatch_table.CombinerStageParameterfvNV );
	__fillin(  82, "CompileShader", (SPUGenericFunction) child->dispatch_table.CompileShader );
	__fillin(  83, "CompressedTexImage1DARB", (SPUGenericFunction) child->dispatch_table.CompressedTexImage1DARB );
	__fillin(  84, "CompressedTexImage2DARB", (SPUGenericFunction) child->dispatch_table.CompressedTexImage2DARB );
	__fillin(  85, "CompressedTexImage3DARB", (SPUGenericFunction) child->dispatch_table.CompressedTexImage3DARB );
	__fillin(  86, "CompressedTexSubImage1DARB", (SPUGenericFunction) child->dispatch_table.CompressedTexSubImage1DARB );
	__fillin(  87, "CompressedTexSubImage2DARB", (SPUGenericFunction) child->dispatch_table.CompressedTexSubImage2DARB );
	__fillin(  88, "CompressedTexSubImage3DARB", (SPUGenericFunction) child->dispatch_table.CompressedTexSubImage3DARB );
	__fillin(  89, "CopyPixels", (SPUGenericFunction) child->dispatch_table.CopyPixels );
	__fillin(  90, "CopyTexImage1D", (SPUGenericFunction) child->dispatch_table.CopyTexImage1D );
	__fillin(  91, "CopyTexImage2D", (SPUGenericFunction) child->dispatch_table.CopyTexImage2D );
	__fillin(  92, "CopyTexSubImage1D", (SPUGenericFunction) child->dispatch_table.CopyTexSubImage1D );
	__fillin(  93, "CopyTexSubImage2D", (SPUGenericFunction) child->dispatch_table.CopyTexSubImage2D );
	__fillin(  94, "CopyTexSubImage3D", (SPUGenericFunction) child->dispatch_table.CopyTexSubImage3D );
	__fillin(  95, "CreateContext", (SPUGenericFunction) child->dispatch_table.CreateContext );
	__fillin(  96, "CreateProgram", (SPUGenericFunction) child->dispatch_table.CreateProgram );
	__fillin(  97, "CreateShader", (SPUGenericFunction) child->dispatch_table.CreateShader );
	__fillin(  98, "CullFace", (SPUGenericFunction) child->dispatch_table.CullFace );
	__fillin(  99, "DeleteBuffersARB", (SPUGenericFunction) child->dispatch_table.DeleteBuffersARB );
	__fillin( 100, "DeleteFencesNV", (SPUGenericFunction) child->dispatch_table.DeleteFencesNV );
	__fillin( 101, "DeleteLists", (SPUGenericFunction) child->dispatch_table.DeleteLists );
	__fillin( 102, "DeleteObjectARB", (SPUGenericFunction) child->dispatch_table.DeleteObjectARB );
	__fillin( 103, "DeleteProgram", (SPUGenericFunction) child->dispatch_table.DeleteProgram );
	__fillin( 104, "DeleteProgramsARB", (SPUGenericFunction) child->dispatch_table.DeleteProgramsARB );
	__fillin( 105, "DeleteQueriesARB", (SPUGenericFunction) child->dispatch_table.DeleteQueriesARB );
	__fillin( 106, "DeleteShader", (SPUGenericFunction) child->dispatch_table.DeleteShader );
	__fillin( 107, "DeleteTextures", (SPUGenericFunction) child->dispatch_table.DeleteTextures );
	__fillin( 108, "DepthFunc", (SPUGenericFunction) child->dispatch_table.DepthFunc );
	__fillin( 109, "DepthMask", (SPUGenericFunction) child->dispatch_table.DepthMask );
	__fillin( 110, "DepthRange", (SPUGenericFunction) child->dispatch_table.DepthRange );
	__fillin( 111, "DestroyContext", (SPUGenericFunction) child->dispatch_table.DestroyContext );
	__fillin( 112, "DetachObjectARB", (SPUGenericFunction) child->dispatch_table.DetachObjectARB );
	__fillin( 113, "DetachShader", (SPUGenericFunction) child->dispatch_table.DetachShader );
	__fillin( 114, "Disable", (SPUGenericFunction) child->dispatch_table.Disable );
	__fillin( 115, "DisableClientState", (SPUGenericFunction) child->dispatch_table.DisableClientState );
	__fillin( 116, "DisableVertexAttribArrayARB", (SPUGenericFunction) child->dispatch_table.DisableVertexAttribArrayARB );
	__fillin( 117, "DrawArrays", (SPUGenericFunction) child->dispatch_table.DrawArrays );
	__fillin( 118, "DrawBuffer", (SPUGenericFunction) child->dispatch_table.DrawBuffer );
	__fillin( 119, "DrawBuffers", (SPUGenericFunction) child->dispatch_table.DrawBuffers );
	__fillin( 120, "DrawElements", (SPUGenericFunction) child->dispatch_table.DrawElements );
	__fillin( 121, "DrawPixels", (SPUGenericFunction) child->dispatch_table.DrawPixels );
	__fillin( 122, "DrawRangeElements", (SPUGenericFunction) child->dispatch_table.DrawRangeElements );
	__fillin( 123, "EdgeFlag", (SPUGenericFunction) child->dispatch_table.EdgeFlag );
	__fillin( 124, "EdgeFlagPointer", (SPUGenericFunction) child->dispatch_table.EdgeFlagPointer );
	__fillin( 125, "EdgeFlagv", (SPUGenericFunction) child->dispatch_table.EdgeFlagv );
	__fillin( 126, "Enable", (SPUGenericFunction) child->dispatch_table.Enable );
	__fillin( 127, "EnableClientState", (SPUGenericFunction) child->dispatch_table.EnableClientState );
	__fillin( 128, "EnableVertexAttribArrayARB", (SPUGenericFunction) child->dispatch_table.EnableVertexAttribArrayARB );
	__fillin( 129, "End", (SPUGenericFunction) child->dispatch_table.End );
	__fillin( 130, "EndList", (SPUGenericFunction) child->dispatch_table.EndList );
	__fillin( 131, "EndQueryARB", (SPUGenericFunction) child->dispatch_table.EndQueryARB );
	__fillin( 132, "EvalCoord1d", (SPUGenericFunction) child->dispatch_table.EvalCoord1d );
	__fillin( 133, "EvalCoord1dv", (SPUGenericFunction) child->dispatch_table.EvalCoord1dv );
	__fillin( 134, "EvalCoord1f", (SPUGenericFunction) child->dispatch_table.EvalCoord1f );
	__fillin( 135, "EvalCoord1fv", (SPUGenericFunction) child->dispatch_table.EvalCoord1fv );
	__fillin( 136, "EvalCoord2d", (SPUGenericFunction) child->dispatch_table.EvalCoord2d );
	__fillin( 137, "EvalCoord2dv", (SPUGenericFunction) child->dispatch_table.EvalCoord2dv );
	__fillin( 138, "EvalCoord2f", (SPUGenericFunction) child->dispatch_table.EvalCoord2f );
	__fillin( 139, "EvalCoord2fv", (SPUGenericFunction) child->dispatch_table.EvalCoord2fv );
	__fillin( 140, "EvalMesh1", (SPUGenericFunction) child->dispatch_table.EvalMesh1 );
	__fillin( 141, "EvalMesh2", (SPUGenericFunction) child->dispatch_table.EvalMesh2 );
	__fillin( 142, "EvalPoint1", (SPUGenericFunction) child->dispatch_table.EvalPoint1 );
	__fillin( 143, "EvalPoint2", (SPUGenericFunction) child->dispatch_table.EvalPoint2 );
	__fillin( 144, "ExecuteProgramNV", (SPUGenericFunction) child->dispatch_table.ExecuteProgramNV );
	__fillin( 145, "FeedbackBuffer", (SPUGenericFunction) child->dispatch_table.FeedbackBuffer );
	__fillin( 146, "FinalCombinerInputNV", (SPUGenericFunction) child->dispatch_table.FinalCombinerInputNV );
	__fillin( 147, "Finish", (SPUGenericFunction) child->dispatch_table.Finish );
	__fillin( 148, "FinishFenceNV", (SPUGenericFunction) child->dispatch_table.FinishFenceNV );
	__fillin( 149, "Flush", (SPUGenericFunction) child->dispatch_table.Flush );
	__fillin( 150, "FlushVertexArrayRangeNV", (SPUGenericFunction) child->dispatch_table.FlushVertexArrayRangeNV );
	__fillin( 151, "FogCoordPointerEXT", (SPUGenericFunction) child->dispatch_table.FogCoordPointerEXT );
	__fillin( 152, "FogCoorddEXT", (SPUGenericFunction) child->dispatch_table.FogCoorddEXT );
	__fillin( 153, "FogCoorddvEXT", (SPUGenericFunction) child->dispatch_table.FogCoorddvEXT );
	__fillin( 154, "FogCoordfEXT", (SPUGenericFunction) child->dispatch_table.FogCoordfEXT );
	__fillin( 155, "FogCoordfvEXT", (SPUGenericFunction) child->dispatch_table.FogCoordfvEXT );
	__fillin( 156, "Fogf", (SPUGenericFunction) child->dispatch_table.Fogf );
	__fillin( 157, "Fogfv", (SPUGenericFunction) child->dispatch_table.Fogfv );
	__fillin( 158, "Fogi", (SPUGenericFunction) child->dispatch_table.Fogi );
	__fillin( 159, "Fogiv", (SPUGenericFunction) child->dispatch_table.Fogiv );
	__fillin( 160, "FrontFace", (SPUGenericFunction) child->dispatch_table.FrontFace );
	__fillin( 161, "Frustum", (SPUGenericFunction) child->dispatch_table.Frustum );
	__fillin( 162, "GenBuffersARB", (SPUGenericFunction) child->dispatch_table.GenBuffersARB );
	__fillin( 163, "GenFencesNV", (SPUGenericFunction) child->dispatch_table.GenFencesNV );
	__fillin( 164, "GenLists", (SPUGenericFunction) child->dispatch_table.GenLists );
	__fillin( 165, "GenProgramsARB", (SPUGenericFunction) child->dispatch_table.GenProgramsARB );
	__fillin( 166, "GenProgramsNV", (SPUGenericFunction) child->dispatch_table.GenProgramsNV );
	__fillin( 167, "GenQueriesARB", (SPUGenericFunction) child->dispatch_table.GenQueriesARB );
	__fillin( 168, "GenTextures", (SPUGenericFunction) child->dispatch_table.GenTextures );
	__fillin( 169, "GetActiveAttrib", (SPUGenericFunction) child->dispatch_table.GetActiveAttrib );
	__fillin( 170, "GetActiveUniform", (SPUGenericFunction) child->dispatch_table.GetActiveUniform );
	__fillin( 171, "GetAttachedObjectsARB", (SPUGenericFunction) child->dispatch_table.GetAttachedObjectsARB );
	__fillin( 172, "GetAttachedShaders", (SPUGenericFunction) child->dispatch_table.GetAttachedShaders );
	__fillin( 173, "GetAttribLocation", (SPUGenericFunction) child->dispatch_table.GetAttribLocation );
	__fillin( 174, "GetBooleanv", (SPUGenericFunction) child->dispatch_table.GetBooleanv );
	__fillin( 175, "GetBufferParameterivARB", (SPUGenericFunction) child->dispatch_table.GetBufferParameterivARB );
	__fillin( 176, "GetBufferPointervARB", (SPUGenericFunction) child->dispatch_table.GetBufferPointervARB );
	__fillin( 177, "GetBufferSubDataARB", (SPUGenericFunction) child->dispatch_table.GetBufferSubDataARB );
	__fillin( 178, "GetChromiumParametervCR", (SPUGenericFunction) child->dispatch_table.GetChromiumParametervCR );
	__fillin( 179, "GetClipPlane", (SPUGenericFunction) child->dispatch_table.GetClipPlane );
	__fillin( 180, "GetCombinerInputParameterfvNV", (SPUGenericFunction) child->dispatch_table.GetCombinerInputParameterfvNV );
	__fillin( 181, "GetCombinerInputParameterivNV", (SPUGenericFunction) child->dispatch_table.GetCombinerInputParameterivNV );
	__fillin( 182, "GetCombinerOutputParameterfvNV", (SPUGenericFunction) child->dispatch_table.GetCombinerOutputParameterfvNV );
	__fillin( 183, "GetCombinerOutputParameterivNV", (SPUGenericFunction) child->dispatch_table.GetCombinerOutputParameterivNV );
	__fillin( 184, "GetCombinerStageParameterfvNV", (SPUGenericFunction) child->dispatch_table.GetCombinerStageParameterfvNV );
	__fillin( 185, "GetCompressedTexImageARB", (SPUGenericFunction) child->dispatch_table.GetCompressedTexImageARB );
	__fillin( 186, "GetDoublev", (SPUGenericFunction) child->dispatch_table.GetDoublev );
	__fillin( 187, "GetError", (SPUGenericFunction) child->dispatch_table.GetError );
	__fillin( 188, "GetFenceivNV", (SPUGenericFunction) child->dispatch_table.GetFenceivNV );
	__fillin( 189, "GetFinalCombinerInputParameterfvNV", (SPUGenericFunction) child->dispatch_table.GetFinalCombinerInputParameterfvNV );
	__fillin( 190, "GetFinalCombinerInputParameterivNV", (SPUGenericFunction) child->dispatch_table.GetFinalCombinerInputParameterivNV );
	__fillin( 191, "GetFloatv", (SPUGenericFunction) child->dispatch_table.GetFloatv );
	__fillin( 192, "GetHandleARB", (SPUGenericFunction) child->dispatch_table.GetHandleARB );
	__fillin( 193, "GetInfoLogARB", (SPUGenericFunction) child->dispatch_table.GetInfoLogARB );
	__fillin( 194, "GetIntegerv", (SPUGenericFunction) child->dispatch_table.GetIntegerv );
	__fillin( 195, "GetLightfv", (SPUGenericFunction) child->dispatch_table.GetLightfv );
	__fillin( 196, "GetLightiv", (SPUGenericFunction) child->dispatch_table.GetLightiv );
	__fillin( 197, "GetMapdv", (SPUGenericFunction) child->dispatch_table.GetMapdv );
	__fillin( 198, "GetMapfv", (SPUGenericFunction) child->dispatch_table.GetMapfv );
	__fillin( 199, "GetMapiv", (SPUGenericFunction) child->dispatch_table.GetMapiv );
	__fillin( 200, "GetMaterialfv", (SPUGenericFunction) child->dispatch_table.GetMaterialfv );
	__fillin( 201, "GetMaterialiv", (SPUGenericFunction) child->dispatch_table.GetMaterialiv );
	__fillin( 202, "GetObjectParameterfvARB", (SPUGenericFunction) child->dispatch_table.GetObjectParameterfvARB );
	__fillin( 203, "GetObjectParameterivARB", (SPUGenericFunction) child->dispatch_table.GetObjectParameterivARB );
	__fillin( 204, "GetPixelMapfv", (SPUGenericFunction) child->dispatch_table.GetPixelMapfv );
	__fillin( 205, "GetPixelMapuiv", (SPUGenericFunction) child->dispatch_table.GetPixelMapuiv );
	__fillin( 206, "GetPixelMapusv", (SPUGenericFunction) child->dispatch_table.GetPixelMapusv );
	__fillin( 207, "GetPointerv", (SPUGenericFunction) child->dispatch_table.GetPointerv );
	__fillin( 208, "GetPolygonStipple", (SPUGenericFunction) child->dispatch_table.GetPolygonStipple );
	__fillin( 209, "GetProgramEnvParameterdvARB", (SPUGenericFunction) child->dispatch_table.GetProgramEnvParameterdvARB );
	__fillin( 210, "GetProgramEnvParameterfvARB", (SPUGenericFunction) child->dispatch_table.GetProgramEnvParameterfvARB );
	__fillin( 211, "GetProgramInfoLog", (SPUGenericFunction) child->dispatch_table.GetProgramInfoLog );
	__fillin( 212, "GetProgramLocalParameterdvARB", (SPUGenericFunction) child->dispatch_table.GetProgramLocalParameterdvARB );
	__fillin( 213, "GetProgramLocalParameterfvARB", (SPUGenericFunction) child->dispatch_table.GetProgramLocalParameterfvARB );
	__fillin( 214, "GetProgramNamedParameterdvNV", (SPUGenericFunction) child->dispatch_table.GetProgramNamedParameterdvNV );
	__fillin( 215, "GetProgramNamedParameterfvNV", (SPUGenericFunction) child->dispatch_table.GetProgramNamedParameterfvNV );
	__fillin( 216, "GetProgramParameterdvNV", (SPUGenericFunction) child->dispatch_table.GetProgramParameterdvNV );
	__fillin( 217, "GetProgramParameterfvNV", (SPUGenericFunction) child->dispatch_table.GetProgramParameterfvNV );
	__fillin( 218, "GetProgramStringARB", (SPUGenericFunction) child->dispatch_table.GetProgramStringARB );
	__fillin( 219, "GetProgramStringNV", (SPUGenericFunction) child->dispatch_table.GetProgramStringNV );
	__fillin( 220, "GetProgramiv", (SPUGenericFunction) child->dispatch_table.GetProgramiv );
	__fillin( 221, "GetProgramivARB", (SPUGenericFunction) child->dispatch_table.GetProgramivARB );
	__fillin( 222, "GetProgramivNV", (SPUGenericFunction) child->dispatch_table.GetProgramivNV );
	__fillin( 223, "GetQueryObjectivARB", (SPUGenericFunction) child->dispatch_table.GetQueryObjectivARB );
	__fillin( 224, "GetQueryObjectuivARB", (SPUGenericFunction) child->dispatch_table.GetQueryObjectuivARB );
	__fillin( 225, "GetQueryivARB", (SPUGenericFunction) child->dispatch_table.GetQueryivARB );
	__fillin( 226, "GetShaderInfoLog", (SPUGenericFunction) child->dispatch_table.GetShaderInfoLog );
	__fillin( 227, "GetShaderSource", (SPUGenericFunction) child->dispatch_table.GetShaderSource );
	__fillin( 228, "GetShaderiv", (SPUGenericFunction) child->dispatch_table.GetShaderiv );
	__fillin( 229, "GetString", (SPUGenericFunction) child->dispatch_table.GetString );
	__fillin( 230, "GetTexEnvfv", (SPUGenericFunction) child->dispatch_table.GetTexEnvfv );
	__fillin( 231, "GetTexEnviv", (SPUGenericFunction) child->dispatch_table.GetTexEnviv );
	__fillin( 232, "GetTexGendv", (SPUGenericFunction) child->dispatch_table.GetTexGendv );
	__fillin( 233, "GetTexGenfv", (SPUGenericFunction) child->dispatch_table.GetTexGenfv );
	__fillin( 234, "GetTexGeniv", (SPUGenericFunction) child->dispatch_table.GetTexGeniv );
	__fillin( 235, "GetTexImage", (SPUGenericFunction) child->dispatch_table.GetTexImage );
	__fillin( 236, "GetTexLevelParameterfv", (SPUGenericFunction) child->dispatch_table.GetTexLevelParameterfv );
	__fillin( 237, "GetTexLevelParameteriv", (SPUGenericFunction) child->dispatch_table.GetTexLevelParameteriv );
	__fillin( 238, "GetTexParameterfv", (SPUGenericFunction) child->dispatch_table.GetTexParameterfv );
	__fillin( 239, "GetTexParameteriv", (SPUGenericFunction) child->dispatch_table.GetTexParameteriv );
	__fillin( 240, "GetTrackMatrixivNV", (SPUGenericFunction) child->dispatch_table.GetTrackMatrixivNV );
	__fillin( 241, "GetUniformLocation", (SPUGenericFunction) child->dispatch_table.GetUniformLocation );
	__fillin( 242, "GetUniformfv", (SPUGenericFunction) child->dispatch_table.GetUniformfv );
	__fillin( 243, "GetUniformiv", (SPUGenericFunction) child->dispatch_table.GetUniformiv );
	__fillin( 244, "GetVertexAttribPointervARB", (SPUGenericFunction) child->dispatch_table.GetVertexAttribPointervARB );
	__fillin( 245, "GetVertexAttribPointervNV", (SPUGenericFunction) child->dispatch_table.GetVertexAttribPointervNV );
	__fillin( 246, "GetVertexAttribdvARB", (SPUGenericFunction) child->dispatch_table.GetVertexAttribdvARB );
	__fillin( 247, "GetVertexAttribdvNV", (SPUGenericFunction) child->dispatch_table.GetVertexAttribdvNV );
	__fillin( 248, "GetVertexAttribfvARB", (SPUGenericFunction) child->dispatch_table.GetVertexAttribfvARB );
	__fillin( 249, "GetVertexAttribfvNV", (SPUGenericFunction) child->dispatch_table.GetVertexAttribfvNV );
	__fillin( 250, "GetVertexAttribivARB", (SPUGenericFunction) child->dispatch_table.GetVertexAttribivARB );
	__fillin( 251, "GetVertexAttribivNV", (SPUGenericFunction) child->dispatch_table.GetVertexAttribivNV );
	__fillin( 252, "Hint", (SPUGenericFunction) child->dispatch_table.Hint );
	__fillin( 253, "IndexMask", (SPUGenericFunction) child->dispatch_table.IndexMask );
	__fillin( 254, "IndexPointer", (SPUGenericFunction) child->dispatch_table.IndexPointer );
	__fillin( 255, "Indexd", (SPUGenericFunction) child->dispatch_table.Indexd );
	__fillin( 256, "Indexdv", (SPUGenericFunction) child->dispatch_table.Indexdv );
	__fillin( 257, "Indexf", (SPUGenericFunction) child->dispatch_table.Indexf );
	__fillin( 258, "Indexfv", (SPUGenericFunction) child->dispatch_table.Indexfv );
	__fillin( 259, "Indexi", (SPUGenericFunction) child->dispatch_table.Indexi );
	__fillin( 260, "Indexiv", (SPUGenericFunction) child->dispatch_table.Indexiv );
	__fillin( 261, "Indexs", (SPUGenericFunction) child->dispatch_table.Indexs );
	__fillin( 262, "Indexsv", (SPUGenericFunction) child->dispatch_table.Indexsv );
	__fillin( 263, "Indexub", (SPUGenericFunction) child->dispatch_table.Indexub );
	__fillin( 264, "Indexubv", (SPUGenericFunction) child->dispatch_table.Indexubv );
	__fillin( 265, "InitNames", (SPUGenericFunction) child->dispatch_table.InitNames );
	__fillin( 266, "InterleavedArrays", (SPUGenericFunction) child->dispatch_table.InterleavedArrays );
	__fillin( 267, "IsBufferARB", (SPUGenericFunction) child->dispatch_table.IsBufferARB );
	__fillin( 268, "IsEnabled", (SPUGenericFunction) child->dispatch_table.IsEnabled );
	__fillin( 269, "IsFenceNV", (SPUGenericFunction) child->dispatch_table.IsFenceNV );
	__fillin( 270, "IsList", (SPUGenericFunction) child->dispatch_table.IsList );
	__fillin( 271, "IsProgram", (SPUGenericFunction) child->dispatch_table.IsProgram );
	__fillin( 272, "IsProgramARB", (SPUGenericFunction) child->dispatch_table.IsProgramARB );
	__fillin( 273, "IsQueryARB", (SPUGenericFunction) child->dispatch_table.IsQueryARB );
	__fillin( 274, "IsShader", (SPUGenericFunction) child->dispatch_table.IsShader );
	__fillin( 275, "IsTexture", (SPUGenericFunction) child->dispatch_table.IsTexture );
	__fillin( 276, "LightModelf", (SPUGenericFunction) child->dispatch_table.LightModelf );
	__fillin( 277, "LightModelfv", (SPUGenericFunction) child->dispatch_table.LightModelfv );
	__fillin( 278, "LightModeli", (SPUGenericFunction) child->dispatch_table.LightModeli );
	__fillin( 279, "LightModeliv", (SPUGenericFunction) child->dispatch_table.LightModeliv );
	__fillin( 280, "Lightf", (SPUGenericFunction) child->dispatch_table.Lightf );
	__fillin( 281, "Lightfv", (SPUGenericFunction) child->dispatch_table.Lightfv );
	__fillin( 282, "Lighti", (SPUGenericFunction) child->dispatch_table.Lighti );
	__fillin( 283, "Lightiv", (SPUGenericFunction) child->dispatch_table.Lightiv );
	__fillin( 284, "LineStipple", (SPUGenericFunction) child->dispatch_table.LineStipple );
	__fillin( 285, "LineWidth", (SPUGenericFunction) child->dispatch_table.LineWidth );
	__fillin( 286, "LinkProgram", (SPUGenericFunction) child->dispatch_table.LinkProgram );
	__fillin( 287, "ListBase", (SPUGenericFunction) child->dispatch_table.ListBase );
	__fillin( 288, "LoadIdentity", (SPUGenericFunction) child->dispatch_table.LoadIdentity );
	__fillin( 289, "LoadMatrixd", (SPUGenericFunction) child->dispatch_table.LoadMatrixd );
	__fillin( 290, "LoadMatrixf", (SPUGenericFunction) child->dispatch_table.LoadMatrixf );
	__fillin( 291, "LoadName", (SPUGenericFunction) child->dispatch_table.LoadName );
	__fillin( 292, "LoadProgramNV", (SPUGenericFunction) child->dispatch_table.LoadProgramNV );
	__fillin( 293, "LoadTransposeMatrixdARB", (SPUGenericFunction) child->dispatch_table.LoadTransposeMatrixdARB );
	__fillin( 294, "LoadTransposeMatrixfARB", (SPUGenericFunction) child->dispatch_table.LoadTransposeMatrixfARB );
	__fillin( 295, "LogicOp", (SPUGenericFunction) child->dispatch_table.LogicOp );
	__fillin( 296, "MakeCurrent", (SPUGenericFunction) child->dispatch_table.MakeCurrent );
	__fillin( 297, "Map1d", (SPUGenericFunction) child->dispatch_table.Map1d );
	__fillin( 298, "Map1f", (SPUGenericFunction) child->dispatch_table.Map1f );
	__fillin( 299, "Map2d", (SPUGenericFunction) child->dispatch_table.Map2d );
	__fillin( 300, "Map2f", (SPUGenericFunction) child->dispatch_table.Map2f );
	__fillin( 301, "MapBufferARB", (SPUGenericFunction) child->dispatch_table.MapBufferARB );
	__fillin( 302, "MapGrid1d", (SPUGenericFunction) child->dispatch_table.MapGrid1d );
	__fillin( 303, "MapGrid1f", (SPUGenericFunction) child->dispatch_table.MapGrid1f );
	__fillin( 304, "MapGrid2d", (SPUGenericFunction) child->dispatch_table.MapGrid2d );
	__fillin( 305, "MapGrid2f", (SPUGenericFunction) child->dispatch_table.MapGrid2f );
	__fillin( 306, "Materialf", (SPUGenericFunction) child->dispatch_table.Materialf );
	__fillin( 307, "Materialfv", (SPUGenericFunction) child->dispatch_table.Materialfv );
	__fillin( 308, "Materiali", (SPUGenericFunction) child->dispatch_table.Materiali );
	__fillin( 309, "Materialiv", (SPUGenericFunction) child->dispatch_table.Materialiv );
	__fillin( 310, "MatrixMode", (SPUGenericFunction) child->dispatch_table.MatrixMode );
	__fillin( 311, "MultMatrixd", (SPUGenericFunction) child->dispatch_table.MultMatrixd );
	__fillin( 312, "MultMatrixf", (SPUGenericFunction) child->dispatch_table.MultMatrixf );
	__fillin( 313, "MultTransposeMatrixdARB", (SPUGenericFunction) child->dispatch_table.MultTransposeMatrixdARB );
	__fillin( 314, "MultTransposeMatrixfARB", (SPUGenericFunction) child->dispatch_table.MultTransposeMatrixfARB );
	__fillin( 315, "MultiDrawArraysEXT", (SPUGenericFunction) child->dispatch_table.MultiDrawArraysEXT );
	__fillin( 316, "MultiDrawElementsEXT", (SPUGenericFunction) child->dispatch_table.MultiDrawElementsEXT );
	__fillin( 317, "MultiTexCoord1dARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1dARB );
	__fillin( 318, "MultiTexCoord1dvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1dvARB );
	__fillin( 319, "MultiTexCoord1fARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1fARB );
	__fillin( 320, "MultiTexCoord1fvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1fvARB );
	__fillin( 321, "MultiTexCoord1iARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1iARB );
	__fillin( 322, "MultiTexCoord1ivARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1ivARB );
	__fillin( 323, "MultiTexCoord1sARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1sARB );
	__fillin( 324, "MultiTexCoord1svARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord1svARB );
	__fillin( 325, "MultiTexCoord2dARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2dARB );
	__fillin( 326, "MultiTexCoord2dvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2dvARB );
	__fillin( 327, "MultiTexCoord2fARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2fARB );
	__fillin( 328, "MultiTexCoord2fvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2fvARB );
	__fillin( 329, "MultiTexCoord2iARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2iARB );
	__fillin( 330, "MultiTexCoord2ivARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2ivARB );
	__fillin( 331, "MultiTexCoord2sARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2sARB );
	__fillin( 332, "MultiTexCoord2svARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord2svARB );
	__fillin( 333, "MultiTexCoord3dARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3dARB );
	__fillin( 334, "MultiTexCoord3dvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3dvARB );
	__fillin( 335, "MultiTexCoord3fARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3fARB );
	__fillin( 336, "MultiTexCoord3fvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3fvARB );
	__fillin( 337, "MultiTexCoord3iARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3iARB );
	__fillin( 338, "MultiTexCoord3ivARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3ivARB );
	__fillin( 339, "MultiTexCoord3sARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3sARB );
	__fillin( 340, "MultiTexCoord3svARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord3svARB );
	__fillin( 341, "MultiTexCoord4dARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4dARB );
	__fillin( 342, "MultiTexCoord4dvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4dvARB );
	__fillin( 343, "MultiTexCoord4fARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4fARB );
	__fillin( 344, "MultiTexCoord4fvARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4fvARB );
	__fillin( 345, "MultiTexCoord4iARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4iARB );
	__fillin( 346, "MultiTexCoord4ivARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4ivARB );
	__fillin( 347, "MultiTexCoord4sARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4sARB );
	__fillin( 348, "MultiTexCoord4svARB", (SPUGenericFunction) child->dispatch_table.MultiTexCoord4svARB );
	__fillin( 349, "NewList", (SPUGenericFunction) child->dispatch_table.NewList );
	__fillin( 350, "Normal3b", (SPUGenericFunction) child->dispatch_table.Normal3b );
	__fillin( 351, "Normal3bv", (SPUGenericFunction) child->dispatch_table.Normal3bv );
	__fillin( 352, "Normal3d", (SPUGenericFunction) child->dispatch_table.Normal3d );
	__fillin( 353, "Normal3dv", (SPUGenericFunction) child->dispatch_table.Normal3dv );
	__fillin( 354, "Normal3f", (SPUGenericFunction) child->dispatch_table.Normal3f );
	__fillin( 355, "Normal3fv", (SPUGenericFunction) child->dispatch_table.Normal3fv );
	__fillin( 356, "Normal3i", (SPUGenericFunction) child->dispatch_table.Normal3i );
	__fillin( 357, "Normal3iv", (SPUGenericFunction) child->dispatch_table.Normal3iv );
	__fillin( 358, "Normal3s", (SPUGenericFunction) child->dispatch_table.Normal3s );
	__fillin( 359, "Normal3sv", (SPUGenericFunction) child->dispatch_table.Normal3sv );
	__fillin( 360, "NormalPointer", (SPUGenericFunction) child->dispatch_table.NormalPointer );
	__fillin( 361, "Ortho", (SPUGenericFunction) child->dispatch_table.Ortho );
	__fillin( 362, "PassThrough", (SPUGenericFunction) child->dispatch_table.PassThrough );
	__fillin( 363, "PixelMapfv", (SPUGenericFunction) child->dispatch_table.PixelMapfv );
	__fillin( 364, "PixelMapuiv", (SPUGenericFunction) child->dispatch_table.PixelMapuiv );
	__fillin( 365, "PixelMapusv", (SPUGenericFunction) child->dispatch_table.PixelMapusv );
	__fillin( 366, "PixelStoref", (SPUGenericFunction) child->dispatch_table.PixelStoref );
	__fillin( 367, "PixelStorei", (SPUGenericFunction) child->dispatch_table.PixelStorei );
	__fillin( 368, "PixelTransferf", (SPUGenericFunction) child->dispatch_table.PixelTransferf );
	__fillin( 369, "PixelTransferi", (SPUGenericFunction) child->dispatch_table.PixelTransferi );
	__fillin( 370, "PixelZoom", (SPUGenericFunction) child->dispatch_table.PixelZoom );
	__fillin( 371, "PointParameterfARB", (SPUGenericFunction) child->dispatch_table.PointParameterfARB );
	__fillin( 372, "PointParameterfvARB", (SPUGenericFunction) child->dispatch_table.PointParameterfvARB );
	__fillin( 373, "PointParameteri", (SPUGenericFunction) child->dispatch_table.PointParameteri );
	__fillin( 374, "PointParameteriv", (SPUGenericFunction) child->dispatch_table.PointParameteriv );
	__fillin( 375, "PointSize", (SPUGenericFunction) child->dispatch_table.PointSize );
	__fillin( 376, "PolygonMode", (SPUGenericFunction) child->dispatch_table.PolygonMode );
	__fillin( 377, "PolygonOffset", (SPUGenericFunction) child->dispatch_table.PolygonOffset );
	__fillin( 378, "PolygonStipple", (SPUGenericFunction) child->dispatch_table.PolygonStipple );
	__fillin( 379, "PopAttrib", (SPUGenericFunction) child->dispatch_table.PopAttrib );
	__fillin( 380, "PopClientAttrib", (SPUGenericFunction) child->dispatch_table.PopClientAttrib );
	__fillin( 381, "PopMatrix", (SPUGenericFunction) child->dispatch_table.PopMatrix );
	__fillin( 382, "PopName", (SPUGenericFunction) child->dispatch_table.PopName );
	__fillin( 383, "PrioritizeTextures", (SPUGenericFunction) child->dispatch_table.PrioritizeTextures );
	__fillin( 384, "ProgramEnvParameter4dARB", (SPUGenericFunction) child->dispatch_table.ProgramEnvParameter4dARB );
	__fillin( 385, "ProgramEnvParameter4dvARB", (SPUGenericFunction) child->dispatch_table.ProgramEnvParameter4dvARB );
	__fillin( 386, "ProgramEnvParameter4fARB", (SPUGenericFunction) child->dispatch_table.ProgramEnvParameter4fARB );
	__fillin( 387, "ProgramEnvParameter4fvARB", (SPUGenericFunction) child->dispatch_table.ProgramEnvParameter4fvARB );
	__fillin( 388, "ProgramLocalParameter4dARB", (SPUGenericFunction) child->dispatch_table.ProgramLocalParameter4dARB );
	__fillin( 389, "ProgramLocalParameter4dvARB", (SPUGenericFunction) child->dispatch_table.ProgramLocalParameter4dvARB );
	__fillin( 390, "ProgramLocalParameter4fARB", (SPUGenericFunction) child->dispatch_table.ProgramLocalParameter4fARB );
	__fillin( 391, "ProgramLocalParameter4fvARB", (SPUGenericFunction) child->dispatch_table.ProgramLocalParameter4fvARB );
	__fillin( 392, "ProgramNamedParameter4dNV", (SPUGenericFunction) child->dispatch_table.ProgramNamedParameter4dNV );
	__fillin( 393, "ProgramNamedParameter4dvNV", (SPUGenericFunction) child->dispatch_table.ProgramNamedParameter4dvNV );
	__fillin( 394, "ProgramNamedParameter4fNV", (SPUGenericFunction) child->dispatch_table.ProgramNamedParameter4fNV );
	__fillin( 395, "ProgramNamedParameter4fvNV", (SPUGenericFunction) child->dispatch_table.ProgramNamedParameter4fvNV );
	__fillin( 396, "ProgramParameter4dNV", (SPUGenericFunction) child->dispatch_table.ProgramParameter4dNV );
	__fillin( 397, "ProgramParameter4dvNV", (SPUGenericFunction) child->dispatch_table.ProgramParameter4dvNV );
	__fillin( 398, "ProgramParameter4fNV", (SPUGenericFunction) child->dispatch_table.ProgramParameter4fNV );
	__fillin( 399, "ProgramParameter4fvNV", (SPUGenericFunction) child->dispatch_table.ProgramParameter4fvNV );
	__fillin( 400, "ProgramParameters4dvNV", (SPUGenericFunction) child->dispatch_table.ProgramParameters4dvNV );
	__fillin( 401, "ProgramParameters4fvNV", (SPUGenericFunction) child->dispatch_table.ProgramParameters4fvNV );
	__fillin( 402, "ProgramStringARB", (SPUGenericFunction) child->dispatch_table.ProgramStringARB );
	__fillin( 403, "PushAttrib", (SPUGenericFunction) child->dispatch_table.PushAttrib );
	__fillin( 404, "PushClientAttrib", (SPUGenericFunction) child->dispatch_table.PushClientAttrib );
	__fillin( 405, "PushMatrix", (SPUGenericFunction) child->dispatch_table.PushMatrix );
	__fillin( 406, "PushName", (SPUGenericFunction) child->dispatch_table.PushName );
	__fillin( 407, "RasterPos2d", (SPUGenericFunction) child->dispatch_table.RasterPos2d );
	__fillin( 408, "RasterPos2dv", (SPUGenericFunction) child->dispatch_table.RasterPos2dv );
	__fillin( 409, "RasterPos2f", (SPUGenericFunction) child->dispatch_table.RasterPos2f );
	__fillin( 410, "RasterPos2fv", (SPUGenericFunction) child->dispatch_table.RasterPos2fv );
	__fillin( 411, "RasterPos2i", (SPUGenericFunction) child->dispatch_table.RasterPos2i );
	__fillin( 412, "RasterPos2iv", (SPUGenericFunction) child->dispatch_table.RasterPos2iv );
	__fillin( 413, "RasterPos2s", (SPUGenericFunction) child->dispatch_table.RasterPos2s );
	__fillin( 414, "RasterPos2sv", (SPUGenericFunction) child->dispatch_table.RasterPos2sv );
	__fillin( 415, "RasterPos3d", (SPUGenericFunction) child->dispatch_table.RasterPos3d );
	__fillin( 416, "RasterPos3dv", (SPUGenericFunction) child->dispatch_table.RasterPos3dv );
	__fillin( 417, "RasterPos3f", (SPUGenericFunction) child->dispatch_table.RasterPos3f );
	__fillin( 418, "RasterPos3fv", (SPUGenericFunction) child->dispatch_table.RasterPos3fv );
	__fillin( 419, "RasterPos3i", (SPUGenericFunction) child->dispatch_table.RasterPos3i );
	__fillin( 420, "RasterPos3iv", (SPUGenericFunction) child->dispatch_table.RasterPos3iv );
	__fillin( 421, "RasterPos3s", (SPUGenericFunction) child->dispatch_table.RasterPos3s );
	__fillin( 422, "RasterPos3sv", (SPUGenericFunction) child->dispatch_table.RasterPos3sv );
	__fillin( 423, "RasterPos4d", (SPUGenericFunction) child->dispatch_table.RasterPos4d );
	__fillin( 424, "RasterPos4dv", (SPUGenericFunction) child->dispatch_table.RasterPos4dv );
	__fillin( 425, "RasterPos4f", (SPUGenericFunction) child->dispatch_table.RasterPos4f );
	__fillin( 426, "RasterPos4fv", (SPUGenericFunction) child->dispatch_table.RasterPos4fv );
	__fillin( 427, "RasterPos4i", (SPUGenericFunction) child->dispatch_table.RasterPos4i );
	__fillin( 428, "RasterPos4iv", (SPUGenericFunction) child->dispatch_table.RasterPos4iv );
	__fillin( 429, "RasterPos4s", (SPUGenericFunction) child->dispatch_table.RasterPos4s );
	__fillin( 430, "RasterPos4sv", (SPUGenericFunction) child->dispatch_table.RasterPos4sv );
	__fillin( 431, "ReadBuffer", (SPUGenericFunction) child->dispatch_table.ReadBuffer );
	__fillin( 432, "ReadPixels", (SPUGenericFunction) child->dispatch_table.ReadPixels );
	__fillin( 433, "Rectd", (SPUGenericFunction) child->dispatch_table.Rectd );
	__fillin( 434, "Rectdv", (SPUGenericFunction) child->dispatch_table.Rectdv );
	__fillin( 435, "Rectf", (SPUGenericFunction) child->dispatch_table.Rectf );
	__fillin( 436, "Rectfv", (SPUGenericFunction) child->dispatch_table.Rectfv );
	__fillin( 437, "Recti", (SPUGenericFunction) child->dispatch_table.Recti );
	__fillin( 438, "Rectiv", (SPUGenericFunction) child->dispatch_table.Rectiv );
	__fillin( 439, "Rects", (SPUGenericFunction) child->dispatch_table.Rects );
	__fillin( 440, "Rectsv", (SPUGenericFunction) child->dispatch_table.Rectsv );
	__fillin( 441, "RenderMode", (SPUGenericFunction) child->dispatch_table.RenderMode );
	__fillin( 442, "RequestResidentProgramsNV", (SPUGenericFunction) child->dispatch_table.RequestResidentProgramsNV );
	__fillin( 443, "Rotated", (SPUGenericFunction) child->dispatch_table.Rotated );
	__fillin( 444, "Rotatef", (SPUGenericFunction) child->dispatch_table.Rotatef );
	__fillin( 445, "SampleCoverageARB", (SPUGenericFunction) child->dispatch_table.SampleCoverageARB );
	__fillin( 446, "Scaled", (SPUGenericFunction) child->dispatch_table.Scaled );
	__fillin( 447, "Scalef", (SPUGenericFunction) child->dispatch_table.Scalef );
	__fillin( 448, "Scissor", (SPUGenericFunction) child->dispatch_table.Scissor );
	__fillin( 449, "SecondaryColor3bEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3bEXT );
	__fillin( 450, "SecondaryColor3bvEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3bvEXT );
	__fillin( 451, "SecondaryColor3dEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3dEXT );
	__fillin( 452, "SecondaryColor3dvEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3dvEXT );
	__fillin( 453, "SecondaryColor3fEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3fEXT );
	__fillin( 454, "SecondaryColor3fvEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3fvEXT );
	__fillin( 455, "SecondaryColor3iEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3iEXT );
	__fillin( 456, "SecondaryColor3ivEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3ivEXT );
	__fillin( 457, "SecondaryColor3sEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3sEXT );
	__fillin( 458, "SecondaryColor3svEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3svEXT );
	__fillin( 459, "SecondaryColor3ubEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3ubEXT );
	__fillin( 460, "SecondaryColor3ubvEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3ubvEXT );
	__fillin( 461, "SecondaryColor3uiEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3uiEXT );
	__fillin( 462, "SecondaryColor3uivEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3uivEXT );
	__fillin( 463, "SecondaryColor3usEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3usEXT );
	__fillin( 464, "SecondaryColor3usvEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColor3usvEXT );
	__fillin( 465, "SecondaryColorPointerEXT", (SPUGenericFunction) child->dispatch_table.SecondaryColorPointerEXT );
	__fillin( 466, "SelectBuffer", (SPUGenericFunction) child->dispatch_table.SelectBuffer );
	__fillin( 467, "SemaphoreCreateCR", (SPUGenericFunction) child->dispatch_table.SemaphoreCreateCR );
	__fillin( 468, "SemaphoreDestroyCR", (SPUGenericFunction) child->dispatch_table.SemaphoreDestroyCR );
	__fillin( 469, "SemaphorePCR", (SPUGenericFunction) child->dispatch_table.SemaphorePCR );
	__fillin( 470, "SemaphoreVCR", (SPUGenericFunction) child->dispatch_table.SemaphoreVCR );
	__fillin( 471, "SetFenceNV", (SPUGenericFunction) child->dispatch_table.SetFenceNV );
	__fillin( 472, "ShadeModel", (SPUGenericFunction) child->dispatch_table.ShadeModel );
	__fillin( 473, "ShaderSource", (SPUGenericFunction) child->dispatch_table.ShaderSource );
	__fillin( 474, "StencilFunc", (SPUGenericFunction) child->dispatch_table.StencilFunc );
	__fillin( 475, "StencilFuncSeparate", (SPUGenericFunction) child->dispatch_table.StencilFuncSeparate );
	__fillin( 476, "StencilMask", (SPUGenericFunction) child->dispatch_table.StencilMask );
	__fillin( 477, "StencilMaskSeparate", (SPUGenericFunction) child->dispatch_table.StencilMaskSeparate );
	__fillin( 478, "StencilOp", (SPUGenericFunction) child->dispatch_table.StencilOp );
	__fillin( 479, "StencilOpSeparate", (SPUGenericFunction) child->dispatch_table.StencilOpSeparate );
	__fillin( 480, "SwapBuffers", (SPUGenericFunction) child->dispatch_table.SwapBuffers );
	__fillin( 481, "TestFenceNV", (SPUGenericFunction) child->dispatch_table.TestFenceNV );
	__fillin( 482, "TexCoord1d", (SPUGenericFunction) child->dispatch_table.TexCoord1d );
	__fillin( 483, "TexCoord1dv", (SPUGenericFunction) child->dispatch_table.TexCoord1dv );
	__fillin( 484, "TexCoord1f", (SPUGenericFunction) child->dispatch_table.TexCoord1f );
	__fillin( 485, "TexCoord1fv", (SPUGenericFunction) child->dispatch_table.TexCoord1fv );
	__fillin( 486, "TexCoord1i", (SPUGenericFunction) child->dispatch_table.TexCoord1i );
	__fillin( 487, "TexCoord1iv", (SPUGenericFunction) child->dispatch_table.TexCoord1iv );
	__fillin( 488, "TexCoord1s", (SPUGenericFunction) child->dispatch_table.TexCoord1s );
	__fillin( 489, "TexCoord1sv", (SPUGenericFunction) child->dispatch_table.TexCoord1sv );
	__fillin( 490, "TexCoord2d", (SPUGenericFunction) child->dispatch_table.TexCoord2d );
	__fillin( 491, "TexCoord2dv", (SPUGenericFunction) child->dispatch_table.TexCoord2dv );
	__fillin( 492, "TexCoord2f", (SPUGenericFunction) child->dispatch_table.TexCoord2f );
	__fillin( 493, "TexCoord2fv", (SPUGenericFunction) child->dispatch_table.TexCoord2fv );
	__fillin( 494, "TexCoord2i", (SPUGenericFunction) child->dispatch_table.TexCoord2i );
	__fillin( 495, "TexCoord2iv", (SPUGenericFunction) child->dispatch_table.TexCoord2iv );
	__fillin( 496, "TexCoord2s", (SPUGenericFunction) child->dispatch_table.TexCoord2s );
	__fillin( 497, "TexCoord2sv", (SPUGenericFunction) child->dispatch_table.TexCoord2sv );
	__fillin( 498, "TexCoord3d", (SPUGenericFunction) child->dispatch_table.TexCoord3d );
	__fillin( 499, "TexCoord3dv", (SPUGenericFunction) child->dispatch_table.TexCoord3dv );
	__fillin( 500, "TexCoord3f", (SPUGenericFunction) child->dispatch_table.TexCoord3f );
	__fillin( 501, "TexCoord3fv", (SPUGenericFunction) child->dispatch_table.TexCoord3fv );
	__fillin( 502, "TexCoord3i", (SPUGenericFunction) child->dispatch_table.TexCoord3i );
	__fillin( 503, "TexCoord3iv", (SPUGenericFunction) child->dispatch_table.TexCoord3iv );
	__fillin( 504, "TexCoord3s", (SPUGenericFunction) child->dispatch_table.TexCoord3s );
	__fillin( 505, "TexCoord3sv", (SPUGenericFunction) child->dispatch_table.TexCoord3sv );
	__fillin( 506, "TexCoord4d", (SPUGenericFunction) child->dispatch_table.TexCoord4d );
	__fillin( 507, "TexCoord4dv", (SPUGenericFunction) child->dispatch_table.TexCoord4dv );
	__fillin( 508, "TexCoord4f", (SPUGenericFunction) child->dispatch_table.TexCoord4f );
	__fillin( 509, "TexCoord4fv", (SPUGenericFunction) child->dispatch_table.TexCoord4fv );
	__fillin( 510, "TexCoord4i", (SPUGenericFunction) child->dispatch_table.TexCoord4i );
	__fillin( 511, "TexCoord4iv", (SPUGenericFunction) child->dispatch_table.TexCoord4iv );
	__fillin( 512, "TexCoord4s", (SPUGenericFunction) child->dispatch_table.TexCoord4s );
	__fillin( 513, "TexCoord4sv", (SPUGenericFunction) child->dispatch_table.TexCoord4sv );
	__fillin( 514, "TexCoordPointer", (SPUGenericFunction) child->dispatch_table.TexCoordPointer );
	__fillin( 515, "TexEnvf", (SPUGenericFunction) child->dispatch_table.TexEnvf );
	__fillin( 516, "TexEnvfv", (SPUGenericFunction) child->dispatch_table.TexEnvfv );
	__fillin( 517, "TexEnvi", (SPUGenericFunction) child->dispatch_table.TexEnvi );
	__fillin( 518, "TexEnviv", (SPUGenericFunction) child->dispatch_table.TexEnviv );
	__fillin( 519, "TexGend", (SPUGenericFunction) child->dispatch_table.TexGend );
	__fillin( 520, "TexGendv", (SPUGenericFunction) child->dispatch_table.TexGendv );
	__fillin( 521, "TexGenf", (SPUGenericFunction) child->dispatch_table.TexGenf );
	__fillin( 522, "TexGenfv", (SPUGenericFunction) child->dispatch_table.TexGenfv );
	__fillin( 523, "TexGeni", (SPUGenericFunction) child->dispatch_table.TexGeni );
	__fillin( 524, "TexGeniv", (SPUGenericFunction) child->dispatch_table.TexGeniv );
	__fillin( 525, "TexImage1D", (SPUGenericFunction) child->dispatch_table.TexImage1D );
	__fillin( 526, "TexImage2D", (SPUGenericFunction) child->dispatch_table.TexImage2D );
	__fillin( 527, "TexImage3D", (SPUGenericFunction) child->dispatch_table.TexImage3D );
	__fillin( 528, "TexImage3DEXT", (SPUGenericFunction) child->dispatch_table.TexImage3DEXT );
	__fillin( 529, "TexParameterf", (SPUGenericFunction) child->dispatch_table.TexParameterf );
	__fillin( 530, "TexParameterfv", (SPUGenericFunction) child->dispatch_table.TexParameterfv );
	__fillin( 531, "TexParameteri", (SPUGenericFunction) child->dispatch_table.TexParameteri );
	__fillin( 532, "TexParameteriv", (SPUGenericFunction) child->dispatch_table.TexParameteriv );
	__fillin( 533, "TexSubImage1D", (SPUGenericFunction) child->dispatch_table.TexSubImage1D );
	__fillin( 534, "TexSubImage2D", (SPUGenericFunction) child->dispatch_table.TexSubImage2D );
	__fillin( 535, "TexSubImage3D", (SPUGenericFunction) child->dispatch_table.TexSubImage3D );
	__fillin( 536, "TrackMatrixNV", (SPUGenericFunction) child->dispatch_table.TrackMatrixNV );
	__fillin( 537, "Translated", (SPUGenericFunction) child->dispatch_table.Translated );
	__fillin( 538, "Translatef", (SPUGenericFunction) child->dispatch_table.Translatef );
	__fillin( 539, "Uniform1f", (SPUGenericFunction) child->dispatch_table.Uniform1f );
	__fillin( 540, "Uniform1fv", (SPUGenericFunction) child->dispatch_table.Uniform1fv );
	__fillin( 541, "Uniform1i", (SPUGenericFunction) child->dispatch_table.Uniform1i );
	__fillin( 542, "Uniform1iv", (SPUGenericFunction) child->dispatch_table.Uniform1iv );
	__fillin( 543, "Uniform2f", (SPUGenericFunction) child->dispatch_table.Uniform2f );
	__fillin( 544, "Uniform2fv", (SPUGenericFunction) child->dispatch_table.Uniform2fv );
	__fillin( 545, "Uniform2i", (SPUGenericFunction) child->dispatch_table.Uniform2i );
	__fillin( 546, "Uniform2iv", (SPUGenericFunction) child->dispatch_table.Uniform2iv );
	__fillin( 547, "Uniform3f", (SPUGenericFunction) child->dispatch_table.Uniform3f );
	__fillin( 548, "Uniform3fv", (SPUGenericFunction) child->dispatch_table.Uniform3fv );
	__fillin( 549, "Uniform3i", (SPUGenericFunction) child->dispatch_table.Uniform3i );
	__fillin( 550, "Uniform3iv", (SPUGenericFunction) child->dispatch_table.Uniform3iv );
	__fillin( 551, "Uniform4f", (SPUGenericFunction) child->dispatch_table.Uniform4f );
	__fillin( 552, "Uniform4fv", (SPUGenericFunction) child->dispatch_table.Uniform4fv );
	__fillin( 553, "Uniform4i", (SPUGenericFunction) child->dispatch_table.Uniform4i );
	__fillin( 554, "Uniform4iv", (SPUGenericFunction) child->dispatch_table.Uniform4iv );
	__fillin( 555, "UniformMatrix2fv", (SPUGenericFunction) child->dispatch_table.UniformMatrix2fv );
	__fillin( 556, "UniformMatrix3fv", (SPUGenericFunction) child->dispatch_table.UniformMatrix3fv );
	__fillin( 557, "UniformMatrix4fv", (SPUGenericFunction) child->dispatch_table.UniformMatrix4fv );
	__fillin( 558, "UnmapBufferARB", (SPUGenericFunction) child->dispatch_table.UnmapBufferARB );
	__fillin( 559, "UseProgram", (SPUGenericFunction) child->dispatch_table.UseProgram );
	__fillin( 560, "ValidateProgram", (SPUGenericFunction) child->dispatch_table.ValidateProgram );
	__fillin( 561, "Vertex2d", (SPUGenericFunction) child->dispatch_table.Vertex2d );
	__fillin( 562, "Vertex2dv", (SPUGenericFunction) child->dispatch_table.Vertex2dv );
	__fillin( 563, "Vertex2f", (SPUGenericFunction) child->dispatch_table.Vertex2f );
	__fillin( 564, "Vertex2fv", (SPUGenericFunction) child->dispatch_table.Vertex2fv );
	__fillin( 565, "Vertex2i", (SPUGenericFunction) child->dispatch_table.Vertex2i );
	__fillin( 566, "Vertex2iv", (SPUGenericFunction) child->dispatch_table.Vertex2iv );
	__fillin( 567, "Vertex2s", (SPUGenericFunction) child->dispatch_table.Vertex2s );
	__fillin( 568, "Vertex2sv", (SPUGenericFunction) child->dispatch_table.Vertex2sv );
	__fillin( 569, "Vertex3d", (SPUGenericFunction) child->dispatch_table.Vertex3d );
	__fillin( 570, "Vertex3dv", (SPUGenericFunction) child->dispatch_table.Vertex3dv );
	__fillin( 571, "Vertex3f", (SPUGenericFunction) child->dispatch_table.Vertex3f );
	__fillin( 572, "Vertex3fv", (SPUGenericFunction) child->dispatch_table.Vertex3fv );
	__fillin( 573, "Vertex3i", (SPUGenericFunction) child->dispatch_table.Vertex3i );
	__fillin( 574, "Vertex3iv", (SPUGenericFunction) child->dispatch_table.Vertex3iv );
	__fillin( 575, "Vertex3s", (SPUGenericFunction) child->dispatch_table.Vertex3s );
	__fillin( 576, "Vertex3sv", (SPUGenericFunction) child->dispatch_table.Vertex3sv );
	__fillin( 577, "Vertex4d", (SPUGenericFunction) child->dispatch_table.Vertex4d );
	__fillin( 578, "Vertex4dv", (SPUGenericFunction) child->dispatch_table.Vertex4dv );
	__fillin( 579, "Vertex4f", (SPUGenericFunction) child->dispatch_table.Vertex4f );
	__fillin( 580, "Vertex4fv", (SPUGenericFunction) child->dispatch_table.Vertex4fv );
	__fillin( 581, "Vertex4i", (SPUGenericFunction) child->dispatch_table.Vertex4i );
	__fillin( 582, "Vertex4iv", (SPUGenericFunction) child->dispatch_table.Vertex4iv );
	__fillin( 583, "Vertex4s", (SPUGenericFunction) child->dispatch_table.Vertex4s );
	__fillin( 584, "Vertex4sv", (SPUGenericFunction) child->dispatch_table.Vertex4sv );
	__fillin( 585, "VertexArrayRangeNV", (SPUGenericFunction) child->dispatch_table.VertexArrayRangeNV );
	__fillin( 586, "VertexAttrib1dARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib1dARB );
	__fillin( 587, "VertexAttrib1dvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib1dvARB );
	__fillin( 588, "VertexAttrib1fARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib1fARB );
	__fillin( 589, "VertexAttrib1fvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib1fvARB );
	__fillin( 590, "VertexAttrib1sARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib1sARB );
	__fillin( 591, "VertexAttrib1svARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib1svARB );
	__fillin( 592, "VertexAttrib2dARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib2dARB );
	__fillin( 593, "VertexAttrib2dvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib2dvARB );
	__fillin( 594, "VertexAttrib2fARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib2fARB );
	__fillin( 595, "VertexAttrib2fvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib2fvARB );
	__fillin( 596, "VertexAttrib2sARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib2sARB );
	__fillin( 597, "VertexAttrib2svARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib2svARB );
	__fillin( 598, "VertexAttrib3dARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib3dARB );
	__fillin( 599, "VertexAttrib3dvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib3dvARB );
	__fillin( 600, "VertexAttrib3fARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib3fARB );
	__fillin( 601, "VertexAttrib3fvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib3fvARB );
	__fillin( 602, "VertexAttrib3sARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib3sARB );
	__fillin( 603, "VertexAttrib3svARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib3svARB );
	__fillin( 604, "VertexAttrib4NbvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NbvARB );
	__fillin( 605, "VertexAttrib4NivARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NivARB );
	__fillin( 606, "VertexAttrib4NsvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NsvARB );
	__fillin( 607, "VertexAttrib4NubARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NubARB );
	__fillin( 608, "VertexAttrib4NubvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NubvARB );
	__fillin( 609, "VertexAttrib4NuivARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NuivARB );
	__fillin( 610, "VertexAttrib4NusvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4NusvARB );
	__fillin( 611, "VertexAttrib4bvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4bvARB );
	__fillin( 612, "VertexAttrib4dARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4dARB );
	__fillin( 613, "VertexAttrib4dvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4dvARB );
	__fillin( 614, "VertexAttrib4fARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4fARB );
	__fillin( 615, "VertexAttrib4fvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4fvARB );
	__fillin( 616, "VertexAttrib4ivARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4ivARB );
	__fillin( 617, "VertexAttrib4sARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4sARB );
	__fillin( 618, "VertexAttrib4svARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4svARB );
	__fillin( 619, "VertexAttrib4ubvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4ubvARB );
	__fillin( 620, "VertexAttrib4uivARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4uivARB );
	__fillin( 621, "VertexAttrib4usvARB", (SPUGenericFunction) child->dispatch_table.VertexAttrib4usvARB );
	__fillin( 622, "VertexAttribPointerARB", (SPUGenericFunction) child->dispatch_table.VertexAttribPointerARB );
	__fillin( 623, "VertexAttribPointerNV", (SPUGenericFunction) child->dispatch_table.VertexAttribPointerNV );
	__fillin( 624, "VertexAttribs1dvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs1dvNV );
	__fillin( 625, "VertexAttribs1fvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs1fvNV );
	__fillin( 626, "VertexAttribs1svNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs1svNV );
	__fillin( 627, "VertexAttribs2dvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs2dvNV );
	__fillin( 628, "VertexAttribs2fvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs2fvNV );
	__fillin( 629, "VertexAttribs2svNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs2svNV );
	__fillin( 630, "VertexAttribs3dvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs3dvNV );
	__fillin( 631, "VertexAttribs3fvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs3fvNV );
	__fillin( 632, "VertexAttribs3svNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs3svNV );
	__fillin( 633, "VertexAttribs4dvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs4dvNV );
	__fillin( 634, "VertexAttribs4fvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs4fvNV );
	__fillin( 635, "VertexAttribs4svNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs4svNV );
	__fillin( 636, "VertexAttribs4ubvNV", (SPUGenericFunction) child->dispatch_table.VertexAttribs4ubvNV );
	__fillin( 637, "VertexPointer", (SPUGenericFunction) child->dispatch_table.VertexPointer );
	__fillin( 638, "Viewport", (SPUGenericFunction) child->dispatch_table.Viewport );
	__fillin( 639, "WindowCreate", (SPUGenericFunction) child->dispatch_table.WindowCreate );
	__fillin( 640, "WindowDestroy", (SPUGenericFunction) child->dispatch_table.WindowDestroy );
	__fillin( 641, "WindowPos2dARB", (SPUGenericFunction) child->dispatch_table.WindowPos2dARB );
	__fillin( 642, "WindowPos2dvARB", (SPUGenericFunction) child->dispatch_table.WindowPos2dvARB );
	__fillin( 643, "WindowPos2fARB", (SPUGenericFunction) child->dispatch_table.WindowPos2fARB );
	__fillin( 644, "WindowPos2fvARB", (SPUGenericFunction) child->dispatch_table.WindowPos2fvARB );
	__fillin( 645, "WindowPos2iARB", (SPUGenericFunction) child->dispatch_table.WindowPos2iARB );
	__fillin( 646, "WindowPos2ivARB", (SPUGenericFunction) child->dispatch_table.WindowPos2ivARB );
	__fillin( 647, "WindowPos2sARB", (SPUGenericFunction) child->dispatch_table.WindowPos2sARB );
	__fillin( 648, "WindowPos2svARB", (SPUGenericFunction) child->dispatch_table.WindowPos2svARB );
	__fillin( 649, "WindowPos3dARB", (SPUGenericFunction) child->dispatch_table.WindowPos3dARB );
	__fillin( 650, "WindowPos3dvARB", (SPUGenericFunction) child->dispatch_table.WindowPos3dvARB );
	__fillin( 651, "WindowPos3fARB", (SPUGenericFunction) child->dispatch_table.WindowPos3fARB );
	__fillin( 652, "WindowPos3fvARB", (SPUGenericFunction) child->dispatch_table.WindowPos3fvARB );
	__fillin( 653, "WindowPos3iARB", (SPUGenericFunction) child->dispatch_table.WindowPos3iARB );
	__fillin( 654, "WindowPos3ivARB", (SPUGenericFunction) child->dispatch_table.WindowPos3ivARB );
	__fillin( 655, "WindowPos3sARB", (SPUGenericFunction) child->dispatch_table.WindowPos3sARB );
	__fillin( 656, "WindowPos3svARB", (SPUGenericFunction) child->dispatch_table.WindowPos3svARB );
	__fillin( 657, "WindowPosition", (SPUGenericFunction) child->dispatch_table.WindowPosition );
	__fillin( 658, "WindowShow", (SPUGenericFunction) child->dispatch_table.WindowShow );
	__fillin( 659, "WindowSize", (SPUGenericFunction) child->dispatch_table.WindowSize );
	__fillin( 660, "WindowVisibleRegion", (SPUGenericFunction) child->dispatch_table.WindowVisibleRegion );
	__fillin( 661, "Writeback", (SPUGenericFunction) child->dispatch_table.Writeback );
	__fillin( 662, "ZPixCR", (SPUGenericFunction) child->dispatch_table.ZPixCR );
	__fillin( 663, NULL, NULL );
}
