/* This code is AUTOGENERATED!!! */

#include "state.h"
#include "state_internals.h"

void crStateViewportDiff(CRViewportBits *b, CRbitvalue *bitID,
		CRContext *fromCtx, CRContext *toCtx)
{
	CRViewportState *from = &(fromCtx->viewport);
	CRViewportState *to = &(toCtx->viewport);
	unsigned int j, i;
	CRbitvalue nbitID[CR_MAX_BITARRAY];
	for (j=0;j<CR_MAX_BITARRAY;j++)
		nbitID[j] = ~bitID[j];
	i = 0; /* silence compiler */
	if (CHECKDIRTY(b->enable, bitID))
	{
		glAble able[2];
		able[0] = diff_api.Disable;
		able[1] = diff_api.Enable;
		if (from->scissorTest != to->scissorTest)
		{
			able[to->scissorTest](GL_SCISSOR_TEST);
			from->scissorTest = to->scissorTest;
		}
		CLEARDIRTY(b->enable, nbitID);
	}
	if (CHECKDIRTY(b->s_dims, bitID))
	{
		if (from->scissorX != to->scissorX ||
		    from->scissorY != to->scissorY ||
		    from->scissorW != to->scissorW ||
		    from->scissorH != to->scissorH)
		{
			diff_api.Scissor (to->scissorX,
			    to->scissorY,
			    to->scissorW,
			    to->scissorH);
			from->scissorX = to->scissorX;
			from->scissorY = to->scissorY;
			from->scissorW = to->scissorW;
			from->scissorH = to->scissorH;
		}
		CLEARDIRTY(b->s_dims, nbitID);
	}
	if (CHECKDIRTY(b->v_dims, bitID))
	{
		if (from->viewportX != to->viewportX ||
		    from->viewportY != to->viewportY ||
		    from->viewportW != to->viewportW ||
		    from->viewportH != to->viewportH)
		{
			diff_api.Viewport (to->viewportX,
			    to->viewportY,
			    to->viewportW,
			    to->viewportH);
			from->viewportX = to->viewportX;
			from->viewportY = to->viewportY;
			from->viewportW = to->viewportW;
			from->viewportH = to->viewportH;
		}
		CLEARDIRTY(b->v_dims, nbitID);
	}
	if (CHECKDIRTY(b->depth, bitID))
	{
		if (from->nearClip != to->nearClip ||
		    from->farClip != to->farClip)
		{
			diff_api.DepthRange (to->nearClip,
			    to->farClip);
			from->nearClip = to->nearClip;
			from->farClip = to->farClip;
		}
		CLEARDIRTY(b->depth, nbitID);
	}
	CLEARDIRTY(b->dirty, nbitID);
}

void crStateViewportSwitch(CRViewportBits *b, CRbitvalue *bitID,
		CRContext *fromCtx, CRContext *toCtx)
{
	CRViewportState *from = &(fromCtx->viewport);
	CRViewportState *to = &(toCtx->viewport);
	unsigned int j, i;
	CRbitvalue nbitID[CR_MAX_BITARRAY];
	for (j=0;j<CR_MAX_BITARRAY;j++)
		nbitID[j] = ~bitID[j];
	i = 0; /* silence compiler */
	if (CHECKDIRTY(b->enable, bitID))
	{
		glAble able[2];
		able[0] = diff_api.Disable;
		able[1] = diff_api.Enable;
		if (from->scissorTest != to->scissorTest)
		{
			able[to->scissorTest](GL_SCISSOR_TEST);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->enable, nbitID);
	}
	if (CHECKDIRTY(b->s_dims, bitID))
	{
		if (from->scissorX != to->scissorX ||
		    from->scissorY != to->scissorY ||
		    from->scissorW != to->scissorW ||
		    from->scissorH != to->scissorH)
		{
			diff_api.Scissor (to->scissorX,
			    to->scissorY,
			    to->scissorW,
			    to->scissorH);
			FILLDIRTY(b->s_dims);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->s_dims, nbitID);
	}
	if (CHECKDIRTY(b->v_dims, bitID))
	{
		if (from->viewportX != to->viewportX ||
		    from->viewportY != to->viewportY ||
		    from->viewportW != to->viewportW ||
		    from->viewportH != to->viewportH)
		{
			diff_api.Viewport (to->viewportX,
			    to->viewportY,
			    to->viewportW,
			    to->viewportH);
			FILLDIRTY(b->v_dims);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->v_dims, nbitID);
	}
	if (CHECKDIRTY(b->depth, bitID))
	{
		if (from->nearClip != to->nearClip ||
		    from->farClip != to->farClip)
		{
			diff_api.DepthRange (to->nearClip,
			    to->farClip);
			FILLDIRTY(b->depth);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->depth, nbitID);
	}
	CLEARDIRTY(b->dirty, nbitID);
}

