#include "soapH.h"
SOAP_FMAC3 void* SOAP_FMAC4 soap_class_id_enter(struct soap *soap, const char *id, void *p, int t, size_t n, const char *type, const char *arrayType)
{	return soap_id_enter(soap, id, p, t, n, 0, type, arrayType, soap_instantiate);
}

SOAP_FMAC3 void* SOAP_FMAC4 soap_container_id_forward(struct soap *soap, const char *href, void *p, size_t len, int st, int tt, size_t n, unsigned int k)
{	return soap_id_forward(soap, href, p, len, st, tt, n, k, soap_container_insert);
}

SOAP_FMAC3 void SOAP_FMAC4 soap_container_insert(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
#ifdef WIN32
#pragma warning(push)
#pragma warning(disable:4065)
#endif
{	switch (tt)
	{
	case SOAP_TYPE_std__vectorTemplateOfunsignedByte:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<unsigned char >*)p)[len] = *(unsigned char *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfint:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<int >*)p)[len] = *(int *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DataType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<enum vbox__DataType >*)p)[len] = *(enum vbox__DataType *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedLONG64:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<ULONG64 >*)p)[len] = *(ULONG64 *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IHardDiskAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<vbox__IHardDiskAttachment * >*)p)[len] = *(vbox__IHardDiskAttachment **)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfbool:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<bool >*)p)[len] = *(bool *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__VirtualSystemDescriptionType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<enum vbox__VirtualSystemDescriptionType >*)p)[len] = *(enum vbox__VirtualSystemDescriptionType *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedInt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<unsigned int >*)p)[len] = *(unsigned int *)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__ISharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<vbox__ISharedFolder * >*)p)[len] = *(vbox__ISharedFolder **)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IGuestOSType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<vbox__IGuestOSType * >*)p)[len] = *(vbox__IGuestOSType **)q;
		break;
	case SOAP_TYPE_std__vectorTemplateOfstd__string:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container insert type=%d in %d location=%p object=%p len=%lu\n", st, tt, p, q, (unsigned long)len));
		(*(std::vector<std::string >*)p)[len] = *(std::string *)q;
		break;
	default:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Could not insert type=%d in %d\n", st, tt));
	}
#ifdef WIN32
#pragma warning(pop)
#endif
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_byte(struct soap *soap, char *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_byte
	*a = SOAP_DEFAULT_byte;
#else
	*a = (char)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_byte(struct soap *soap, const char *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_byte);
	if (soap_out_byte(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_byte(struct soap *soap, const char *tag, int id, const char *a, const char *type)
{
	return soap_outbyte(soap, tag, id, a, type, SOAP_TYPE_byte);
}

SOAP_FMAC3 char * SOAP_FMAC4 soap_get_byte(struct soap *soap, char *p, const char *tag, const char *type)
{
	if ((p = soap_in_byte(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 char * SOAP_FMAC4 soap_in_byte(struct soap *soap, const char *tag, char *a, const char *type)
{	char *p;
	p = soap_inbyte(soap, tag, a, type, SOAP_TYPE_byte);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_short(struct soap *soap, short *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_short
	*a = SOAP_DEFAULT_short;
#else
	*a = (short)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_short(struct soap *soap, const short *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_short);
	if (soap_out_short(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_short(struct soap *soap, const char *tag, int id, const short *a, const char *type)
{
	return soap_outshort(soap, tag, id, a, type, SOAP_TYPE_short);
}

SOAP_FMAC3 short * SOAP_FMAC4 soap_get_short(struct soap *soap, short *p, const char *tag, const char *type)
{
	if ((p = soap_in_short(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 short * SOAP_FMAC4 soap_in_short(struct soap *soap, const char *tag, short *a, const char *type)
{	short *p;
	p = soap_inshort(soap, tag, a, type, SOAP_TYPE_short);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_int(struct soap *soap, int *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_int
	*a = SOAP_DEFAULT_int;
#else
	*a = (int)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_int(struct soap *soap, const int *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_int);
	if (soap_out_int(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_int(struct soap *soap, const char *tag, int id, const int *a, const char *type)
{
	return soap_outint(soap, tag, id, a, type, SOAP_TYPE_int);
}

SOAP_FMAC3 int * SOAP_FMAC4 soap_get_int(struct soap *soap, int *p, const char *tag, const char *type)
{
	if ((p = soap_in_int(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 int * SOAP_FMAC4 soap_in_int(struct soap *soap, const char *tag, int *a, const char *type)
{	int *p;
	p = soap_inint(soap, tag, a, type, SOAP_TYPE_int);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_LONG64(struct soap *soap, LONG64 *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_LONG64
	*a = SOAP_DEFAULT_LONG64;
#else
	*a = (LONG64)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_LONG64(struct soap *soap, const LONG64 *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_LONG64);
	if (soap_out_LONG64(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_LONG64(struct soap *soap, const char *tag, int id, const LONG64 *a, const char *type)
{
	return soap_outLONG64(soap, tag, id, a, type, SOAP_TYPE_LONG64);
}

SOAP_FMAC3 LONG64 * SOAP_FMAC4 soap_get_LONG64(struct soap *soap, LONG64 *p, const char *tag, const char *type)
{
	if ((p = soap_in_LONG64(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 LONG64 * SOAP_FMAC4 soap_in_LONG64(struct soap *soap, const char *tag, LONG64 *a, const char *type)
{	LONG64 *p;
	p = soap_inLONG64(soap, tag, a, type, SOAP_TYPE_LONG64);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedByte(struct soap *soap, unsigned char *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedByte
	*a = SOAP_DEFAULT_unsignedByte;
#else
	*a = (unsigned char)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedByte(struct soap *soap, const unsigned char *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedByte);
	if (soap_out_unsignedByte(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedByte(struct soap *soap, const char *tag, int id, const unsigned char *a, const char *type)
{
	return soap_outunsignedByte(soap, tag, id, a, type, SOAP_TYPE_unsignedByte);
}

SOAP_FMAC3 unsigned char * SOAP_FMAC4 soap_get_unsignedByte(struct soap *soap, unsigned char *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedByte(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 unsigned char * SOAP_FMAC4 soap_in_unsignedByte(struct soap *soap, const char *tag, unsigned char *a, const char *type)
{	unsigned char *p;
	p = soap_inunsignedByte(soap, tag, a, type, SOAP_TYPE_unsignedByte);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedShort(struct soap *soap, unsigned short *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedShort
	*a = SOAP_DEFAULT_unsignedShort;
#else
	*a = (unsigned short)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedShort(struct soap *soap, const unsigned short *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedShort);
	if (soap_out_unsignedShort(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedShort(struct soap *soap, const char *tag, int id, const unsigned short *a, const char *type)
{
	return soap_outunsignedShort(soap, tag, id, a, type, SOAP_TYPE_unsignedShort);
}

SOAP_FMAC3 unsigned short * SOAP_FMAC4 soap_get_unsignedShort(struct soap *soap, unsigned short *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedShort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 unsigned short * SOAP_FMAC4 soap_in_unsignedShort(struct soap *soap, const char *tag, unsigned short *a, const char *type)
{	unsigned short *p;
	p = soap_inunsignedShort(soap, tag, a, type, SOAP_TYPE_unsignedShort);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedInt(struct soap *soap, unsigned int *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedInt
	*a = SOAP_DEFAULT_unsignedInt;
#else
	*a = (unsigned int)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedInt(struct soap *soap, const unsigned int *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedInt);
	if (soap_out_unsignedInt(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedInt(struct soap *soap, const char *tag, int id, const unsigned int *a, const char *type)
{
	return soap_outunsignedInt(soap, tag, id, a, type, SOAP_TYPE_unsignedInt);
}

SOAP_FMAC3 unsigned int * SOAP_FMAC4 soap_get_unsignedInt(struct soap *soap, unsigned int *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedInt(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 unsigned int * SOAP_FMAC4 soap_in_unsignedInt(struct soap *soap, const char *tag, unsigned int *a, const char *type)
{	unsigned int *p;
	p = soap_inunsignedInt(soap, tag, a, type, SOAP_TYPE_unsignedInt);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedLONG64(struct soap *soap, ULONG64 *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedLONG64
	*a = SOAP_DEFAULT_unsignedLONG64;
#else
	*a = (ULONG64)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedLONG64(struct soap *soap, const ULONG64 *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_unsignedLONG64);
	if (soap_out_unsignedLONG64(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedLONG64(struct soap *soap, const char *tag, int id, const ULONG64 *a, const char *type)
{
	return soap_outULONG64(soap, tag, id, a, type, SOAP_TYPE_unsignedLONG64);
}

SOAP_FMAC3 ULONG64 * SOAP_FMAC4 soap_get_unsignedLONG64(struct soap *soap, ULONG64 *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedLONG64(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 ULONG64 * SOAP_FMAC4 soap_in_unsignedLONG64(struct soap *soap, const char *tag, ULONG64 *a, const char *type)
{	ULONG64 *p;
	p = soap_inULONG64(soap, tag, a, type, SOAP_TYPE_unsignedLONG64);
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_bool(struct soap *soap, bool *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_bool
	*a = SOAP_DEFAULT_bool;
#else
	*a = (bool)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_bool(struct soap *soap, const bool *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_bool);
	if (soap_out_bool(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_bool[] =
{	{ (long)false, "false" },
	{ (long)true, "true" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_bool2s(struct soap *soap, bool n)
{	(void)soap; /* appease -Wall -Werror */
return soap_code_str(soap_codes_bool, n!=0);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_bool(struct soap *soap, const char *tag, int id, const bool *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_bool), type) || soap_send(soap, soap_bool2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 bool * SOAP_FMAC4 soap_get_bool(struct soap *soap, bool *p, const char *tag, const char *type)
{
	if ((p = soap_in_bool(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2bool(struct soap *soap, const char *s, bool *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_bool, s);
	if (map)
		*a = (bool)(map->code != 0);
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || n < 0 || n > 1)
			return soap->error = SOAP_TYPE;
		*a = (bool)(n != 0);
	}
	return SOAP_OK;
}

SOAP_FMAC3 bool * SOAP_FMAC4 soap_in_bool(struct soap *soap, const char *tag, bool *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	if (*soap->type && soap_match_tag(soap, soap->type, type) && soap_match_tag(soap, soap->type, ":boolean"))
	{	soap->error = SOAP_TYPE;
		return NULL;
	}
	a = (bool *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_bool, sizeof(bool), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2bool(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (bool *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_bool, 0, sizeof(bool), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageControllerType
	*a = SOAP_DEFAULT_vbox__StorageControllerType;
#else
	*a = (enum vbox__StorageControllerType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__StorageControllerType(struct soap *soap, const enum vbox__StorageControllerType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__StorageControllerType);
	if (soap_out_vbox__StorageControllerType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__StorageControllerType[] =
{	{ (long)vbox__StorageControllerType__Null, "Null" },
	{ (long)vbox__StorageControllerType__LsiLogic, "LsiLogic" },
	{ (long)vbox__StorageControllerType__BusLogic, "BusLogic" },
	{ (long)vbox__StorageControllerType__IntelAhci, "IntelAhci" },
	{ (long)vbox__StorageControllerType__PIIX3, "PIIX3" },
	{ (long)vbox__StorageControllerType__PIIX4, "PIIX4" },
	{ (long)vbox__StorageControllerType__ICH6, "ICH6" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__StorageControllerType2s(struct soap *soap, enum vbox__StorageControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__StorageControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__StorageControllerType(struct soap *soap, const char *tag, int id, const enum vbox__StorageControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__StorageControllerType), type) || soap_send(soap, soap_vbox__StorageControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__StorageControllerType * SOAP_FMAC4 soap_get_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__StorageControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__StorageControllerType(struct soap *soap, const char *s, enum vbox__StorageControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__StorageControllerType, s);
	if (map)
		*a = (enum vbox__StorageControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__StorageControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__StorageControllerType * SOAP_FMAC4 soap_in_vbox__StorageControllerType(struct soap *soap, const char *tag, enum vbox__StorageControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__StorageControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__StorageControllerType, sizeof(enum vbox__StorageControllerType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__StorageControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__StorageControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__StorageControllerType, 0, sizeof(enum vbox__StorageControllerType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageBus
	*a = SOAP_DEFAULT_vbox__StorageBus;
#else
	*a = (enum vbox__StorageBus)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__StorageBus(struct soap *soap, const enum vbox__StorageBus *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__StorageBus);
	if (soap_out_vbox__StorageBus(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__StorageBus[] =
{	{ (long)vbox__StorageBus__Null, "Null" },
	{ (long)vbox__StorageBus__IDE, "IDE" },
	{ (long)vbox__StorageBus__SATA, "SATA" },
	{ (long)vbox__StorageBus__SCSI, "SCSI" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__StorageBus2s(struct soap *soap, enum vbox__StorageBus n)
{	const char *s = soap_code_str(soap_codes_vbox__StorageBus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__StorageBus(struct soap *soap, const char *tag, int id, const enum vbox__StorageBus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__StorageBus), type) || soap_send(soap, soap_vbox__StorageBus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__StorageBus * SOAP_FMAC4 soap_get_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__StorageBus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__StorageBus(struct soap *soap, const char *s, enum vbox__StorageBus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__StorageBus, s);
	if (map)
		*a = (enum vbox__StorageBus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__StorageBus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__StorageBus * SOAP_FMAC4 soap_in_vbox__StorageBus(struct soap *soap, const char *tag, enum vbox__StorageBus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__StorageBus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__StorageBus, sizeof(enum vbox__StorageBus), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__StorageBus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__StorageBus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__StorageBus, 0, sizeof(enum vbox__StorageBus), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VRDPAuthType(struct soap *soap, enum vbox__VRDPAuthType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VRDPAuthType
	*a = SOAP_DEFAULT_vbox__VRDPAuthType;
#else
	*a = (enum vbox__VRDPAuthType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VRDPAuthType(struct soap *soap, const enum vbox__VRDPAuthType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VRDPAuthType);
	if (soap_out_vbox__VRDPAuthType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VRDPAuthType[] =
{	{ (long)vbox__VRDPAuthType__Null, "Null" },
	{ (long)vbox__VRDPAuthType__External, "External" },
	{ (long)vbox__VRDPAuthType__Guest, "Guest" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VRDPAuthType2s(struct soap *soap, enum vbox__VRDPAuthType n)
{	const char *s = soap_code_str(soap_codes_vbox__VRDPAuthType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VRDPAuthType(struct soap *soap, const char *tag, int id, const enum vbox__VRDPAuthType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VRDPAuthType), type) || soap_send(soap, soap_vbox__VRDPAuthType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VRDPAuthType * SOAP_FMAC4 soap_get_vbox__VRDPAuthType(struct soap *soap, enum vbox__VRDPAuthType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VRDPAuthType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VRDPAuthType(struct soap *soap, const char *s, enum vbox__VRDPAuthType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VRDPAuthType, s);
	if (map)
		*a = (enum vbox__VRDPAuthType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VRDPAuthType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VRDPAuthType * SOAP_FMAC4 soap_in_vbox__VRDPAuthType(struct soap *soap, const char *tag, enum vbox__VRDPAuthType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VRDPAuthType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VRDPAuthType, sizeof(enum vbox__VRDPAuthType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VRDPAuthType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VRDPAuthType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VRDPAuthType, 0, sizeof(enum vbox__VRDPAuthType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioControllerType
	*a = SOAP_DEFAULT_vbox__AudioControllerType;
#else
	*a = (enum vbox__AudioControllerType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioControllerType(struct soap *soap, const enum vbox__AudioControllerType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__AudioControllerType);
	if (soap_out_vbox__AudioControllerType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__AudioControllerType[] =
{	{ (long)vbox__AudioControllerType__AC97, "AC97" },
	{ (long)vbox__AudioControllerType__SB16, "SB16" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioControllerType2s(struct soap *soap, enum vbox__AudioControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioControllerType(struct soap *soap, const char *tag, int id, const enum vbox__AudioControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioControllerType), type) || soap_send(soap, soap_vbox__AudioControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__AudioControllerType * SOAP_FMAC4 soap_get_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioControllerType(struct soap *soap, const char *s, enum vbox__AudioControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AudioControllerType, s);
	if (map)
		*a = (enum vbox__AudioControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioControllerType * SOAP_FMAC4 soap_in_vbox__AudioControllerType(struct soap *soap, const char *tag, enum vbox__AudioControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioControllerType, sizeof(enum vbox__AudioControllerType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__AudioControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioControllerType, 0, sizeof(enum vbox__AudioControllerType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDriverType
	*a = SOAP_DEFAULT_vbox__AudioDriverType;
#else
	*a = (enum vbox__AudioDriverType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioDriverType(struct soap *soap, const enum vbox__AudioDriverType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__AudioDriverType);
	if (soap_out_vbox__AudioDriverType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__AudioDriverType[] =
{	{ (long)vbox__AudioDriverType__Null, "Null" },
	{ (long)vbox__AudioDriverType__WinMM, "WinMM" },
	{ (long)vbox__AudioDriverType__OSS, "OSS" },
	{ (long)vbox__AudioDriverType__ALSA, "ALSA" },
	{ (long)vbox__AudioDriverType__DirectSound, "DirectSound" },
	{ (long)vbox__AudioDriverType__CoreAudio, "CoreAudio" },
	{ (long)vbox__AudioDriverType__MMPM, "MMPM" },
	{ (long)vbox__AudioDriverType__Pulse, "Pulse" },
	{ (long)vbox__AudioDriverType__SolAudio, "SolAudio" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioDriverType2s(struct soap *soap, enum vbox__AudioDriverType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioDriverType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioDriverType(struct soap *soap, const char *tag, int id, const enum vbox__AudioDriverType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioDriverType), type) || soap_send(soap, soap_vbox__AudioDriverType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__AudioDriverType * SOAP_FMAC4 soap_get_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioDriverType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioDriverType(struct soap *soap, const char *s, enum vbox__AudioDriverType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AudioDriverType, s);
	if (map)
		*a = (enum vbox__AudioDriverType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioDriverType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioDriverType * SOAP_FMAC4 soap_in_vbox__AudioDriverType(struct soap *soap, const char *tag, enum vbox__AudioDriverType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioDriverType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioDriverType, sizeof(enum vbox__AudioDriverType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__AudioDriverType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioDriverType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioDriverType, 0, sizeof(enum vbox__AudioDriverType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceFilterAction
	*a = SOAP_DEFAULT_vbox__USBDeviceFilterAction;
#else
	*a = (enum vbox__USBDeviceFilterAction)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBDeviceFilterAction(struct soap *soap, const enum vbox__USBDeviceFilterAction *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__USBDeviceFilterAction);
	if (soap_out_vbox__USBDeviceFilterAction(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__USBDeviceFilterAction[] =
{	{ (long)vbox__USBDeviceFilterAction__Null, "Null" },
	{ (long)vbox__USBDeviceFilterAction__Ignore, "Ignore" },
	{ (long)vbox__USBDeviceFilterAction__Hold, "Hold" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBDeviceFilterAction2s(struct soap *soap, enum vbox__USBDeviceFilterAction n)
{	const char *s = soap_code_str(soap_codes_vbox__USBDeviceFilterAction, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBDeviceFilterAction(struct soap *soap, const char *tag, int id, const enum vbox__USBDeviceFilterAction *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBDeviceFilterAction), type) || soap_send(soap, soap_vbox__USBDeviceFilterAction2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__USBDeviceFilterAction * SOAP_FMAC4 soap_get_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBDeviceFilterAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBDeviceFilterAction(struct soap *soap, const char *s, enum vbox__USBDeviceFilterAction *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__USBDeviceFilterAction, s);
	if (map)
		*a = (enum vbox__USBDeviceFilterAction)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBDeviceFilterAction)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBDeviceFilterAction * SOAP_FMAC4 soap_in_vbox__USBDeviceFilterAction(struct soap *soap, const char *tag, enum vbox__USBDeviceFilterAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBDeviceFilterAction *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBDeviceFilterAction, sizeof(enum vbox__USBDeviceFilterAction), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__USBDeviceFilterAction(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBDeviceFilterAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBDeviceFilterAction, 0, sizeof(enum vbox__USBDeviceFilterAction), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceState
	*a = SOAP_DEFAULT_vbox__USBDeviceState;
#else
	*a = (enum vbox__USBDeviceState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBDeviceState(struct soap *soap, const enum vbox__USBDeviceState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__USBDeviceState);
	if (soap_out_vbox__USBDeviceState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__USBDeviceState[] =
{	{ (long)vbox__USBDeviceState__NotSupported, "NotSupported" },
	{ (long)vbox__USBDeviceState__Unavailable, "Unavailable" },
	{ (long)vbox__USBDeviceState__Busy, "Busy" },
	{ (long)vbox__USBDeviceState__Available, "Available" },
	{ (long)vbox__USBDeviceState__Held, "Held" },
	{ (long)vbox__USBDeviceState__Captured, "Captured" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBDeviceState2s(struct soap *soap, enum vbox__USBDeviceState n)
{	const char *s = soap_code_str(soap_codes_vbox__USBDeviceState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBDeviceState(struct soap *soap, const char *tag, int id, const enum vbox__USBDeviceState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBDeviceState), type) || soap_send(soap, soap_vbox__USBDeviceState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__USBDeviceState * SOAP_FMAC4 soap_get_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBDeviceState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBDeviceState(struct soap *soap, const char *s, enum vbox__USBDeviceState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__USBDeviceState, s);
	if (map)
		*a = (enum vbox__USBDeviceState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBDeviceState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBDeviceState * SOAP_FMAC4 soap_in_vbox__USBDeviceState(struct soap *soap, const char *tag, enum vbox__USBDeviceState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBDeviceState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBDeviceState, sizeof(enum vbox__USBDeviceState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__USBDeviceState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBDeviceState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBDeviceState, 0, sizeof(enum vbox__USBDeviceState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__PortMode(struct soap *soap, enum vbox__PortMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PortMode
	*a = SOAP_DEFAULT_vbox__PortMode;
#else
	*a = (enum vbox__PortMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__PortMode(struct soap *soap, const enum vbox__PortMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__PortMode);
	if (soap_out_vbox__PortMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__PortMode[] =
{	{ (long)vbox__PortMode__Disconnected, "Disconnected" },
	{ (long)vbox__PortMode__HostPipe, "HostPipe" },
	{ (long)vbox__PortMode__HostDevice, "HostDevice" },
	{ (long)vbox__PortMode__RawFile, "RawFile" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__PortMode2s(struct soap *soap, enum vbox__PortMode n)
{	const char *s = soap_code_str(soap_codes_vbox__PortMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__PortMode(struct soap *soap, const char *tag, int id, const enum vbox__PortMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__PortMode), type) || soap_send(soap, soap_vbox__PortMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__PortMode * SOAP_FMAC4 soap_get_vbox__PortMode(struct soap *soap, enum vbox__PortMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__PortMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__PortMode(struct soap *soap, const char *s, enum vbox__PortMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__PortMode, s);
	if (map)
		*a = (enum vbox__PortMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__PortMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__PortMode * SOAP_FMAC4 soap_in_vbox__PortMode(struct soap *soap, const char *tag, enum vbox__PortMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__PortMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__PortMode, sizeof(enum vbox__PortMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__PortMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__PortMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__PortMode, 0, sizeof(enum vbox__PortMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAdapterType
	*a = SOAP_DEFAULT_vbox__NetworkAdapterType;
#else
	*a = (enum vbox__NetworkAdapterType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAdapterType(struct soap *soap, const enum vbox__NetworkAdapterType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__NetworkAdapterType);
	if (soap_out_vbox__NetworkAdapterType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__NetworkAdapterType[] =
{	{ (long)vbox__NetworkAdapterType__Null, "Null" },
	{ (long)vbox__NetworkAdapterType__Am79C970A, "Am79C970A" },
	{ (long)vbox__NetworkAdapterType__Am79C973, "Am79C973" },
	{ (long)vbox__NetworkAdapterType__I82540EM, "I82540EM" },
	{ (long)vbox__NetworkAdapterType__I82543GC, "I82543GC" },
	{ (long)vbox__NetworkAdapterType__I82545EM, "I82545EM" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAdapterType2s(struct soap *soap, enum vbox__NetworkAdapterType n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAdapterType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAdapterType(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAdapterType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAdapterType), type) || soap_send(soap, soap_vbox__NetworkAdapterType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__NetworkAdapterType * SOAP_FMAC4 soap_get_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAdapterType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAdapterType(struct soap *soap, const char *s, enum vbox__NetworkAdapterType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NetworkAdapterType, s);
	if (map)
		*a = (enum vbox__NetworkAdapterType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAdapterType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAdapterType * SOAP_FMAC4 soap_in_vbox__NetworkAdapterType(struct soap *soap, const char *tag, enum vbox__NetworkAdapterType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAdapterType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAdapterType, sizeof(enum vbox__NetworkAdapterType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__NetworkAdapterType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAdapterType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAdapterType, 0, sizeof(enum vbox__NetworkAdapterType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAttachmentType
	*a = SOAP_DEFAULT_vbox__NetworkAttachmentType;
#else
	*a = (enum vbox__NetworkAttachmentType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAttachmentType(struct soap *soap, const enum vbox__NetworkAttachmentType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__NetworkAttachmentType);
	if (soap_out_vbox__NetworkAttachmentType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__NetworkAttachmentType[] =
{	{ (long)vbox__NetworkAttachmentType__Null, "Null" },
	{ (long)vbox__NetworkAttachmentType__NAT, "NAT" },
	{ (long)vbox__NetworkAttachmentType__Bridged, "Bridged" },
	{ (long)vbox__NetworkAttachmentType__Internal, "Internal" },
	{ (long)vbox__NetworkAttachmentType__HostOnly, "HostOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAttachmentType2s(struct soap *soap, enum vbox__NetworkAttachmentType n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAttachmentType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAttachmentType(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAttachmentType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAttachmentType), type) || soap_send(soap, soap_vbox__NetworkAttachmentType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__NetworkAttachmentType * SOAP_FMAC4 soap_get_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAttachmentType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAttachmentType(struct soap *soap, const char *s, enum vbox__NetworkAttachmentType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NetworkAttachmentType, s);
	if (map)
		*a = (enum vbox__NetworkAttachmentType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAttachmentType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAttachmentType * SOAP_FMAC4 soap_in_vbox__NetworkAttachmentType(struct soap *soap, const char *tag, enum vbox__NetworkAttachmentType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAttachmentType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAttachmentType, sizeof(enum vbox__NetworkAttachmentType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__NetworkAttachmentType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAttachmentType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAttachmentType, 0, sizeof(enum vbox__NetworkAttachmentType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FramebufferPixelFormat(struct soap *soap, enum vbox__FramebufferPixelFormat *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FramebufferPixelFormat
	*a = SOAP_DEFAULT_vbox__FramebufferPixelFormat;
#else
	*a = (enum vbox__FramebufferPixelFormat)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FramebufferPixelFormat(struct soap *soap, const enum vbox__FramebufferPixelFormat *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__FramebufferPixelFormat);
	if (soap_out_vbox__FramebufferPixelFormat(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__FramebufferPixelFormat[] =
{	{ (long)vbox__FramebufferPixelFormat__Opaque, "Opaque" },
	{ (long)vbox__FramebufferPixelFormat__FOURCC_USCORERGB, "FOURCC_RGB" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FramebufferPixelFormat2s(struct soap *soap, enum vbox__FramebufferPixelFormat n)
{	const char *s = soap_code_str(soap_codes_vbox__FramebufferPixelFormat, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FramebufferPixelFormat(struct soap *soap, const char *tag, int id, const enum vbox__FramebufferPixelFormat *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FramebufferPixelFormat), type) || soap_send(soap, soap_vbox__FramebufferPixelFormat2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__FramebufferPixelFormat * SOAP_FMAC4 soap_get_vbox__FramebufferPixelFormat(struct soap *soap, enum vbox__FramebufferPixelFormat *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FramebufferPixelFormat(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FramebufferPixelFormat(struct soap *soap, const char *s, enum vbox__FramebufferPixelFormat *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FramebufferPixelFormat, s);
	if (map)
		*a = (enum vbox__FramebufferPixelFormat)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FramebufferPixelFormat)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FramebufferPixelFormat * SOAP_FMAC4 soap_in_vbox__FramebufferPixelFormat(struct soap *soap, const char *tag, enum vbox__FramebufferPixelFormat *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FramebufferPixelFormat *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FramebufferPixelFormat, sizeof(enum vbox__FramebufferPixelFormat), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__FramebufferPixelFormat(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FramebufferPixelFormat *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FramebufferPixelFormat, 0, sizeof(enum vbox__FramebufferPixelFormat), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MouseButtonState
	*a = SOAP_DEFAULT_vbox__MouseButtonState;
#else
	*a = (enum vbox__MouseButtonState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MouseButtonState(struct soap *soap, const enum vbox__MouseButtonState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MouseButtonState);
	if (soap_out_vbox__MouseButtonState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MouseButtonState[] =
{	{ (long)vbox__MouseButtonState__LeftButton, "LeftButton" },
	{ (long)vbox__MouseButtonState__RightButton, "RightButton" },
	{ (long)vbox__MouseButtonState__MiddleButton, "MiddleButton" },
	{ (long)vbox__MouseButtonState__WheelUp, "WheelUp" },
	{ (long)vbox__MouseButtonState__WheelDown, "WheelDown" },
	{ (long)vbox__MouseButtonState__MouseStateMask, "MouseStateMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MouseButtonState2s(struct soap *soap, enum vbox__MouseButtonState n)
{	const char *s = soap_code_str(soap_codes_vbox__MouseButtonState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MouseButtonState(struct soap *soap, const char *tag, int id, const enum vbox__MouseButtonState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MouseButtonState), type) || soap_send(soap, soap_vbox__MouseButtonState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MouseButtonState * SOAP_FMAC4 soap_get_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MouseButtonState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MouseButtonState(struct soap *soap, const char *s, enum vbox__MouseButtonState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MouseButtonState, s);
	if (map)
		*a = (enum vbox__MouseButtonState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MouseButtonState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MouseButtonState * SOAP_FMAC4 soap_in_vbox__MouseButtonState(struct soap *soap, const char *tag, enum vbox__MouseButtonState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MouseButtonState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MouseButtonState, sizeof(enum vbox__MouseButtonState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MouseButtonState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MouseButtonState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MouseButtonState, 0, sizeof(enum vbox__MouseButtonState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HardDiskFormatCapabilities(struct soap *soap, enum vbox__HardDiskFormatCapabilities *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HardDiskFormatCapabilities
	*a = SOAP_DEFAULT_vbox__HardDiskFormatCapabilities;
#else
	*a = (enum vbox__HardDiskFormatCapabilities)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HardDiskFormatCapabilities(struct soap *soap, const enum vbox__HardDiskFormatCapabilities *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HardDiskFormatCapabilities);
	if (soap_out_vbox__HardDiskFormatCapabilities(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HardDiskFormatCapabilities[] =
{	{ (long)vbox__HardDiskFormatCapabilities__Uuid, "Uuid" },
	{ (long)vbox__HardDiskFormatCapabilities__CreateFixed, "CreateFixed" },
	{ (long)vbox__HardDiskFormatCapabilities__CreateDynamic, "CreateDynamic" },
	{ (long)vbox__HardDiskFormatCapabilities__CreateSplit2G, "CreateSplit2G" },
	{ (long)vbox__HardDiskFormatCapabilities__Differencing, "Differencing" },
	{ (long)vbox__HardDiskFormatCapabilities__Asynchronous, "Asynchronous" },
	{ (long)vbox__HardDiskFormatCapabilities__File, "File" },
	{ (long)vbox__HardDiskFormatCapabilities__Properties, "Properties" },
	{ (long)vbox__HardDiskFormatCapabilities__CapabilityMask, "CapabilityMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HardDiskFormatCapabilities2s(struct soap *soap, enum vbox__HardDiskFormatCapabilities n)
{	const char *s = soap_code_str(soap_codes_vbox__HardDiskFormatCapabilities, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HardDiskFormatCapabilities(struct soap *soap, const char *tag, int id, const enum vbox__HardDiskFormatCapabilities *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HardDiskFormatCapabilities), type) || soap_send(soap, soap_vbox__HardDiskFormatCapabilities2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HardDiskFormatCapabilities * SOAP_FMAC4 soap_get_vbox__HardDiskFormatCapabilities(struct soap *soap, enum vbox__HardDiskFormatCapabilities *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HardDiskFormatCapabilities(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HardDiskFormatCapabilities(struct soap *soap, const char *s, enum vbox__HardDiskFormatCapabilities *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HardDiskFormatCapabilities, s);
	if (map)
		*a = (enum vbox__HardDiskFormatCapabilities)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HardDiskFormatCapabilities)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HardDiskFormatCapabilities * SOAP_FMAC4 soap_in_vbox__HardDiskFormatCapabilities(struct soap *soap, const char *tag, enum vbox__HardDiskFormatCapabilities *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HardDiskFormatCapabilities *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HardDiskFormatCapabilities, sizeof(enum vbox__HardDiskFormatCapabilities), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HardDiskFormatCapabilities(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HardDiskFormatCapabilities *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HardDiskFormatCapabilities, 0, sizeof(enum vbox__HardDiskFormatCapabilities), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataFlags
	*a = SOAP_DEFAULT_vbox__DataFlags;
#else
	*a = (enum vbox__DataFlags)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DataFlags(struct soap *soap, const enum vbox__DataFlags *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DataFlags);
	if (soap_out_vbox__DataFlags(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DataFlags[] =
{	{ (long)vbox__DataFlags__None, "None" },
	{ (long)vbox__DataFlags__Mandatory, "Mandatory" },
	{ (long)vbox__DataFlags__Expert, "Expert" },
	{ (long)vbox__DataFlags__Array, "Array" },
	{ (long)vbox__DataFlags__FlagMask, "FlagMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DataFlags2s(struct soap *soap, enum vbox__DataFlags n)
{	const char *s = soap_code_str(soap_codes_vbox__DataFlags, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DataFlags(struct soap *soap, const char *tag, int id, const enum vbox__DataFlags *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DataFlags), type) || soap_send(soap, soap_vbox__DataFlags2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DataFlags * SOAP_FMAC4 soap_get_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DataFlags(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DataFlags(struct soap *soap, const char *s, enum vbox__DataFlags *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DataFlags, s);
	if (map)
		*a = (enum vbox__DataFlags)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DataFlags)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DataFlags * SOAP_FMAC4 soap_in_vbox__DataFlags(struct soap *soap, const char *tag, enum vbox__DataFlags *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DataFlags *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DataFlags, sizeof(enum vbox__DataFlags), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DataFlags(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DataFlags *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DataFlags, 0, sizeof(enum vbox__DataFlags), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DataType(struct soap *soap, enum vbox__DataType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataType
	*a = SOAP_DEFAULT_vbox__DataType;
#else
	*a = (enum vbox__DataType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DataType(struct soap *soap, const enum vbox__DataType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DataType);
	if (soap_out_vbox__DataType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DataType[] =
{	{ (long)vbox__DataType__Int32, "Int32" },
	{ (long)vbox__DataType__Int8, "Int8" },
	{ (long)vbox__DataType__String, "String" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DataType2s(struct soap *soap, enum vbox__DataType n)
{	const char *s = soap_code_str(soap_codes_vbox__DataType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DataType(struct soap *soap, const char *tag, int id, const enum vbox__DataType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DataType), type) || soap_send(soap, soap_vbox__DataType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DataType * SOAP_FMAC4 soap_get_vbox__DataType(struct soap *soap, enum vbox__DataType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DataType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DataType(struct soap *soap, const char *s, enum vbox__DataType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DataType, s);
	if (map)
		*a = (enum vbox__DataType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DataType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DataType * SOAP_FMAC4 soap_in_vbox__DataType(struct soap *soap, const char *tag, enum vbox__DataType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DataType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DataType, sizeof(enum vbox__DataType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DataType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DataType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DataType, 0, sizeof(enum vbox__DataType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HardDiskVariant(struct soap *soap, enum vbox__HardDiskVariant *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HardDiskVariant
	*a = SOAP_DEFAULT_vbox__HardDiskVariant;
#else
	*a = (enum vbox__HardDiskVariant)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HardDiskVariant(struct soap *soap, const enum vbox__HardDiskVariant *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HardDiskVariant);
	if (soap_out_vbox__HardDiskVariant(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HardDiskVariant[] =
{	{ (long)vbox__HardDiskVariant__Standard, "Standard" },
	{ (long)vbox__HardDiskVariant__VmdkSplit2G, "VmdkSplit2G" },
	{ (long)vbox__HardDiskVariant__VmdkStreamOptimized, "VmdkStreamOptimized" },
	{ (long)vbox__HardDiskVariant__VmdkESX, "VmdkESX" },
	{ (long)vbox__HardDiskVariant__Fixed, "Fixed" },
	{ (long)vbox__HardDiskVariant__Diff, "Diff" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HardDiskVariant2s(struct soap *soap, enum vbox__HardDiskVariant n)
{	const char *s = soap_code_str(soap_codes_vbox__HardDiskVariant, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HardDiskVariant(struct soap *soap, const char *tag, int id, const enum vbox__HardDiskVariant *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HardDiskVariant), type) || soap_send(soap, soap_vbox__HardDiskVariant2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HardDiskVariant * SOAP_FMAC4 soap_get_vbox__HardDiskVariant(struct soap *soap, enum vbox__HardDiskVariant *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HardDiskVariant(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HardDiskVariant(struct soap *soap, const char *s, enum vbox__HardDiskVariant *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HardDiskVariant, s);
	if (map)
		*a = (enum vbox__HardDiskVariant)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HardDiskVariant)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HardDiskVariant * SOAP_FMAC4 soap_in_vbox__HardDiskVariant(struct soap *soap, const char *tag, enum vbox__HardDiskVariant *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HardDiskVariant *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HardDiskVariant, sizeof(enum vbox__HardDiskVariant), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HardDiskVariant(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HardDiskVariant *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HardDiskVariant, 0, sizeof(enum vbox__HardDiskVariant), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HardDiskType(struct soap *soap, enum vbox__HardDiskType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HardDiskType
	*a = SOAP_DEFAULT_vbox__HardDiskType;
#else
	*a = (enum vbox__HardDiskType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HardDiskType(struct soap *soap, const enum vbox__HardDiskType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HardDiskType);
	if (soap_out_vbox__HardDiskType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HardDiskType[] =
{	{ (long)vbox__HardDiskType__Normal, "Normal" },
	{ (long)vbox__HardDiskType__Immutable, "Immutable" },
	{ (long)vbox__HardDiskType__Writethrough, "Writethrough" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HardDiskType2s(struct soap *soap, enum vbox__HardDiskType n)
{	const char *s = soap_code_str(soap_codes_vbox__HardDiskType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HardDiskType(struct soap *soap, const char *tag, int id, const enum vbox__HardDiskType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HardDiskType), type) || soap_send(soap, soap_vbox__HardDiskType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HardDiskType * SOAP_FMAC4 soap_get_vbox__HardDiskType(struct soap *soap, enum vbox__HardDiskType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HardDiskType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HardDiskType(struct soap *soap, const char *s, enum vbox__HardDiskType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HardDiskType, s);
	if (map)
		*a = (enum vbox__HardDiskType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HardDiskType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HardDiskType * SOAP_FMAC4 soap_in_vbox__HardDiskType(struct soap *soap, const char *tag, enum vbox__HardDiskType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HardDiskType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HardDiskType, sizeof(enum vbox__HardDiskType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HardDiskType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HardDiskType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HardDiskType, 0, sizeof(enum vbox__HardDiskType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediaState(struct soap *soap, enum vbox__MediaState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediaState
	*a = SOAP_DEFAULT_vbox__MediaState;
#else
	*a = (enum vbox__MediaState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediaState(struct soap *soap, const enum vbox__MediaState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MediaState);
	if (soap_out_vbox__MediaState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MediaState[] =
{	{ (long)vbox__MediaState__NotCreated, "NotCreated" },
	{ (long)vbox__MediaState__Created, "Created" },
	{ (long)vbox__MediaState__LockedRead, "LockedRead" },
	{ (long)vbox__MediaState__LockedWrite, "LockedWrite" },
	{ (long)vbox__MediaState__Inaccessible, "Inaccessible" },
	{ (long)vbox__MediaState__Creating, "Creating" },
	{ (long)vbox__MediaState__Deleting, "Deleting" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediaState2s(struct soap *soap, enum vbox__MediaState n)
{	const char *s = soap_code_str(soap_codes_vbox__MediaState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediaState(struct soap *soap, const char *tag, int id, const enum vbox__MediaState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediaState), type) || soap_send(soap, soap_vbox__MediaState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MediaState * SOAP_FMAC4 soap_get_vbox__MediaState(struct soap *soap, enum vbox__MediaState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediaState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediaState(struct soap *soap, const char *s, enum vbox__MediaState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MediaState, s);
	if (map)
		*a = (enum vbox__MediaState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediaState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediaState * SOAP_FMAC4 soap_in_vbox__MediaState(struct soap *soap, const char *tag, enum vbox__MediaState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediaState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediaState, sizeof(enum vbox__MediaState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MediaState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediaState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediaState, 0, sizeof(enum vbox__MediaState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceType;
#else
	*a = (enum vbox__HostNetworkInterfaceType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceType(struct soap *soap, const enum vbox__HostNetworkInterfaceType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HostNetworkInterfaceType);
	if (soap_out_vbox__HostNetworkInterfaceType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceType[] =
{	{ (long)vbox__HostNetworkInterfaceType__Bridged, "Bridged" },
	{ (long)vbox__HostNetworkInterfaceType__HostOnly, "HostOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceType2s(struct soap *soap, enum vbox__HostNetworkInterfaceType n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceType(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceType), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceType * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceType(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceType, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceType * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceType(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceType, sizeof(enum vbox__HostNetworkInterfaceType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HostNetworkInterfaceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceType, 0, sizeof(enum vbox__HostNetworkInterfaceType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus;
#else
	*a = (enum vbox__HostNetworkInterfaceStatus)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceStatus(struct soap *soap, const enum vbox__HostNetworkInterfaceStatus *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HostNetworkInterfaceStatus);
	if (soap_out_vbox__HostNetworkInterfaceStatus(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceStatus[] =
{	{ (long)vbox__HostNetworkInterfaceStatus__Unknown, "Unknown" },
	{ (long)vbox__HostNetworkInterfaceStatus__Up, "Up" },
	{ (long)vbox__HostNetworkInterfaceStatus__Down, "Down" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceStatus2s(struct soap *soap, enum vbox__HostNetworkInterfaceStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceStatus), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceStatus * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceStatus, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceStatus * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, sizeof(enum vbox__HostNetworkInterfaceStatus), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HostNetworkInterfaceStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, 0, sizeof(enum vbox__HostNetworkInterfaceStatus), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType;
#else
	*a = (enum vbox__HostNetworkInterfaceMediumType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const enum vbox__HostNetworkInterfaceMediumType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType);
	if (soap_out_vbox__HostNetworkInterfaceMediumType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceMediumType[] =
{	{ (long)vbox__HostNetworkInterfaceMediumType__Unknown, "Unknown" },
	{ (long)vbox__HostNetworkInterfaceMediumType__Ethernet, "Ethernet" },
	{ (long)vbox__HostNetworkInterfaceMediumType__PPP, "PPP" },
	{ (long)vbox__HostNetworkInterfaceMediumType__SLIP, "SLIP" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceMediumType2s(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceMediumType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceMediumType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceMediumType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceMediumType * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceMediumType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceMediumType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceMediumType, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceMediumType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceMediumType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceMediumType * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceMediumType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceMediumType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, sizeof(enum vbox__HostNetworkInterfaceMediumType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__HostNetworkInterfaceMediumType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceMediumType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, 0, sizeof(enum vbox__HostNetworkInterfaceMediumType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType;
#else
	*a = (enum vbox__VirtualSystemDescriptionValueType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const enum vbox__VirtualSystemDescriptionValueType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType);
	if (soap_out_vbox__VirtualSystemDescriptionValueType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VirtualSystemDescriptionValueType[] =
{	{ (long)vbox__VirtualSystemDescriptionValueType__Reference, "Reference" },
	{ (long)vbox__VirtualSystemDescriptionValueType__Original, "Original" },
	{ (long)vbox__VirtualSystemDescriptionValueType__Auto, "Auto" },
	{ (long)vbox__VirtualSystemDescriptionValueType__ExtraConfig, "ExtraConfig" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VirtualSystemDescriptionValueType2s(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType n)
{	const char *s = soap_code_str(soap_codes_vbox__VirtualSystemDescriptionValueType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *tag, int id, const enum vbox__VirtualSystemDescriptionValueType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType), type) || soap_send(soap, soap_vbox__VirtualSystemDescriptionValueType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionValueType * SOAP_FMAC4 soap_get_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VirtualSystemDescriptionValueType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *s, enum vbox__VirtualSystemDescriptionValueType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VirtualSystemDescriptionValueType, s);
	if (map)
		*a = (enum vbox__VirtualSystemDescriptionValueType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VirtualSystemDescriptionValueType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionValueType * SOAP_FMAC4 soap_in_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *tag, enum vbox__VirtualSystemDescriptionValueType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VirtualSystemDescriptionValueType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, sizeof(enum vbox__VirtualSystemDescriptionValueType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VirtualSystemDescriptionValueType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VirtualSystemDescriptionValueType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, 0, sizeof(enum vbox__VirtualSystemDescriptionValueType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionType;
#else
	*a = (enum vbox__VirtualSystemDescriptionType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VirtualSystemDescriptionType(struct soap *soap, const enum vbox__VirtualSystemDescriptionType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VirtualSystemDescriptionType);
	if (soap_out_vbox__VirtualSystemDescriptionType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VirtualSystemDescriptionType[] =
{	{ (long)vbox__VirtualSystemDescriptionType__Ignore, "Ignore" },
	{ (long)vbox__VirtualSystemDescriptionType__OS, "OS" },
	{ (long)vbox__VirtualSystemDescriptionType__Name, "Name" },
	{ (long)vbox__VirtualSystemDescriptionType__Product, "Product" },
	{ (long)vbox__VirtualSystemDescriptionType__Vendor, "Vendor" },
	{ (long)vbox__VirtualSystemDescriptionType__Version, "Version" },
	{ (long)vbox__VirtualSystemDescriptionType__ProductUrl, "ProductUrl" },
	{ (long)vbox__VirtualSystemDescriptionType__VendorUrl, "VendorUrl" },
	{ (long)vbox__VirtualSystemDescriptionType__Description, "Description" },
	{ (long)vbox__VirtualSystemDescriptionType__License, "License" },
	{ (long)vbox__VirtualSystemDescriptionType__Miscellaneous, "Miscellaneous" },
	{ (long)vbox__VirtualSystemDescriptionType__CPU, "CPU" },
	{ (long)vbox__VirtualSystemDescriptionType__Memory, "Memory" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskControllerIDE, "HardDiskControllerIDE" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskControllerSATA, "HardDiskControllerSATA" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskControllerSCSI, "HardDiskControllerSCSI" },
	{ (long)vbox__VirtualSystemDescriptionType__HardDiskImage, "HardDiskImage" },
	{ (long)vbox__VirtualSystemDescriptionType__Floppy, "Floppy" },
	{ (long)vbox__VirtualSystemDescriptionType__CDROM, "CDROM" },
	{ (long)vbox__VirtualSystemDescriptionType__NetworkAdapter, "NetworkAdapter" },
	{ (long)vbox__VirtualSystemDescriptionType__USBController, "USBController" },
	{ (long)vbox__VirtualSystemDescriptionType__SoundCard, "SoundCard" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VirtualSystemDescriptionType2s(struct soap *soap, enum vbox__VirtualSystemDescriptionType n)
{	const char *s = soap_code_str(soap_codes_vbox__VirtualSystemDescriptionType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *tag, int id, const enum vbox__VirtualSystemDescriptionType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionType), type) || soap_send(soap, soap_vbox__VirtualSystemDescriptionType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionType * SOAP_FMAC4 soap_get_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VirtualSystemDescriptionType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VirtualSystemDescriptionType(struct soap *soap, const char *s, enum vbox__VirtualSystemDescriptionType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VirtualSystemDescriptionType, s);
	if (map)
		*a = (enum vbox__VirtualSystemDescriptionType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 21)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VirtualSystemDescriptionType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionType * SOAP_FMAC4 soap_in_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *tag, enum vbox__VirtualSystemDescriptionType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VirtualSystemDescriptionType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionType, sizeof(enum vbox__VirtualSystemDescriptionType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VirtualSystemDescriptionType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VirtualSystemDescriptionType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VirtualSystemDescriptionType, 0, sizeof(enum vbox__VirtualSystemDescriptionType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__OVFResourceType(struct soap *soap, enum vbox__OVFResourceType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__OVFResourceType
	*a = SOAP_DEFAULT_vbox__OVFResourceType;
#else
	*a = (enum vbox__OVFResourceType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__OVFResourceType(struct soap *soap, const enum vbox__OVFResourceType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__OVFResourceType);
	if (soap_out_vbox__OVFResourceType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__OVFResourceType[] =
{	{ (long)vbox__OVFResourceType__Other, "Other" },
	{ (long)vbox__OVFResourceType__ComputerSystem, "ComputerSystem" },
	{ (long)vbox__OVFResourceType__Processor, "Processor" },
	{ (long)vbox__OVFResourceType__Memory, "Memory" },
	{ (long)vbox__OVFResourceType__IDEController, "IDEController" },
	{ (long)vbox__OVFResourceType__ParallelSCSIHBA, "ParallelSCSIHBA" },
	{ (long)vbox__OVFResourceType__FCHBA, "FCHBA" },
	{ (long)vbox__OVFResourceType__iSCSIHBA, "iSCSIHBA" },
	{ (long)vbox__OVFResourceType__IBHCA, "IBHCA" },
	{ (long)vbox__OVFResourceType__EthernetAdapter, "EthernetAdapter" },
	{ (long)vbox__OVFResourceType__OtherNetworkAdapter, "OtherNetworkAdapter" },
	{ (long)vbox__OVFResourceType__IOSlot, "IOSlot" },
	{ (long)vbox__OVFResourceType__IODevice, "IODevice" },
	{ (long)vbox__OVFResourceType__FloppyDrive, "FloppyDrive" },
	{ (long)vbox__OVFResourceType__CDDrive, "CDDrive" },
	{ (long)vbox__OVFResourceType__DVDDrive, "DVDDrive" },
	{ (long)vbox__OVFResourceType__HardDisk, "HardDisk" },
	{ (long)vbox__OVFResourceType__OtherStorageDevice, "OtherStorageDevice" },
	{ (long)vbox__OVFResourceType__USBController, "USBController" },
	{ (long)vbox__OVFResourceType__SoundCard, "SoundCard" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__OVFResourceType2s(struct soap *soap, enum vbox__OVFResourceType n)
{	const char *s = soap_code_str(soap_codes_vbox__OVFResourceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__OVFResourceType(struct soap *soap, const char *tag, int id, const enum vbox__OVFResourceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__OVFResourceType), type) || soap_send(soap, soap_vbox__OVFResourceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__OVFResourceType * SOAP_FMAC4 soap_get_vbox__OVFResourceType(struct soap *soap, enum vbox__OVFResourceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__OVFResourceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__OVFResourceType(struct soap *soap, const char *s, enum vbox__OVFResourceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__OVFResourceType, s);
	if (map)
		*a = (enum vbox__OVFResourceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 19)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__OVFResourceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__OVFResourceType * SOAP_FMAC4 soap_in_vbox__OVFResourceType(struct soap *soap, const char *tag, enum vbox__OVFResourceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__OVFResourceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__OVFResourceType, sizeof(enum vbox__OVFResourceType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__OVFResourceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__OVFResourceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__OVFResourceType, 0, sizeof(enum vbox__OVFResourceType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CIMOSType(struct soap *soap, enum vbox__CIMOSType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CIMOSType
	*a = SOAP_DEFAULT_vbox__CIMOSType;
#else
	*a = (enum vbox__CIMOSType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CIMOSType(struct soap *soap, const enum vbox__CIMOSType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__CIMOSType);
	if (soap_out_vbox__CIMOSType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__CIMOSType[] =
{	{ (long)vbox__CIMOSType__CIMOS_USCOREUnknown, "CIMOS_Unknown" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOther, "CIMOS_Other" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMACOS, "CIMOS_MACOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREATTUNIX, "CIMOS_ATTUNIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREDGUX, "CIMOS_DGUX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREDECNT, "CIMOS_DECNT" },
	{ (long)vbox__CIMOSType__CIMOS_USCORETru64UNIX, "CIMOS_Tru64UNIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOpenVMS, "CIMOS_OpenVMS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREHPUX, "CIMOS_HPUX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREAIX, "CIMOS_AIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMVS, "CIMOS_MVS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOS400, "CIMOS_OS400" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOS2, "CIMOS_OS2" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREJavaVM, "CIMOS_JavaVM" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMSDOS, "CIMOS_MSDOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWIN3x, "CIMOS_WIN3x" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWIN95, "CIMOS_WIN95" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWIN98, "CIMOS_WIN98" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWINNT, "CIMOS_WINNT" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWINCE, "CIMOS_WINCE" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENCR3000, "CIMOS_NCR3000" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENetWare, "CIMOS_NetWare" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOSF, "CIMOS_OSF" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREDCOS, "CIMOS_DCOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREReliantUNIX, "CIMOS_ReliantUNIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESCOUnixWare, "CIMOS_SCOUnixWare" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESCOOpenServer, "CIMOS_SCOOpenServer" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESequent, "CIMOS_Sequent" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREIRIX, "CIMOS_IRIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESolaris, "CIMOS_Solaris" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESunOS, "CIMOS_SunOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREU6000, "CIMOS_U6000" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREASERIES, "CIMOS_ASERIES" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREHPNonStopOS, "CIMOS_HPNonStopOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREHPNonStopOSS, "CIMOS_HPNonStopOSS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREBS2000, "CIMOS_BS2000" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELINUX, "CIMOS_LINUX" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELynx, "CIMOS_Lynx" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREXENIX, "CIMOS_XENIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREVM, "CIMOS_VM" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREInteractiveUNIX, "CIMOS_InteractiveUNIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREBSDUNIX, "CIMOS_BSDUNIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREFreeBSD, "CIMOS_FreeBSD" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENetBSD, "CIMOS_NetBSD" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREGNUHurd, "CIMOS_GNUHurd" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOS9, "CIMOS_OS9" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMACHKernel, "CIMOS_MACHKernel" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREInferno, "CIMOS_Inferno" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREQNX, "CIMOS_QNX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREEPOC, "CIMOS_EPOC" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREIxWorks, "CIMOS_IxWorks" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREVxWorks, "CIMOS_VxWorks" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMiNT, "CIMOS_MiNT" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREBeOS, "CIMOS_BeOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREHPMPE, "CIMOS_HPMPE" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENextStep, "CIMOS_NextStep" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREPalmPilot, "CIMOS_PalmPilot" },
	{ (long)vbox__CIMOSType__CIMOS_USCORERhapsody, "CIMOS_Rhapsody" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindows2000, "CIMOS_Windows2000" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREDedicated, "CIMOS_Dedicated" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOS390, "CIMOS_OS390" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREVSE, "CIMOS_VSE" },
	{ (long)vbox__CIMOSType__CIMOS_USCORETPF, "CIMOS_TPF" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsMe, "CIMOS_WindowsMe" },
	{ (long)vbox__CIMOSType__CIMOS_USCORECalderaOpenUNIX, "CIMOS_CalderaOpenUNIX" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOpenBSD, "CIMOS_OpenBSD" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENotApplicable, "CIMOS_NotApplicable" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsXP, "CIMOS_WindowsXP" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREzOS, "CIMOS_zOS" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMicrosoftWindowsServer2003, "CIMOS_MicrosoftWindowsServer2003" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMicrosoftWindowsServer2003_USCORE64, "CIMOS_MicrosoftWindowsServer2003_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsXP_USCORE64, "CIMOS_WindowsXP_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsXPEmbedded, "CIMOS_WindowsXPEmbedded" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsVista, "CIMOS_WindowsVista" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsVista_USCORE64, "CIMOS_WindowsVista_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREWindowsEmbeddedforPointofService, "CIMOS_WindowsEmbeddedforPointofService" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMicrosoftWindowsServer2008, "CIMOS_MicrosoftWindowsServer2008" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMicrosoftWindowsServer2008_USCORE64, "CIMOS_MicrosoftWindowsServer2008_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREFreeBSD_USCORE64, "CIMOS_FreeBSD_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORERedHatEnterpriseLinux, "CIMOS_RedHatEnterpriseLinux" },
	{ (long)vbox__CIMOSType__CIMOS_USCORERedHatEnterpriseLinux_USCORE64, "CIMOS_RedHatEnterpriseLinux_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESolaris_USCORE64, "CIMOS_Solaris_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESUSE, "CIMOS_SUSE" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESUSE_USCORE64, "CIMOS_SUSE_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESLES, "CIMOS_SLES" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESLES_USCORE64, "CIMOS_SLES_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENovellOES, "CIMOS_NovellOES" },
	{ (long)vbox__CIMOSType__CIMOS_USCORENovellLinuxDesktop, "CIMOS_NovellLinuxDesktop" },
	{ (long)vbox__CIMOSType__CIMOS_USCORESunJavaDesktopSystem, "CIMOS_SunJavaDesktopSystem" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMandriva, "CIMOS_Mandriva" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREMandriva_USCORE64, "CIMOS_Mandriva_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORETurboLinux, "CIMOS_TurboLinux" },
	{ (long)vbox__CIMOSType__CIMOS_USCORETurboLinux_USCORE64, "CIMOS_TurboLinux_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREUbuntu, "CIMOS_Ubuntu" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREUbuntu_USCORE64, "CIMOS_Ubuntu_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREDebian, "CIMOS_Debian" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREDebian_USCORE64, "CIMOS_Debian_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELinux_USCORE2_USCORE4_USCOREx, "CIMOS_Linux_2_4_x" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELinux_USCORE2_USCORE4_USCOREx_USCORE64, "CIMOS_Linux_2_4_x_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELinux_USCORE2_USCORE6_USCOREx, "CIMOS_Linux_2_6_x" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELinux_USCORE2_USCORE6_USCOREx_USCORE64, "CIMOS_Linux_2_6_x_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCORELinux_USCORE64, "CIMOS_Linux_64" },
	{ (long)vbox__CIMOSType__CIMOS_USCOREOther_USCORE64, "CIMOS_Other_64" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CIMOSType2s(struct soap *soap, enum vbox__CIMOSType n)
{	const char *s = soap_code_str(soap_codes_vbox__CIMOSType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CIMOSType(struct soap *soap, const char *tag, int id, const enum vbox__CIMOSType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CIMOSType), type) || soap_send(soap, soap_vbox__CIMOSType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__CIMOSType * SOAP_FMAC4 soap_get_vbox__CIMOSType(struct soap *soap, enum vbox__CIMOSType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CIMOSType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CIMOSType(struct soap *soap, const char *s, enum vbox__CIMOSType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__CIMOSType, s);
	if (map)
		*a = (enum vbox__CIMOSType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 102)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CIMOSType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CIMOSType * SOAP_FMAC4 soap_in_vbox__CIMOSType(struct soap *soap, const char *tag, enum vbox__CIMOSType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CIMOSType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CIMOSType, sizeof(enum vbox__CIMOSType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__CIMOSType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CIMOSType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CIMOSType, 0, sizeof(enum vbox__CIMOSType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VFSFileType(struct soap *soap, enum vbox__VFSFileType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VFSFileType
	*a = SOAP_DEFAULT_vbox__VFSFileType;
#else
	*a = (enum vbox__VFSFileType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VFSFileType(struct soap *soap, const enum vbox__VFSFileType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VFSFileType);
	if (soap_out_vbox__VFSFileType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VFSFileType[] =
{	{ (long)vbox__VFSFileType__Unknown, "Unknown" },
	{ (long)vbox__VFSFileType__Fifo, "Fifo" },
	{ (long)vbox__VFSFileType__DevChar, "DevChar" },
	{ (long)vbox__VFSFileType__Directory, "Directory" },
	{ (long)vbox__VFSFileType__DevBlock, "DevBlock" },
	{ (long)vbox__VFSFileType__File, "File" },
	{ (long)vbox__VFSFileType__SymLink, "SymLink" },
	{ (long)vbox__VFSFileType__Socket, "Socket" },
	{ (long)vbox__VFSFileType__WhiteOut, "WhiteOut" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VFSFileType2s(struct soap *soap, enum vbox__VFSFileType n)
{	const char *s = soap_code_str(soap_codes_vbox__VFSFileType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VFSFileType(struct soap *soap, const char *tag, int id, const enum vbox__VFSFileType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VFSFileType), type) || soap_send(soap, soap_vbox__VFSFileType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VFSFileType * SOAP_FMAC4 soap_get_vbox__VFSFileType(struct soap *soap, enum vbox__VFSFileType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VFSFileType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VFSFileType(struct soap *soap, const char *s, enum vbox__VFSFileType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VFSFileType, s);
	if (map)
		*a = (enum vbox__VFSFileType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VFSFileType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VFSFileType * SOAP_FMAC4 soap_in_vbox__VFSFileType(struct soap *soap, const char *tag, enum vbox__VFSFileType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VFSFileType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VFSFileType, sizeof(enum vbox__VFSFileType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VFSFileType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VFSFileType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VFSFileType, 0, sizeof(enum vbox__VFSFileType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VFSType(struct soap *soap, enum vbox__VFSType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VFSType
	*a = SOAP_DEFAULT_vbox__VFSType;
#else
	*a = (enum vbox__VFSType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VFSType(struct soap *soap, const enum vbox__VFSType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__VFSType);
	if (soap_out_vbox__VFSType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__VFSType[] =
{	{ (long)vbox__VFSType__File, "File" },
	{ (long)vbox__VFSType__Cloud, "Cloud" },
	{ (long)vbox__VFSType__S3, "S3" },
	{ (long)vbox__VFSType__WebDav, "WebDav" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VFSType2s(struct soap *soap, enum vbox__VFSType n)
{	const char *s = soap_code_str(soap_codes_vbox__VFSType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VFSType(struct soap *soap, const char *tag, int id, const enum vbox__VFSType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VFSType), type) || soap_send(soap, soap_vbox__VFSType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__VFSType * SOAP_FMAC4 soap_get_vbox__VFSType(struct soap *soap, enum vbox__VFSType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VFSType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VFSType(struct soap *soap, const char *s, enum vbox__VFSType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VFSType, s);
	if (map)
		*a = (enum vbox__VFSType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VFSType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VFSType * SOAP_FMAC4 soap_in_vbox__VFSType(struct soap *soap, const char *tag, enum vbox__VFSType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VFSType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VFSType, sizeof(enum vbox__VFSType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__VFSType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VFSType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VFSType, 0, sizeof(enum vbox__VFSType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessorFeature
	*a = SOAP_DEFAULT_vbox__ProcessorFeature;
#else
	*a = (enum vbox__ProcessorFeature)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessorFeature(struct soap *soap, const enum vbox__ProcessorFeature *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__ProcessorFeature);
	if (soap_out_vbox__ProcessorFeature(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__ProcessorFeature[] =
{	{ (long)vbox__ProcessorFeature__HWVirtEx, "HWVirtEx" },
	{ (long)vbox__ProcessorFeature__PAE, "PAE" },
	{ (long)vbox__ProcessorFeature__LongMode, "LongMode" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessorFeature2s(struct soap *soap, enum vbox__ProcessorFeature n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessorFeature, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessorFeature(struct soap *soap, const char *tag, int id, const enum vbox__ProcessorFeature *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessorFeature), type) || soap_send(soap, soap_vbox__ProcessorFeature2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__ProcessorFeature * SOAP_FMAC4 soap_get_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessorFeature(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessorFeature(struct soap *soap, const char *s, enum vbox__ProcessorFeature *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessorFeature, s);
	if (map)
		*a = (enum vbox__ProcessorFeature)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessorFeature)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessorFeature * SOAP_FMAC4 soap_in_vbox__ProcessorFeature(struct soap *soap, const char *tag, enum vbox__ProcessorFeature *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessorFeature *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessorFeature, sizeof(enum vbox__ProcessorFeature), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__ProcessorFeature(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessorFeature *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessorFeature, 0, sizeof(enum vbox__ProcessorFeature), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DriveState(struct soap *soap, enum vbox__DriveState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DriveState
	*a = SOAP_DEFAULT_vbox__DriveState;
#else
	*a = (enum vbox__DriveState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DriveState(struct soap *soap, const enum vbox__DriveState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DriveState);
	if (soap_out_vbox__DriveState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DriveState[] =
{	{ (long)vbox__DriveState__Null, "Null" },
	{ (long)vbox__DriveState__NotMounted, "NotMounted" },
	{ (long)vbox__DriveState__ImageMounted, "ImageMounted" },
	{ (long)vbox__DriveState__HostDriveCaptured, "HostDriveCaptured" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DriveState2s(struct soap *soap, enum vbox__DriveState n)
{	const char *s = soap_code_str(soap_codes_vbox__DriveState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DriveState(struct soap *soap, const char *tag, int id, const enum vbox__DriveState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DriveState), type) || soap_send(soap, soap_vbox__DriveState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DriveState * SOAP_FMAC4 soap_get_vbox__DriveState(struct soap *soap, enum vbox__DriveState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DriveState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DriveState(struct soap *soap, const char *s, enum vbox__DriveState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DriveState, s);
	if (map)
		*a = (enum vbox__DriveState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DriveState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DriveState * SOAP_FMAC4 soap_in_vbox__DriveState(struct soap *soap, const char *tag, enum vbox__DriveState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DriveState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DriveState, sizeof(enum vbox__DriveState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DriveState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DriveState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DriveState, 0, sizeof(enum vbox__DriveState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__BIOSBootMenuMode(struct soap *soap, enum vbox__BIOSBootMenuMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BIOSBootMenuMode
	*a = SOAP_DEFAULT_vbox__BIOSBootMenuMode;
#else
	*a = (enum vbox__BIOSBootMenuMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__BIOSBootMenuMode(struct soap *soap, const enum vbox__BIOSBootMenuMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__BIOSBootMenuMode);
	if (soap_out_vbox__BIOSBootMenuMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__BIOSBootMenuMode[] =
{	{ (long)vbox__BIOSBootMenuMode__Disabled, "Disabled" },
	{ (long)vbox__BIOSBootMenuMode__MenuOnly, "MenuOnly" },
	{ (long)vbox__BIOSBootMenuMode__MessageAndMenu, "MessageAndMenu" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__BIOSBootMenuMode2s(struct soap *soap, enum vbox__BIOSBootMenuMode n)
{	const char *s = soap_code_str(soap_codes_vbox__BIOSBootMenuMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__BIOSBootMenuMode(struct soap *soap, const char *tag, int id, const enum vbox__BIOSBootMenuMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__BIOSBootMenuMode), type) || soap_send(soap, soap_vbox__BIOSBootMenuMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__BIOSBootMenuMode * SOAP_FMAC4 soap_get_vbox__BIOSBootMenuMode(struct soap *soap, enum vbox__BIOSBootMenuMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__BIOSBootMenuMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__BIOSBootMenuMode(struct soap *soap, const char *s, enum vbox__BIOSBootMenuMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__BIOSBootMenuMode, s);
	if (map)
		*a = (enum vbox__BIOSBootMenuMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__BIOSBootMenuMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__BIOSBootMenuMode * SOAP_FMAC4 soap_in_vbox__BIOSBootMenuMode(struct soap *soap, const char *tag, enum vbox__BIOSBootMenuMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__BIOSBootMenuMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__BIOSBootMenuMode, sizeof(enum vbox__BIOSBootMenuMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__BIOSBootMenuMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__BIOSBootMenuMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__BIOSBootMenuMode, 0, sizeof(enum vbox__BIOSBootMenuMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestStatisticType(struct soap *soap, enum vbox__GuestStatisticType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestStatisticType
	*a = SOAP_DEFAULT_vbox__GuestStatisticType;
#else
	*a = (enum vbox__GuestStatisticType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestStatisticType(struct soap *soap, const enum vbox__GuestStatisticType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__GuestStatisticType);
	if (soap_out_vbox__GuestStatisticType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__GuestStatisticType[] =
{	{ (long)vbox__GuestStatisticType__CPULoad_USCOREIdle, "CPULoad_Idle" },
	{ (long)vbox__GuestStatisticType__CPULoad_USCOREKernel, "CPULoad_Kernel" },
	{ (long)vbox__GuestStatisticType__CPULoad_USCOREUser, "CPULoad_User" },
	{ (long)vbox__GuestStatisticType__Threads, "Threads" },
	{ (long)vbox__GuestStatisticType__Processes, "Processes" },
	{ (long)vbox__GuestStatisticType__Handles, "Handles" },
	{ (long)vbox__GuestStatisticType__MemoryLoad, "MemoryLoad" },
	{ (long)vbox__GuestStatisticType__PhysMemTotal, "PhysMemTotal" },
	{ (long)vbox__GuestStatisticType__PhysMemAvailable, "PhysMemAvailable" },
	{ (long)vbox__GuestStatisticType__PhysMemBalloon, "PhysMemBalloon" },
	{ (long)vbox__GuestStatisticType__MemCommitTotal, "MemCommitTotal" },
	{ (long)vbox__GuestStatisticType__MemKernelTotal, "MemKernelTotal" },
	{ (long)vbox__GuestStatisticType__MemKernelPaged, "MemKernelPaged" },
	{ (long)vbox__GuestStatisticType__MemKernelNonpaged, "MemKernelNonpaged" },
	{ (long)vbox__GuestStatisticType__MemSystemCache, "MemSystemCache" },
	{ (long)vbox__GuestStatisticType__PageFileSize, "PageFileSize" },
	{ (long)vbox__GuestStatisticType__SampleNumber, "SampleNumber" },
	{ (long)vbox__GuestStatisticType__MaxVal, "MaxVal" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestStatisticType2s(struct soap *soap, enum vbox__GuestStatisticType n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestStatisticType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestStatisticType(struct soap *soap, const char *tag, int id, const enum vbox__GuestStatisticType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestStatisticType), type) || soap_send(soap, soap_vbox__GuestStatisticType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__GuestStatisticType * SOAP_FMAC4 soap_get_vbox__GuestStatisticType(struct soap *soap, enum vbox__GuestStatisticType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestStatisticType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestStatisticType(struct soap *soap, const char *s, enum vbox__GuestStatisticType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestStatisticType, s);
	if (map)
		*a = (enum vbox__GuestStatisticType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 17)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestStatisticType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestStatisticType * SOAP_FMAC4 soap_in_vbox__GuestStatisticType(struct soap *soap, const char *tag, enum vbox__GuestStatisticType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestStatisticType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestStatisticType, sizeof(enum vbox__GuestStatisticType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__GuestStatisticType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestStatisticType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestStatisticType, 0, sizeof(enum vbox__GuestStatisticType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__Scope(struct soap *soap, enum vbox__Scope *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__Scope
	*a = SOAP_DEFAULT_vbox__Scope;
#else
	*a = (enum vbox__Scope)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__Scope(struct soap *soap, const enum vbox__Scope *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__Scope);
	if (soap_out_vbox__Scope(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__Scope[] =
{	{ (long)vbox__Scope__Global, "Global" },
	{ (long)vbox__Scope__Machine, "Machine" },
	{ (long)vbox__Scope__Session, "Session" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__Scope2s(struct soap *soap, enum vbox__Scope n)
{	const char *s = soap_code_str(soap_codes_vbox__Scope, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__Scope(struct soap *soap, const char *tag, int id, const enum vbox__Scope *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__Scope), type) || soap_send(soap, soap_vbox__Scope2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__Scope * SOAP_FMAC4 soap_get_vbox__Scope(struct soap *soap, enum vbox__Scope *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__Scope(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__Scope(struct soap *soap, const char *s, enum vbox__Scope *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__Scope, s);
	if (map)
		*a = (enum vbox__Scope)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__Scope)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__Scope * SOAP_FMAC4 soap_in_vbox__Scope(struct soap *soap, const char *tag, enum vbox__Scope *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__Scope *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__Scope, sizeof(enum vbox__Scope), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__Scope(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__Scope *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__Scope, 0, sizeof(enum vbox__Scope), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ClipboardMode
	*a = SOAP_DEFAULT_vbox__ClipboardMode;
#else
	*a = (enum vbox__ClipboardMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ClipboardMode(struct soap *soap, const enum vbox__ClipboardMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__ClipboardMode);
	if (soap_out_vbox__ClipboardMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__ClipboardMode[] =
{	{ (long)vbox__ClipboardMode__Disabled, "Disabled" },
	{ (long)vbox__ClipboardMode__HostToGuest, "HostToGuest" },
	{ (long)vbox__ClipboardMode__GuestToHost, "GuestToHost" },
	{ (long)vbox__ClipboardMode__Bidirectional, "Bidirectional" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ClipboardMode2s(struct soap *soap, enum vbox__ClipboardMode n)
{	const char *s = soap_code_str(soap_codes_vbox__ClipboardMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ClipboardMode(struct soap *soap, const char *tag, int id, const enum vbox__ClipboardMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ClipboardMode), type) || soap_send(soap, soap_vbox__ClipboardMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__ClipboardMode * SOAP_FMAC4 soap_get_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ClipboardMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ClipboardMode(struct soap *soap, const char *s, enum vbox__ClipboardMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ClipboardMode, s);
	if (map)
		*a = (enum vbox__ClipboardMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ClipboardMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ClipboardMode * SOAP_FMAC4 soap_in_vbox__ClipboardMode(struct soap *soap, const char *tag, enum vbox__ClipboardMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ClipboardMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ClipboardMode, sizeof(enum vbox__ClipboardMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__ClipboardMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ClipboardMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ClipboardMode, 0, sizeof(enum vbox__ClipboardMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceActivity
	*a = SOAP_DEFAULT_vbox__DeviceActivity;
#else
	*a = (enum vbox__DeviceActivity)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DeviceActivity(struct soap *soap, const enum vbox__DeviceActivity *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DeviceActivity);
	if (soap_out_vbox__DeviceActivity(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DeviceActivity[] =
{	{ (long)vbox__DeviceActivity__Null, "Null" },
	{ (long)vbox__DeviceActivity__Idle, "Idle" },
	{ (long)vbox__DeviceActivity__Reading, "Reading" },
	{ (long)vbox__DeviceActivity__Writing, "Writing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DeviceActivity2s(struct soap *soap, enum vbox__DeviceActivity n)
{	const char *s = soap_code_str(soap_codes_vbox__DeviceActivity, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DeviceActivity(struct soap *soap, const char *tag, int id, const enum vbox__DeviceActivity *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DeviceActivity), type) || soap_send(soap, soap_vbox__DeviceActivity2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DeviceActivity * SOAP_FMAC4 soap_get_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DeviceActivity(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DeviceActivity(struct soap *soap, const char *s, enum vbox__DeviceActivity *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DeviceActivity, s);
	if (map)
		*a = (enum vbox__DeviceActivity)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DeviceActivity)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DeviceActivity * SOAP_FMAC4 soap_in_vbox__DeviceActivity(struct soap *soap, const char *tag, enum vbox__DeviceActivity *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DeviceActivity *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DeviceActivity, sizeof(enum vbox__DeviceActivity), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DeviceActivity(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DeviceActivity *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DeviceActivity, 0, sizeof(enum vbox__DeviceActivity), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceType
	*a = SOAP_DEFAULT_vbox__DeviceType;
#else
	*a = (enum vbox__DeviceType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DeviceType(struct soap *soap, const enum vbox__DeviceType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__DeviceType);
	if (soap_out_vbox__DeviceType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__DeviceType[] =
{	{ (long)vbox__DeviceType__Null, "Null" },
	{ (long)vbox__DeviceType__Floppy, "Floppy" },
	{ (long)vbox__DeviceType__DVD, "DVD" },
	{ (long)vbox__DeviceType__HardDisk, "HardDisk" },
	{ (long)vbox__DeviceType__Network, "Network" },
	{ (long)vbox__DeviceType__USB, "USB" },
	{ (long)vbox__DeviceType__SharedFolder, "SharedFolder" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DeviceType2s(struct soap *soap, enum vbox__DeviceType n)
{	const char *s = soap_code_str(soap_codes_vbox__DeviceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DeviceType(struct soap *soap, const char *tag, int id, const enum vbox__DeviceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DeviceType), type) || soap_send(soap, soap_vbox__DeviceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__DeviceType * SOAP_FMAC4 soap_get_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DeviceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DeviceType(struct soap *soap, const char *s, enum vbox__DeviceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DeviceType, s);
	if (map)
		*a = (enum vbox__DeviceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DeviceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DeviceType * SOAP_FMAC4 soap_in_vbox__DeviceType(struct soap *soap, const char *tag, enum vbox__DeviceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DeviceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DeviceType, sizeof(enum vbox__DeviceType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__DeviceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DeviceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DeviceType, 0, sizeof(enum vbox__DeviceType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SessionType(struct soap *soap, enum vbox__SessionType *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionType
	*a = SOAP_DEFAULT_vbox__SessionType;
#else
	*a = (enum vbox__SessionType)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SessionType(struct soap *soap, const enum vbox__SessionType *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__SessionType);
	if (soap_out_vbox__SessionType(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__SessionType[] =
{	{ (long)vbox__SessionType__Null, "Null" },
	{ (long)vbox__SessionType__Direct, "Direct" },
	{ (long)vbox__SessionType__Remote, "Remote" },
	{ (long)vbox__SessionType__Existing, "Existing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SessionType2s(struct soap *soap, enum vbox__SessionType n)
{	const char *s = soap_code_str(soap_codes_vbox__SessionType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SessionType(struct soap *soap, const char *tag, int id, const enum vbox__SessionType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SessionType), type) || soap_send(soap, soap_vbox__SessionType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__SessionType * SOAP_FMAC4 soap_get_vbox__SessionType(struct soap *soap, enum vbox__SessionType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SessionType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SessionType(struct soap *soap, const char *s, enum vbox__SessionType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SessionType, s);
	if (map)
		*a = (enum vbox__SessionType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SessionType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SessionType * SOAP_FMAC4 soap_in_vbox__SessionType(struct soap *soap, const char *tag, enum vbox__SessionType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SessionType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SessionType, sizeof(enum vbox__SessionType), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__SessionType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SessionType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SessionType, 0, sizeof(enum vbox__SessionType), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SessionState(struct soap *soap, enum vbox__SessionState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionState
	*a = SOAP_DEFAULT_vbox__SessionState;
#else
	*a = (enum vbox__SessionState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SessionState(struct soap *soap, const enum vbox__SessionState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__SessionState);
	if (soap_out_vbox__SessionState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__SessionState[] =
{	{ (long)vbox__SessionState__Null, "Null" },
	{ (long)vbox__SessionState__Closed, "Closed" },
	{ (long)vbox__SessionState__Open, "Open" },
	{ (long)vbox__SessionState__Spawning, "Spawning" },
	{ (long)vbox__SessionState__Closing, "Closing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SessionState2s(struct soap *soap, enum vbox__SessionState n)
{	const char *s = soap_code_str(soap_codes_vbox__SessionState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SessionState(struct soap *soap, const char *tag, int id, const enum vbox__SessionState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SessionState), type) || soap_send(soap, soap_vbox__SessionState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__SessionState * SOAP_FMAC4 soap_get_vbox__SessionState(struct soap *soap, enum vbox__SessionState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SessionState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SessionState(struct soap *soap, const char *s, enum vbox__SessionState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SessionState, s);
	if (map)
		*a = (enum vbox__SessionState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SessionState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SessionState * SOAP_FMAC4 soap_in_vbox__SessionState(struct soap *soap, const char *tag, enum vbox__SessionState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SessionState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SessionState, sizeof(enum vbox__SessionState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__SessionState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SessionState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SessionState, 0, sizeof(enum vbox__SessionState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MachineState(struct soap *soap, enum vbox__MachineState *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MachineState
	*a = SOAP_DEFAULT_vbox__MachineState;
#else
	*a = (enum vbox__MachineState)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MachineState(struct soap *soap, const enum vbox__MachineState *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__MachineState);
	if (soap_out_vbox__MachineState(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__MachineState[] =
{	{ (long)vbox__MachineState__Null, "Null" },
	{ (long)vbox__MachineState__PoweredOff, "PoweredOff" },
	{ (long)vbox__MachineState__Saved, "Saved" },
	{ (long)vbox__MachineState__Aborted, "Aborted" },
	{ (long)vbox__MachineState__Running, "Running" },
	{ (long)vbox__MachineState__Paused, "Paused" },
	{ (long)vbox__MachineState__Stuck, "Stuck" },
	{ (long)vbox__MachineState__Starting, "Starting" },
	{ (long)vbox__MachineState__Stopping, "Stopping" },
	{ (long)vbox__MachineState__Saving, "Saving" },
	{ (long)vbox__MachineState__Restoring, "Restoring" },
	{ (long)vbox__MachineState__Discarding, "Discarding" },
	{ (long)vbox__MachineState__SettingUp, "SettingUp" },
	{ (long)vbox__MachineState__FirstOnline, "FirstOnline" },
	{ (long)vbox__MachineState__LastOnline, "LastOnline" },
	{ (long)vbox__MachineState__FirstTransient, "FirstTransient" },
	{ (long)vbox__MachineState__LastTransient, "LastTransient" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MachineState2s(struct soap *soap, enum vbox__MachineState n)
{	const char *s = soap_code_str(soap_codes_vbox__MachineState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MachineState(struct soap *soap, const char *tag, int id, const enum vbox__MachineState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MachineState), type) || soap_send(soap, soap_vbox__MachineState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__MachineState * SOAP_FMAC4 soap_get_vbox__MachineState(struct soap *soap, enum vbox__MachineState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MachineState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MachineState(struct soap *soap, const char *s, enum vbox__MachineState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MachineState, s);
	if (map)
		*a = (enum vbox__MachineState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 16)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MachineState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MachineState * SOAP_FMAC4 soap_in_vbox__MachineState(struct soap *soap, const char *tag, enum vbox__MachineState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MachineState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MachineState, sizeof(enum vbox__MachineState), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__MachineState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MachineState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MachineState, 0, sizeof(enum vbox__MachineState), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *a)
{	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AccessMode
	*a = SOAP_DEFAULT_vbox__AccessMode;
#else
	*a = (enum vbox__AccessMode)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AccessMode(struct soap *soap, const enum vbox__AccessMode *a, const char *tag, const char *type)
{
	register int id = soap_embed(soap, (void*)a, NULL, 0, tag, SOAP_TYPE_vbox__AccessMode);
	if (soap_out_vbox__AccessMode(soap, tag, id, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

static const struct soap_code_map soap_codes_vbox__AccessMode[] =
{	{ (long)vbox__AccessMode__ReadOnly, "ReadOnly" },
	{ (long)vbox__AccessMode__ReadWrite, "ReadWrite" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AccessMode2s(struct soap *soap, enum vbox__AccessMode n)
{	const char *s = soap_code_str(soap_codes_vbox__AccessMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AccessMode(struct soap *soap, const char *tag, int id, const enum vbox__AccessMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AccessMode), type) || soap_send(soap, soap_vbox__AccessMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3 enum vbox__AccessMode * SOAP_FMAC4 soap_get_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AccessMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AccessMode(struct soap *soap, const char *s, enum vbox__AccessMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AccessMode, s);
	if (map)
		*a = (enum vbox__AccessMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AccessMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AccessMode * SOAP_FMAC4 soap_in_vbox__AccessMode(struct soap *soap, const char *tag, enum vbox__AccessMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AccessMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AccessMode, sizeof(enum vbox__AccessMode), 0, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (!a || soap_s2vbox__AccessMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AccessMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AccessMode, 0, sizeof(enum vbox__AccessMode), 0, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

void _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices);
	soap_default_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths);
	soap_default_std__vectorTemplateOfint(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices);
	soap_serialize_std__vectorTemplateOfunsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths);
	soap_serialize_std__vectorTemplateOfint(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnMetricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnObjects", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnUnits", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnScales", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnSequenceNumbers", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnDataIndices", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfunsignedInt(soap, "returnDataLengths", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfint(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse, sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnMetricNames", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnObjects", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnUnits", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfunsignedInt(soap, "returnScales", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales), "xsd:unsignedInt"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfunsignedInt(soap, "returnSequenceNumbers", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers), "xsd:unsignedInt"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfunsignedInt(soap, "returnDataIndices", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices), "xsd:unsignedInt"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfunsignedInt(soap, "returnDataLengths", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths), "xsd:unsignedInt"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfint(soap, "returnval", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval), "xsd:int"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse, 0, sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse), 0, soap_copy__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnMetricNames.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnObjects.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnUnits.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnScales.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnSequenceNumbers.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataIndices.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnDataLengths.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse::returnval.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse);
		((_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)p = *(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)q;
}

void _vbox__IPerformanceCollector_USCOREqueryMetricsData::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsData::_USCOREthis);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsData::metricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsData::objects);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREqueryMetricsData::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsData::_USCOREthis);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsData::metricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREqueryMetricsData::objects);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREqueryMetricsData::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREqueryMetricsData::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREqueryMetricsData(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREqueryMetricsData(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREqueryMetricsData *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::_USCOREthis), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "metricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::metricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "objects", -1, &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::objects), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREqueryMetricsData::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREqueryMetricsData(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsData * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREqueryMetricsData(struct soap *soap, _vbox__IPerformanceCollector_USCOREqueryMetricsData *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsData(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREqueryMetricsData::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsData(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsData * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREqueryMetricsData(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREqueryMetricsData *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREqueryMetricsData *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData, sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsData), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREqueryMetricsData *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "metricNames", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::metricNames), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "objects", &(a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::objects), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREqueryMetricsData *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData, 0, sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsData), 0, soap_copy__vbox__IPerformanceCollector_USCOREqueryMetricsData);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::metricNames.size() < 1 || a->_vbox__IPerformanceCollector_USCOREqueryMetricsData::objects.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREqueryMetricsData * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREqueryMetricsData(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREqueryMetricsData(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREqueryMetricsData;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsData);
		((_vbox__IPerformanceCollector_USCOREqueryMetricsData*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREqueryMetricsData[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREqueryMetricsData);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREqueryMetricsData*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREqueryMetricsData*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREqueryMetricsData(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREqueryMetricsData %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREqueryMetricsData*)p = *(_vbox__IPerformanceCollector_USCOREqueryMetricsData*)q;
}

void _vbox__IPerformanceCollector_USCOREdisableMetricsResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREdisableMetricsResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREdisableMetricsResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREdisableMetricsResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREdisableMetricsResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREdisableMetricsResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREdisableMetricsResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREdisableMetricsResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREdisableMetricsResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREdisableMetricsResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse, sizeof(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREdisableMetricsResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnval", &(a->_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::returnval), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREdisableMetricsResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse, 0, sizeof(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse), 0, soap_copy__vbox__IPerformanceCollector_USCOREdisableMetricsResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (a->_vbox__IPerformanceCollector_USCOREdisableMetricsResponse::returnval.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREdisableMetricsResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREdisableMetricsResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse);
		((_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREdisableMetricsResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREdisableMetricsResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREdisableMetricsResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)q;
}

void _vbox__IPerformanceCollector_USCOREdisableMetrics::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetrics::_USCOREthis);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetrics::metricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetrics::objects);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREdisableMetrics::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetrics::_USCOREthis);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetrics::metricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREdisableMetrics::objects);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREdisableMetrics::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREdisableMetrics::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREdisableMetrics(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREdisableMetrics(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREdisableMetrics *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceCollector_USCOREdisableMetrics::_USCOREthis), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "metricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREdisableMetrics::metricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "objects", -1, &(a->_vbox__IPerformanceCollector_USCOREdisableMetrics::objects), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREdisableMetrics::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREdisableMetrics(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREdisableMetrics * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREdisableMetrics(struct soap *soap, _vbox__IPerformanceCollector_USCOREdisableMetrics *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREdisableMetrics(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREdisableMetrics::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREdisableMetrics(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREdisableMetrics * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREdisableMetrics(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREdisableMetrics *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREdisableMetrics *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics, sizeof(_vbox__IPerformanceCollector_USCOREdisableMetrics), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREdisableMetrics *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceCollector_USCOREdisableMetrics::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "metricNames", &(a->_vbox__IPerformanceCollector_USCOREdisableMetrics::metricNames), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "objects", &(a->_vbox__IPerformanceCollector_USCOREdisableMetrics::objects), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREdisableMetrics *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics, 0, sizeof(_vbox__IPerformanceCollector_USCOREdisableMetrics), 0, soap_copy__vbox__IPerformanceCollector_USCOREdisableMetrics);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || a->_vbox__IPerformanceCollector_USCOREdisableMetrics::metricNames.size() < 1 || a->_vbox__IPerformanceCollector_USCOREdisableMetrics::objects.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREdisableMetrics * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREdisableMetrics(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREdisableMetrics(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREdisableMetrics;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREdisableMetrics);
		((_vbox__IPerformanceCollector_USCOREdisableMetrics*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREdisableMetrics[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREdisableMetrics);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREdisableMetrics*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREdisableMetrics*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREdisableMetrics(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREdisableMetrics %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREdisableMetrics*)p = *(_vbox__IPerformanceCollector_USCOREdisableMetrics*)q;
}

void _vbox__IPerformanceCollector_USCOREenableMetricsResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetricsResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREenableMetricsResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetricsResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREenableMetricsResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREenableMetricsResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREenableMetricsResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREenableMetricsResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREenableMetricsResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREenableMetricsResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREenableMetricsResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREenableMetricsResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREenableMetricsResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREenableMetricsResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREenableMetricsResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREenableMetricsResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREenableMetricsResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREenableMetricsResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREenableMetricsResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREenableMetricsResponse(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREenableMetricsResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREenableMetricsResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse, sizeof(_vbox__IPerformanceCollector_USCOREenableMetricsResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREenableMetricsResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnval", &(a->_vbox__IPerformanceCollector_USCOREenableMetricsResponse::returnval), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREenableMetricsResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse, 0, sizeof(_vbox__IPerformanceCollector_USCOREenableMetricsResponse), 0, soap_copy__vbox__IPerformanceCollector_USCOREenableMetricsResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (a->_vbox__IPerformanceCollector_USCOREenableMetricsResponse::returnval.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREenableMetricsResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREenableMetricsResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREenableMetricsResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREenableMetricsResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREenableMetricsResponse);
		((_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREenableMetricsResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREenableMetricsResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREenableMetricsResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREenableMetricsResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)q;
}

void _vbox__IPerformanceCollector_USCOREenableMetrics::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetrics::_USCOREthis);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetrics::metricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetrics::objects);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREenableMetrics::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetrics::_USCOREthis);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetrics::metricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREenableMetrics::objects);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREenableMetrics::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREenableMetrics::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREenableMetrics(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREenableMetrics(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREenableMetrics *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceCollector_USCOREenableMetrics::_USCOREthis), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "metricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREenableMetrics::metricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "objects", -1, &(a->_vbox__IPerformanceCollector_USCOREenableMetrics::objects), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREenableMetrics::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREenableMetrics(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREenableMetrics * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREenableMetrics(struct soap *soap, _vbox__IPerformanceCollector_USCOREenableMetrics *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREenableMetrics(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREenableMetrics::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREenableMetrics(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREenableMetrics * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREenableMetrics(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREenableMetrics *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREenableMetrics *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics, sizeof(_vbox__IPerformanceCollector_USCOREenableMetrics), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREenableMetrics *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceCollector_USCOREenableMetrics::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "metricNames", &(a->_vbox__IPerformanceCollector_USCOREenableMetrics::metricNames), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "objects", &(a->_vbox__IPerformanceCollector_USCOREenableMetrics::objects), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREenableMetrics *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics, 0, sizeof(_vbox__IPerformanceCollector_USCOREenableMetrics), 0, soap_copy__vbox__IPerformanceCollector_USCOREenableMetrics);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || a->_vbox__IPerformanceCollector_USCOREenableMetrics::metricNames.size() < 1 || a->_vbox__IPerformanceCollector_USCOREenableMetrics::objects.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREenableMetrics * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREenableMetrics(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREenableMetrics(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREenableMetrics;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREenableMetrics);
		((_vbox__IPerformanceCollector_USCOREenableMetrics*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREenableMetrics[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREenableMetrics);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREenableMetrics*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREenableMetrics*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREenableMetrics(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREenableMetrics %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREenableMetrics*)p = *(_vbox__IPerformanceCollector_USCOREenableMetrics*)q;
}

void _vbox__IPerformanceCollector_USCOREsetupMetricsResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREsetupMetricsResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREsetupMetricsResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREsetupMetricsResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREsetupMetricsResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREsetupMetricsResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREsetupMetricsResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREsetupMetricsResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREsetupMetricsResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREsetupMetricsResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse, sizeof(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREsetupMetricsResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnval", &(a->_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::returnval), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREsetupMetricsResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse, 0, sizeof(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse), 0, soap_copy__vbox__IPerformanceCollector_USCOREsetupMetricsResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (a->_vbox__IPerformanceCollector_USCOREsetupMetricsResponse::returnval.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREsetupMetricsResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREsetupMetricsResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse);
		((_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREsetupMetricsResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREsetupMetricsResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREsetupMetricsResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)q;
}

void _vbox__IPerformanceCollector_USCOREsetupMetrics::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::_USCOREthis);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::metricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::objects);
	soap_default_unsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::period);
	soap_default_unsignedInt(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::count);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREsetupMetrics::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::_USCOREthis);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::metricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREsetupMetrics::objects);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREsetupMetrics::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREsetupMetrics::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREsetupMetrics(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREsetupMetrics(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREsetupMetrics *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::_USCOREthis), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "metricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::metricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "objects", -1, &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::objects), ""))
		return soap->error;
	if (soap_out_unsignedInt(soap, "period", -1, &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::period), ""))
		return soap->error;
	if (soap_out_unsignedInt(soap, "count", -1, &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::count), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREsetupMetrics::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREsetupMetrics(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREsetupMetrics * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREsetupMetrics(struct soap *soap, _vbox__IPerformanceCollector_USCOREsetupMetrics *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREsetupMetrics(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREsetupMetrics::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREsetupMetrics(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREsetupMetrics * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREsetupMetrics(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREsetupMetrics *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREsetupMetrics *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics, sizeof(_vbox__IPerformanceCollector_USCOREsetupMetrics), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREsetupMetrics *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_period1 = 1;
	size_t soap_flag_count1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "metricNames", &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::metricNames), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "objects", &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::objects), "xsd:string"))
					continue;
			if (soap_flag_period1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "period", &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::period), "xsd:unsignedInt"))
				{	soap_flag_period1--;
					continue;
				}
			if (soap_flag_count1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "count", &(a->_vbox__IPerformanceCollector_USCOREsetupMetrics::count), "xsd:unsignedInt"))
				{	soap_flag_count1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREsetupMetrics *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics, 0, sizeof(_vbox__IPerformanceCollector_USCOREsetupMetrics), 0, soap_copy__vbox__IPerformanceCollector_USCOREsetupMetrics);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || a->_vbox__IPerformanceCollector_USCOREsetupMetrics::metricNames.size() < 1 || a->_vbox__IPerformanceCollector_USCOREsetupMetrics::objects.size() < 1 || soap_flag_period1 > 0 || soap_flag_count1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREsetupMetrics * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREsetupMetrics(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREsetupMetrics(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREsetupMetrics;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREsetupMetrics);
		((_vbox__IPerformanceCollector_USCOREsetupMetrics*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREsetupMetrics[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREsetupMetrics);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREsetupMetrics*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREsetupMetrics*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREsetupMetrics(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREsetupMetrics %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREsetupMetrics*)p = *(_vbox__IPerformanceCollector_USCOREsetupMetrics*)q;
}

void _vbox__IPerformanceCollector_USCOREgetMetricsResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetricsResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREgetMetricsResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetricsResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREgetMetricsResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREgetMetricsResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREgetMetricsResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREgetMetricsResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREgetMetricsResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREgetMetricsResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREgetMetricsResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREgetMetricsResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricsResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREgetMetricsResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREgetMetricsResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREgetMetricsResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREgetMetricsResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREgetMetricsResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricsResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREgetMetricsResponse(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREgetMetricsResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREgetMetricsResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse, sizeof(_vbox__IPerformanceCollector_USCOREgetMetricsResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREgetMetricsResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnval", &(a->_vbox__IPerformanceCollector_USCOREgetMetricsResponse::returnval), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREgetMetricsResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse, 0, sizeof(_vbox__IPerformanceCollector_USCOREgetMetricsResponse), 0, soap_copy__vbox__IPerformanceCollector_USCOREgetMetricsResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (a->_vbox__IPerformanceCollector_USCOREgetMetricsResponse::returnval.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricsResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricsResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricsResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetricsResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREgetMetricsResponse);
		((_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetricsResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREgetMetricsResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREgetMetricsResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREgetMetricsResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)q;
}

void _vbox__IPerformanceCollector_USCOREgetMetrics::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetrics::_USCOREthis);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetrics::metricNames);
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetrics::objects);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREgetMetrics::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetrics::_USCOREthis);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetrics::metricNames);
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetrics::objects);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREgetMetrics::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREgetMetrics::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREgetMetrics(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREgetMetrics(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREgetMetrics *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceCollector_USCOREgetMetrics::_USCOREthis), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "metricNames", -1, &(a->_vbox__IPerformanceCollector_USCOREgetMetrics::metricNames), ""))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "objects", -1, &(a->_vbox__IPerformanceCollector_USCOREgetMetrics::objects), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREgetMetrics::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREgetMetrics(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetrics * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREgetMetrics(struct soap *soap, _vbox__IPerformanceCollector_USCOREgetMetrics *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREgetMetrics(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREgetMetrics::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREgetMetrics(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetrics * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREgetMetrics(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREgetMetrics *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREgetMetrics *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics, sizeof(_vbox__IPerformanceCollector_USCOREgetMetrics), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREgetMetrics *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceCollector_USCOREgetMetrics::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "metricNames", &(a->_vbox__IPerformanceCollector_USCOREgetMetrics::metricNames), "xsd:string"))
					continue;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "objects", &(a->_vbox__IPerformanceCollector_USCOREgetMetrics::objects), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREgetMetrics *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics, 0, sizeof(_vbox__IPerformanceCollector_USCOREgetMetrics), 0, soap_copy__vbox__IPerformanceCollector_USCOREgetMetrics);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || a->_vbox__IPerformanceCollector_USCOREgetMetrics::metricNames.size() < 1 || a->_vbox__IPerformanceCollector_USCOREgetMetrics::objects.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetrics * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetrics(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetrics(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetrics;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREgetMetrics);
		((_vbox__IPerformanceCollector_USCOREgetMetrics*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetrics[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREgetMetrics);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREgetMetrics*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREgetMetrics*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREgetMetrics(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREgetMetrics %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREgetMetrics*)p = *(_vbox__IPerformanceCollector_USCOREgetMetrics*)q;
}

void _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__vectorTemplateOfstd__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse), type))
		return soap->error;
	if (soap_out_std__vectorTemplateOfstd__string(soap, "returnval", -1, &(a->_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(struct soap *soap, _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse, sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_std__vectorTemplateOfstd__string(soap, "returnval", &(a->_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::returnval), "xsd:string"))
					continue;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse, 0, sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse), 0, soap_copy__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (a->_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse::returnval.size() < 1))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse);
		((_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)p = *(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)q;
}

void _vbox__IPerformanceCollector_USCOREgetMetricNames::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetricNames::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceCollector_USCOREgetMetricNames::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceCollector_USCOREgetMetricNames::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceCollector_USCOREgetMetricNames::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceCollector_USCOREgetMetricNames::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceCollector_USCOREgetMetricNames(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceCollector_USCOREgetMetricNames(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceCollector_USCOREgetMetricNames *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceCollector_USCOREgetMetricNames::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceCollector_USCOREgetMetricNames::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceCollector_USCOREgetMetricNames(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricNames * SOAP_FMAC4 soap_get__vbox__IPerformanceCollector_USCOREgetMetricNames(struct soap *soap, _vbox__IPerformanceCollector_USCOREgetMetricNames *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceCollector_USCOREgetMetricNames(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceCollector_USCOREgetMetricNames::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceCollector_USCOREgetMetricNames(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricNames * SOAP_FMAC4 soap_in__vbox__IPerformanceCollector_USCOREgetMetricNames(struct soap *soap, const char *tag, _vbox__IPerformanceCollector_USCOREgetMetricNames *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceCollector_USCOREgetMetricNames *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames, sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNames), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceCollector_USCOREgetMetricNames *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceCollector_USCOREgetMetricNames::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceCollector_USCOREgetMetricNames *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames, 0, sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNames), 0, soap_copy__vbox__IPerformanceCollector_USCOREgetMetricNames);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceCollector_USCOREgetMetricNames * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricNames(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceCollector_USCOREgetMetricNames(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetricNames;
		if (size)
			*size = sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNames);
		((_vbox__IPerformanceCollector_USCOREgetMetricNames*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceCollector_USCOREgetMetricNames[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceCollector_USCOREgetMetricNames);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceCollector_USCOREgetMetricNames*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceCollector_USCOREgetMetricNames*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceCollector_USCOREgetMetricNames(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceCollector_USCOREgetMetricNames %p -> %p\n", q, p));
	*(_vbox__IPerformanceCollector_USCOREgetMetricNames*)p = *(_vbox__IPerformanceCollector_USCOREgetMetricNames*)q;
}

void _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_int(soap, &this->_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse), type))
		return soap->error;
	if (soap_out_int(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_int(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse::returnval), "xsd:int"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse);
		((_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetMaximumValue::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMaximumValue::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetMaximumValue::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMaximumValue::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetMaximumValue::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetMaximumValue::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetMaximumValue(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetMaximumValue(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetMaximumValue *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetMaximumValue::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetMaximumValue::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetMaximumValue(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMaximumValue * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetMaximumValue(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetMaximumValue *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetMaximumValue(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetMaximumValue::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetMaximumValue(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMaximumValue * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetMaximumValue(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetMaximumValue *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetMaximumValue *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue, sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValue), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetMaximumValue *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetMaximumValue::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetMaximumValue *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValue), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetMaximumValue);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMaximumValue * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetMaximumValue(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetMaximumValue(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMaximumValue;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValue);
		((_vbox__IPerformanceMetric_USCOREgetMaximumValue*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMaximumValue[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetMaximumValue);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetMaximumValue*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetMaximumValue*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetMaximumValue(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetMaximumValue %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetMaximumValue*)p = *(_vbox__IPerformanceMetric_USCOREgetMaximumValue*)q;
}

void _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_int(soap, &this->_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse), type))
		return soap->error;
	if (soap_out_int(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_int(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse::returnval), "xsd:int"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse);
		((_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetMinimumValue::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMinimumValue::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetMinimumValue::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMinimumValue::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetMinimumValue::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetMinimumValue::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetMinimumValue(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetMinimumValue(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetMinimumValue *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetMinimumValue::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetMinimumValue::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetMinimumValue(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMinimumValue * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetMinimumValue(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetMinimumValue *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetMinimumValue(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetMinimumValue::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetMinimumValue(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMinimumValue * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetMinimumValue(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetMinimumValue *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetMinimumValue *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue, sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValue), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetMinimumValue *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetMinimumValue::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetMinimumValue *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValue), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetMinimumValue);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMinimumValue * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetMinimumValue(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetMinimumValue(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMinimumValue;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValue);
		((_vbox__IPerformanceMetric_USCOREgetMinimumValue*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMinimumValue[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetMinimumValue);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetMinimumValue*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetMinimumValue*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetMinimumValue(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetMinimumValue %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetMinimumValue*)p = *(_vbox__IPerformanceMetric_USCOREgetMinimumValue*)q;
}

void _vbox__IPerformanceMetric_USCOREgetUnitResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetUnitResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetUnitResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetUnitResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetUnitResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetUnitResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetUnitResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetUnitResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetUnitResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetUnitResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetUnitResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetUnitResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetUnitResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetUnitResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetUnitResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetUnitResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetUnitResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetUnitResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetUnitResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetUnitResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetUnitResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetUnitResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetUnitResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetUnitResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetUnitResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetUnitResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetUnitResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetUnitResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetUnitResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetUnitResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetUnitResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetUnitResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetUnitResponse);
		((_vbox__IPerformanceMetric_USCOREgetUnitResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetUnitResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetUnitResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetUnitResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetUnitResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetUnitResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetUnitResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetUnitResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetUnitResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetUnit::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetUnit::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetUnit::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetUnit::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetUnit::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetUnit::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetUnit(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetUnit(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetUnit *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetUnit::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetUnit::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetUnit(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetUnit * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetUnit(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetUnit *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetUnit(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetUnit::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetUnit(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetUnit * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetUnit(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetUnit *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetUnit *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit, sizeof(_vbox__IPerformanceMetric_USCOREgetUnit), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetUnit *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetUnit::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetUnit *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetUnit), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetUnit);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetUnit * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetUnit(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetUnit(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetUnit;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetUnit);
		((_vbox__IPerformanceMetric_USCOREgetUnit*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetUnit[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetUnit);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetUnit*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetUnit*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetUnit(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetUnit %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetUnit*)p = *(_vbox__IPerformanceMetric_USCOREgetUnit*)q;
}

void _vbox__IPerformanceMetric_USCOREgetCountResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IPerformanceMetric_USCOREgetCountResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetCountResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetCountResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetCountResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetCountResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetCountResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetCountResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetCountResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetCountResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetCountResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetCountResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetCountResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetCountResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetCountResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetCountResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetCountResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetCountResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetCountResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetCountResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetCountResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetCountResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetCountResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetCountResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetCountResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetCountResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetCountResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetCountResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetCountResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetCountResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetCountResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetCountResponse);
		((_vbox__IPerformanceMetric_USCOREgetCountResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetCountResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetCountResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetCountResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetCountResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetCountResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetCountResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetCountResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetCountResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetCount::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetCount::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetCount::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetCount::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetCount::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetCount::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetCount(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetCount(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetCount *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetCount::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetCount::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetCount(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetCount * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetCount(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetCount *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetCount(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetCount::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetCount(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetCount * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetCount(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetCount *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetCount *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount, sizeof(_vbox__IPerformanceMetric_USCOREgetCount), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetCount *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetCount::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetCount *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetCount), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetCount);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetCount * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetCount(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetCount(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetCount;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetCount);
		((_vbox__IPerformanceMetric_USCOREgetCount*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetCount[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetCount);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetCount*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetCount*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetCount(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetCount %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetCount*)p = *(_vbox__IPerformanceMetric_USCOREgetCount*)q;
}

void _vbox__IPerformanceMetric_USCOREgetPeriodResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IPerformanceMetric_USCOREgetPeriodResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetPeriodResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetPeriodResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetPeriodResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetPeriodResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetPeriodResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetPeriodResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetPeriodResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetPeriodResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetPeriodResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetPeriodResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetPeriodResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetPeriodResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetPeriodResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetPeriodResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetPeriodResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetPeriodResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetPeriodResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetPeriodResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetPeriodResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetPeriodResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetPeriodResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetPeriodResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetPeriodResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetPeriodResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetPeriodResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetPeriodResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetPeriodResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetPeriodResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetPeriodResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetPeriodResponse);
		((_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetPeriodResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetPeriodResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetPeriodResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetPeriodResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetPeriod::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetPeriod::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetPeriod::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetPeriod::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetPeriod::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetPeriod::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetPeriod(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetPeriod(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetPeriod *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetPeriod::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetPeriod::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetPeriod(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetPeriod * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetPeriod(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetPeriod *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetPeriod(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetPeriod::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetPeriod(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetPeriod * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetPeriod(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetPeriod *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetPeriod *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod, sizeof(_vbox__IPerformanceMetric_USCOREgetPeriod), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetPeriod *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetPeriod::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetPeriod *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetPeriod), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetPeriod);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetPeriod * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetPeriod(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetPeriod(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetPeriod;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetPeriod);
		((_vbox__IPerformanceMetric_USCOREgetPeriod*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetPeriod[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetPeriod);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetPeriod*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetPeriod*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetPeriod(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetPeriod %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetPeriod*)p = *(_vbox__IPerformanceMetric_USCOREgetPeriod*)q;
}

void _vbox__IPerformanceMetric_USCOREgetDescriptionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetDescriptionResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetDescriptionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetDescriptionResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetDescriptionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetDescriptionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetDescriptionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetDescriptionResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetDescriptionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetDescriptionResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetDescriptionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetDescriptionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetDescriptionResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetDescriptionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetDescriptionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetDescriptionResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetDescriptionResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetDescriptionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetDescriptionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetDescriptionResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetDescriptionResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse);
		((_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetDescriptionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetDescriptionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetDescriptionResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetDescription::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetDescription::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetDescription::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetDescription::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetDescription::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetDescription::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetDescription(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetDescription(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetDescription *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetDescription::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetDescription::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetDescription(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetDescription * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetDescription(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetDescription *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetDescription(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetDescription::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetDescription(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetDescription * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetDescription(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetDescription *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetDescription *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription, sizeof(_vbox__IPerformanceMetric_USCOREgetDescription), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetDescription *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetDescription::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetDescription *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetDescription), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetDescription);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetDescription * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetDescription(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetDescription(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetDescription;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetDescription);
		((_vbox__IPerformanceMetric_USCOREgetDescription*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetDescription[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetDescription);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetDescription*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetDescription*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetDescription(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetDescription %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetDescription*)p = *(_vbox__IPerformanceMetric_USCOREgetDescription*)q;
}

void _vbox__IPerformanceMetric_USCOREgetObjectResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetObjectResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetObjectResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetObjectResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetObjectResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetObjectResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetObjectResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetObjectResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetObjectResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetObjectResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetObjectResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetObjectResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetObjectResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetObjectResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetObjectResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetObjectResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetObjectResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetObjectResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetObjectResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetObjectResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetObjectResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetObjectResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetObjectResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetObjectResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetObjectResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetObjectResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetObjectResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetObjectResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetObjectResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetObjectResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetObjectResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetObjectResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetObjectResponse);
		((_vbox__IPerformanceMetric_USCOREgetObjectResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetObjectResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetObjectResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetObjectResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetObjectResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetObjectResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetObjectResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetObjectResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetObjectResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetObject::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetObject::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetObject::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetObject::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetObject::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetObject::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetObject(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetObject(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetObject *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetObject::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetObject::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetObject(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetObject * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetObject(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetObject *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetObject(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetObject::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetObject(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetObject * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetObject(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetObject *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetObject *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject, sizeof(_vbox__IPerformanceMetric_USCOREgetObject), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetObject *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetObject::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetObject *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetObject), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetObject);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetObject * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetObject(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetObject(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetObject;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetObject);
		((_vbox__IPerformanceMetric_USCOREgetObject*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetObject[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetObject);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetObject*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetObject*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetObject(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetObject %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetObject*)p = *(_vbox__IPerformanceMetric_USCOREgetObject*)q;
}

void _vbox__IPerformanceMetric_USCOREgetMetricNameResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMetricNameResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetMetricNameResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMetricNameResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetMetricNameResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetMetricNameResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetMetricNameResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IPerformanceMetric_USCOREgetMetricNameResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetMetricNameResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMetricNameResponse * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetMetricNameResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetMetricNameResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMetricNameResponse * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetMetricNameResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetMetricNameResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse, sizeof(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetMetricNameResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IPerformanceMetric_USCOREgetMetricNameResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetMetricNameResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetMetricNameResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMetricNameResponse * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMetricNameResponse;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse);
		((_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMetricNameResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetMetricNameResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetMetricNameResponse %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)q;
}

void _vbox__IPerformanceMetric_USCOREgetMetricName::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMetricName::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IPerformanceMetric_USCOREgetMetricName::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IPerformanceMetric_USCOREgetMetricName::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IPerformanceMetric_USCOREgetMetricName::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IPerformanceMetric_USCOREgetMetricName::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IPerformanceMetric_USCOREgetMetricName(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IPerformanceMetric_USCOREgetMetricName(struct soap *soap, const char *tag, int id, const _vbox__IPerformanceMetric_USCOREgetMetricName *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IPerformanceMetric_USCOREgetMetricName::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IPerformanceMetric_USCOREgetMetricName::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IPerformanceMetric_USCOREgetMetricName(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMetricName * SOAP_FMAC4 soap_get__vbox__IPerformanceMetric_USCOREgetMetricName(struct soap *soap, _vbox__IPerformanceMetric_USCOREgetMetricName *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IPerformanceMetric_USCOREgetMetricName(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IPerformanceMetric_USCOREgetMetricName::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IPerformanceMetric_USCOREgetMetricName(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMetricName * SOAP_FMAC4 soap_in__vbox__IPerformanceMetric_USCOREgetMetricName(struct soap *soap, const char *tag, _vbox__IPerformanceMetric_USCOREgetMetricName *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IPerformanceMetric_USCOREgetMetricName *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName, sizeof(_vbox__IPerformanceMetric_USCOREgetMetricName), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IPerformanceMetric_USCOREgetMetricName *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IPerformanceMetric_USCOREgetMetricName::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IPerformanceMetric_USCOREgetMetricName *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName, 0, sizeof(_vbox__IPerformanceMetric_USCOREgetMetricName), 0, soap_copy__vbox__IPerformanceMetric_USCOREgetMetricName);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IPerformanceMetric_USCOREgetMetricName * SOAP_FMAC4 soap_instantiate__vbox__IPerformanceMetric_USCOREgetMetricName(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IPerformanceMetric_USCOREgetMetricName(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMetricName;
		if (size)
			*size = sizeof(_vbox__IPerformanceMetric_USCOREgetMetricName);
		((_vbox__IPerformanceMetric_USCOREgetMetricName*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IPerformanceMetric_USCOREgetMetricName[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IPerformanceMetric_USCOREgetMetricName);
		for (int i = 0; i < n; i++)
			((_vbox__IPerformanceMetric_USCOREgetMetricName*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IPerformanceMetric_USCOREgetMetricName*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IPerformanceMetric_USCOREgetMetricName(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IPerformanceMetric_USCOREgetMetricName %p -> %p\n", q, p));
	*(_vbox__IPerformanceMetric_USCOREgetMetricName*)p = *(_vbox__IPerformanceMetric_USCOREgetMetricName*)q;
}

void _vbox__IWebsessionManager_USCORElogoffResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IWebsessionManager_USCORElogoffResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IWebsessionManager_USCORElogoffResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IWebsessionManager_USCORElogoffResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IWebsessionManager_USCORElogoffResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IWebsessionManager_USCORElogoffResponse(struct soap *soap, const char *tag, int id, const _vbox__IWebsessionManager_USCORElogoffResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IWebsessionManager_USCORElogoffResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IWebsessionManager_USCORElogoffResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogoffResponse * SOAP_FMAC4 soap_get__vbox__IWebsessionManager_USCORElogoffResponse(struct soap *soap, _vbox__IWebsessionManager_USCORElogoffResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IWebsessionManager_USCORElogoffResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IWebsessionManager_USCORElogoffResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IWebsessionManager_USCORElogoffResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogoffResponse * SOAP_FMAC4 soap_in__vbox__IWebsessionManager_USCORElogoffResponse(struct soap *soap, const char *tag, _vbox__IWebsessionManager_USCORElogoffResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IWebsessionManager_USCORElogoffResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse, sizeof(_vbox__IWebsessionManager_USCORElogoffResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IWebsessionManager_USCORElogoffResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IWebsessionManager_USCORElogoffResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse, 0, sizeof(_vbox__IWebsessionManager_USCORElogoffResponse), 0, soap_copy__vbox__IWebsessionManager_USCORElogoffResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogoffResponse * SOAP_FMAC4 soap_instantiate__vbox__IWebsessionManager_USCORElogoffResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IWebsessionManager_USCORElogoffResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogoffResponse;
		if (size)
			*size = sizeof(_vbox__IWebsessionManager_USCORElogoffResponse);
		((_vbox__IWebsessionManager_USCORElogoffResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogoffResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IWebsessionManager_USCORElogoffResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IWebsessionManager_USCORElogoffResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IWebsessionManager_USCORElogoffResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IWebsessionManager_USCORElogoffResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IWebsessionManager_USCORElogoffResponse %p -> %p\n", q, p));
	*(_vbox__IWebsessionManager_USCORElogoffResponse*)p = *(_vbox__IWebsessionManager_USCORElogoffResponse*)q;
}

void _vbox__IWebsessionManager_USCORElogoff::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogoff::refIVirtualBox);
	/* transient soap skipped */
}

void _vbox__IWebsessionManager_USCORElogoff::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogoff::refIVirtualBox);
	/* transient soap skipped */
}

int _vbox__IWebsessionManager_USCORElogoff::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IWebsessionManager_USCORElogoff::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IWebsessionManager_USCORElogoff(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IWebsessionManager_USCORElogoff(struct soap *soap, const char *tag, int id, const _vbox__IWebsessionManager_USCORElogoff *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff), type))
		return soap->error;
	if (soap_out_std__string(soap, "refIVirtualBox", -1, &(a->_vbox__IWebsessionManager_USCORElogoff::refIVirtualBox), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IWebsessionManager_USCORElogoff::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IWebsessionManager_USCORElogoff(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogoff * SOAP_FMAC4 soap_get__vbox__IWebsessionManager_USCORElogoff(struct soap *soap, _vbox__IWebsessionManager_USCORElogoff *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IWebsessionManager_USCORElogoff(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IWebsessionManager_USCORElogoff::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IWebsessionManager_USCORElogoff(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogoff * SOAP_FMAC4 soap_in__vbox__IWebsessionManager_USCORElogoff(struct soap *soap, const char *tag, _vbox__IWebsessionManager_USCORElogoff *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IWebsessionManager_USCORElogoff *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff, sizeof(_vbox__IWebsessionManager_USCORElogoff), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IWebsessionManager_USCORElogoff *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_refIVirtualBox1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_refIVirtualBox1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "refIVirtualBox", &(a->_vbox__IWebsessionManager_USCORElogoff::refIVirtualBox), "xsd:string"))
				{	soap_flag_refIVirtualBox1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IWebsessionManager_USCORElogoff *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff, 0, sizeof(_vbox__IWebsessionManager_USCORElogoff), 0, soap_copy__vbox__IWebsessionManager_USCORElogoff);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_refIVirtualBox1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogoff * SOAP_FMAC4 soap_instantiate__vbox__IWebsessionManager_USCORElogoff(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IWebsessionManager_USCORElogoff(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogoff;
		if (size)
			*size = sizeof(_vbox__IWebsessionManager_USCORElogoff);
		((_vbox__IWebsessionManager_USCORElogoff*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogoff[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IWebsessionManager_USCORElogoff);
		for (int i = 0; i < n; i++)
			((_vbox__IWebsessionManager_USCORElogoff*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IWebsessionManager_USCORElogoff*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IWebsessionManager_USCORElogoff(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IWebsessionManager_USCORElogoff %p -> %p\n", q, p));
	*(_vbox__IWebsessionManager_USCORElogoff*)p = *(_vbox__IWebsessionManager_USCORElogoff*)q;
}

void _vbox__IWebsessionManager_USCOREgetSessionObjectResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IWebsessionManager_USCOREgetSessionObjectResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IWebsessionManager_USCOREgetSessionObjectResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IWebsessionManager_USCOREgetSessionObjectResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IWebsessionManager_USCOREgetSessionObjectResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IWebsessionManager_USCOREgetSessionObjectResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(struct soap *soap, const char *tag, int id, const _vbox__IWebsessionManager_USCOREgetSessionObjectResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IWebsessionManager_USCOREgetSessionObjectResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IWebsessionManager_USCOREgetSessionObjectResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCOREgetSessionObjectResponse * SOAP_FMAC4 soap_get__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(struct soap *soap, _vbox__IWebsessionManager_USCOREgetSessionObjectResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IWebsessionManager_USCOREgetSessionObjectResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCOREgetSessionObjectResponse * SOAP_FMAC4 soap_in__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(struct soap *soap, const char *tag, _vbox__IWebsessionManager_USCOREgetSessionObjectResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IWebsessionManager_USCOREgetSessionObjectResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse, sizeof(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IWebsessionManager_USCOREgetSessionObjectResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IWebsessionManager_USCOREgetSessionObjectResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IWebsessionManager_USCOREgetSessionObjectResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse, 0, sizeof(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse), 0, soap_copy__vbox__IWebsessionManager_USCOREgetSessionObjectResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCOREgetSessionObjectResponse * SOAP_FMAC4 soap_instantiate__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCOREgetSessionObjectResponse;
		if (size)
			*size = sizeof(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse);
		((_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCOREgetSessionObjectResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IWebsessionManager_USCOREgetSessionObjectResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IWebsessionManager_USCOREgetSessionObjectResponse %p -> %p\n", q, p));
	*(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)p = *(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)q;
}

void _vbox__IWebsessionManager_USCOREgetSessionObject::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IWebsessionManager_USCOREgetSessionObject::refIVirtualBox);
	/* transient soap skipped */
}

void _vbox__IWebsessionManager_USCOREgetSessionObject::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IWebsessionManager_USCOREgetSessionObject::refIVirtualBox);
	/* transient soap skipped */
}

int _vbox__IWebsessionManager_USCOREgetSessionObject::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IWebsessionManager_USCOREgetSessionObject::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IWebsessionManager_USCOREgetSessionObject(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IWebsessionManager_USCOREgetSessionObject(struct soap *soap, const char *tag, int id, const _vbox__IWebsessionManager_USCOREgetSessionObject *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject), type))
		return soap->error;
	if (soap_out_std__string(soap, "refIVirtualBox", -1, &(a->_vbox__IWebsessionManager_USCOREgetSessionObject::refIVirtualBox), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IWebsessionManager_USCOREgetSessionObject::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IWebsessionManager_USCOREgetSessionObject(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCOREgetSessionObject * SOAP_FMAC4 soap_get__vbox__IWebsessionManager_USCOREgetSessionObject(struct soap *soap, _vbox__IWebsessionManager_USCOREgetSessionObject *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IWebsessionManager_USCOREgetSessionObject(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IWebsessionManager_USCOREgetSessionObject::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IWebsessionManager_USCOREgetSessionObject(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCOREgetSessionObject * SOAP_FMAC4 soap_in__vbox__IWebsessionManager_USCOREgetSessionObject(struct soap *soap, const char *tag, _vbox__IWebsessionManager_USCOREgetSessionObject *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IWebsessionManager_USCOREgetSessionObject *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject, sizeof(_vbox__IWebsessionManager_USCOREgetSessionObject), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IWebsessionManager_USCOREgetSessionObject *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_refIVirtualBox1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_refIVirtualBox1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "refIVirtualBox", &(a->_vbox__IWebsessionManager_USCOREgetSessionObject::refIVirtualBox), "xsd:string"))
				{	soap_flag_refIVirtualBox1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IWebsessionManager_USCOREgetSessionObject *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject, 0, sizeof(_vbox__IWebsessionManager_USCOREgetSessionObject), 0, soap_copy__vbox__IWebsessionManager_USCOREgetSessionObject);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_refIVirtualBox1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCOREgetSessionObject * SOAP_FMAC4 soap_instantiate__vbox__IWebsessionManager_USCOREgetSessionObject(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IWebsessionManager_USCOREgetSessionObject(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCOREgetSessionObject;
		if (size)
			*size = sizeof(_vbox__IWebsessionManager_USCOREgetSessionObject);
		((_vbox__IWebsessionManager_USCOREgetSessionObject*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCOREgetSessionObject[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IWebsessionManager_USCOREgetSessionObject);
		for (int i = 0; i < n; i++)
			((_vbox__IWebsessionManager_USCOREgetSessionObject*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IWebsessionManager_USCOREgetSessionObject*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IWebsessionManager_USCOREgetSessionObject(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IWebsessionManager_USCOREgetSessionObject %p -> %p\n", q, p));
	*(_vbox__IWebsessionManager_USCOREgetSessionObject*)p = *(_vbox__IWebsessionManager_USCOREgetSessionObject*)q;
}

void _vbox__IWebsessionManager_USCORElogonResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogonResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IWebsessionManager_USCORElogonResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogonResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IWebsessionManager_USCORElogonResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IWebsessionManager_USCORElogonResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IWebsessionManager_USCORElogonResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IWebsessionManager_USCORElogonResponse(struct soap *soap, const char *tag, int id, const _vbox__IWebsessionManager_USCORElogonResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IWebsessionManager_USCORElogonResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IWebsessionManager_USCORElogonResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IWebsessionManager_USCORElogonResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogonResponse * SOAP_FMAC4 soap_get__vbox__IWebsessionManager_USCORElogonResponse(struct soap *soap, _vbox__IWebsessionManager_USCORElogonResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IWebsessionManager_USCORElogonResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IWebsessionManager_USCORElogonResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IWebsessionManager_USCORElogonResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogonResponse * SOAP_FMAC4 soap_in__vbox__IWebsessionManager_USCORElogonResponse(struct soap *soap, const char *tag, _vbox__IWebsessionManager_USCORElogonResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IWebsessionManager_USCORElogonResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse, sizeof(_vbox__IWebsessionManager_USCORElogonResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IWebsessionManager_USCORElogonResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IWebsessionManager_USCORElogonResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IWebsessionManager_USCORElogonResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse, 0, sizeof(_vbox__IWebsessionManager_USCORElogonResponse), 0, soap_copy__vbox__IWebsessionManager_USCORElogonResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogonResponse * SOAP_FMAC4 soap_instantiate__vbox__IWebsessionManager_USCORElogonResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IWebsessionManager_USCORElogonResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogonResponse;
		if (size)
			*size = sizeof(_vbox__IWebsessionManager_USCORElogonResponse);
		((_vbox__IWebsessionManager_USCORElogonResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogonResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IWebsessionManager_USCORElogonResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IWebsessionManager_USCORElogonResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IWebsessionManager_USCORElogonResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IWebsessionManager_USCORElogonResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IWebsessionManager_USCORElogonResponse %p -> %p\n", q, p));
	*(_vbox__IWebsessionManager_USCORElogonResponse*)p = *(_vbox__IWebsessionManager_USCORElogonResponse*)q;
}

void _vbox__IWebsessionManager_USCORElogon::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogon::username);
	soap_default_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogon::password);
	/* transient soap skipped */
}

void _vbox__IWebsessionManager_USCORElogon::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogon::username);
	soap_serialize_std__string(soap, &this->_vbox__IWebsessionManager_USCORElogon::password);
	/* transient soap skipped */
}

int _vbox__IWebsessionManager_USCORElogon::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IWebsessionManager_USCORElogon);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IWebsessionManager_USCORElogon::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IWebsessionManager_USCORElogon(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IWebsessionManager_USCORElogon(struct soap *soap, const char *tag, int id, const _vbox__IWebsessionManager_USCORElogon *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogon), type))
		return soap->error;
	if (soap_out_std__string(soap, "username", -1, &(a->_vbox__IWebsessionManager_USCORElogon::username), ""))
		return soap->error;
	if (soap_out_std__string(soap, "password", -1, &(a->_vbox__IWebsessionManager_USCORElogon::password), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IWebsessionManager_USCORElogon::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IWebsessionManager_USCORElogon(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogon * SOAP_FMAC4 soap_get__vbox__IWebsessionManager_USCORElogon(struct soap *soap, _vbox__IWebsessionManager_USCORElogon *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IWebsessionManager_USCORElogon(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IWebsessionManager_USCORElogon::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IWebsessionManager_USCORElogon(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogon * SOAP_FMAC4 soap_in__vbox__IWebsessionManager_USCORElogon(struct soap *soap, const char *tag, _vbox__IWebsessionManager_USCORElogon *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IWebsessionManager_USCORElogon *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IWebsessionManager_USCORElogon, sizeof(_vbox__IWebsessionManager_USCORElogon), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IWebsessionManager_USCORElogon)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IWebsessionManager_USCORElogon *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_username1 = 1;
	size_t soap_flag_password1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_username1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "username", &(a->_vbox__IWebsessionManager_USCORElogon::username), "xsd:string"))
				{	soap_flag_username1--;
					continue;
				}
			if (soap_flag_password1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "password", &(a->_vbox__IWebsessionManager_USCORElogon::password), "xsd:string"))
				{	soap_flag_password1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IWebsessionManager_USCORElogon *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IWebsessionManager_USCORElogon, 0, sizeof(_vbox__IWebsessionManager_USCORElogon), 0, soap_copy__vbox__IWebsessionManager_USCORElogon);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_username1 > 0 || soap_flag_password1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IWebsessionManager_USCORElogon * SOAP_FMAC4 soap_instantiate__vbox__IWebsessionManager_USCORElogon(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IWebsessionManager_USCORElogon(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IWebsessionManager_USCORElogon, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogon;
		if (size)
			*size = sizeof(_vbox__IWebsessionManager_USCORElogon);
		((_vbox__IWebsessionManager_USCORElogon*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IWebsessionManager_USCORElogon[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IWebsessionManager_USCORElogon);
		for (int i = 0; i < n; i++)
			((_vbox__IWebsessionManager_USCORElogon*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IWebsessionManager_USCORElogon*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IWebsessionManager_USCORElogon(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IWebsessionManager_USCORElogon %p -> %p\n", q, p));
	*(_vbox__IWebsessionManager_USCORElogon*)p = *(_vbox__IWebsessionManager_USCORElogon*)q;
}

void _vbox__IManagedObjectRef_USCOREreleaseResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IManagedObjectRef_USCOREreleaseResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IManagedObjectRef_USCOREreleaseResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IManagedObjectRef_USCOREreleaseResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IManagedObjectRef_USCOREreleaseResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IManagedObjectRef_USCOREreleaseResponse(struct soap *soap, const char *tag, int id, const _vbox__IManagedObjectRef_USCOREreleaseResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IManagedObjectRef_USCOREreleaseResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IManagedObjectRef_USCOREreleaseResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREreleaseResponse * SOAP_FMAC4 soap_get__vbox__IManagedObjectRef_USCOREreleaseResponse(struct soap *soap, _vbox__IManagedObjectRef_USCOREreleaseResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IManagedObjectRef_USCOREreleaseResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IManagedObjectRef_USCOREreleaseResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IManagedObjectRef_USCOREreleaseResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREreleaseResponse * SOAP_FMAC4 soap_in__vbox__IManagedObjectRef_USCOREreleaseResponse(struct soap *soap, const char *tag, _vbox__IManagedObjectRef_USCOREreleaseResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IManagedObjectRef_USCOREreleaseResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse, sizeof(_vbox__IManagedObjectRef_USCOREreleaseResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IManagedObjectRef_USCOREreleaseResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IManagedObjectRef_USCOREreleaseResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse, 0, sizeof(_vbox__IManagedObjectRef_USCOREreleaseResponse), 0, soap_copy__vbox__IManagedObjectRef_USCOREreleaseResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREreleaseResponse * SOAP_FMAC4 soap_instantiate__vbox__IManagedObjectRef_USCOREreleaseResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IManagedObjectRef_USCOREreleaseResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCOREreleaseResponse;
		if (size)
			*size = sizeof(_vbox__IManagedObjectRef_USCOREreleaseResponse);
		((_vbox__IManagedObjectRef_USCOREreleaseResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCOREreleaseResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IManagedObjectRef_USCOREreleaseResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IManagedObjectRef_USCOREreleaseResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IManagedObjectRef_USCOREreleaseResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IManagedObjectRef_USCOREreleaseResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IManagedObjectRef_USCOREreleaseResponse %p -> %p\n", q, p));
	*(_vbox__IManagedObjectRef_USCOREreleaseResponse*)p = *(_vbox__IManagedObjectRef_USCOREreleaseResponse*)q;
}

void _vbox__IManagedObjectRef_USCORErelease::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IManagedObjectRef_USCORErelease::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IManagedObjectRef_USCORErelease::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IManagedObjectRef_USCORErelease::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IManagedObjectRef_USCORErelease::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IManagedObjectRef_USCORErelease::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IManagedObjectRef_USCORErelease(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IManagedObjectRef_USCORErelease(struct soap *soap, const char *tag, int id, const _vbox__IManagedObjectRef_USCORErelease *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IManagedObjectRef_USCORErelease::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IManagedObjectRef_USCORErelease::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IManagedObjectRef_USCORErelease(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCORErelease * SOAP_FMAC4 soap_get__vbox__IManagedObjectRef_USCORErelease(struct soap *soap, _vbox__IManagedObjectRef_USCORErelease *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IManagedObjectRef_USCORErelease(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IManagedObjectRef_USCORErelease::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IManagedObjectRef_USCORErelease(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCORErelease * SOAP_FMAC4 soap_in__vbox__IManagedObjectRef_USCORErelease(struct soap *soap, const char *tag, _vbox__IManagedObjectRef_USCORErelease *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IManagedObjectRef_USCORErelease *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease, sizeof(_vbox__IManagedObjectRef_USCORErelease), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IManagedObjectRef_USCORErelease *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IManagedObjectRef_USCORErelease::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IManagedObjectRef_USCORErelease *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease, 0, sizeof(_vbox__IManagedObjectRef_USCORErelease), 0, soap_copy__vbox__IManagedObjectRef_USCORErelease);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCORErelease * SOAP_FMAC4 soap_instantiate__vbox__IManagedObjectRef_USCORErelease(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IManagedObjectRef_USCORErelease(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCORErelease;
		if (size)
			*size = sizeof(_vbox__IManagedObjectRef_USCORErelease);
		((_vbox__IManagedObjectRef_USCORErelease*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCORErelease[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IManagedObjectRef_USCORErelease);
		for (int i = 0; i < n; i++)
			((_vbox__IManagedObjectRef_USCORErelease*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IManagedObjectRef_USCORErelease*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IManagedObjectRef_USCORErelease(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IManagedObjectRef_USCORErelease %p -> %p\n", q, p));
	*(_vbox__IManagedObjectRef_USCORErelease*)p = *(_vbox__IManagedObjectRef_USCORErelease*)q;
}

void _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(struct soap *soap, const char *tag, int id, const _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse * SOAP_FMAC4 soap_get__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(struct soap *soap, _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse * SOAP_FMAC4 soap_in__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(struct soap *soap, const char *tag, _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse, sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse, 0, sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse), 0, soap_copy__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse * SOAP_FMAC4 soap_instantiate__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse;
		if (size)
			*size = sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse);
		((_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse %p -> %p\n", q, p));
	*(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)p = *(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)q;
}

void _vbox__IManagedObjectRef_USCOREgetInterfaceName::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IManagedObjectRef_USCOREgetInterfaceName::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IManagedObjectRef_USCOREgetInterfaceName::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IManagedObjectRef_USCOREgetInterfaceName::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IManagedObjectRef_USCOREgetInterfaceName::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IManagedObjectRef_USCOREgetInterfaceName::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IManagedObjectRef_USCOREgetInterfaceName(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IManagedObjectRef_USCOREgetInterfaceName(struct soap *soap, const char *tag, int id, const _vbox__IManagedObjectRef_USCOREgetInterfaceName *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IManagedObjectRef_USCOREgetInterfaceName::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IManagedObjectRef_USCOREgetInterfaceName::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IManagedObjectRef_USCOREgetInterfaceName(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREgetInterfaceName * SOAP_FMAC4 soap_get__vbox__IManagedObjectRef_USCOREgetInterfaceName(struct soap *soap, _vbox__IManagedObjectRef_USCOREgetInterfaceName *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IManagedObjectRef_USCOREgetInterfaceName(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IManagedObjectRef_USCOREgetInterfaceName::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IManagedObjectRef_USCOREgetInterfaceName(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREgetInterfaceName * SOAP_FMAC4 soap_in__vbox__IManagedObjectRef_USCOREgetInterfaceName(struct soap *soap, const char *tag, _vbox__IManagedObjectRef_USCOREgetInterfaceName *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IManagedObjectRef_USCOREgetInterfaceName *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName, sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceName), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IManagedObjectRef_USCOREgetInterfaceName *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IManagedObjectRef_USCOREgetInterfaceName::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IManagedObjectRef_USCOREgetInterfaceName *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName, 0, sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceName), 0, soap_copy__vbox__IManagedObjectRef_USCOREgetInterfaceName);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IManagedObjectRef_USCOREgetInterfaceName * SOAP_FMAC4 soap_instantiate__vbox__IManagedObjectRef_USCOREgetInterfaceName(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IManagedObjectRef_USCOREgetInterfaceName(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCOREgetInterfaceName;
		if (size)
			*size = sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceName);
		((_vbox__IManagedObjectRef_USCOREgetInterfaceName*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IManagedObjectRef_USCOREgetInterfaceName[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IManagedObjectRef_USCOREgetInterfaceName);
		for (int i = 0; i < n; i++)
			((_vbox__IManagedObjectRef_USCOREgetInterfaceName*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IManagedObjectRef_USCOREgetInterfaceName*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IManagedObjectRef_USCOREgetInterfaceName(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IManagedObjectRef_USCOREgetInterfaceName %p -> %p\n", q, p));
	*(_vbox__IManagedObjectRef_USCOREgetInterfaceName*)p = *(_vbox__IManagedObjectRef_USCOREgetInterfaceName*)q;
}

void _vbox__IStorageController_USCORESetIDEEmulationPortResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IStorageController_USCORESetIDEEmulationPortResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCORESetIDEEmulationPortResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCORESetIDEEmulationPortResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCORESetIDEEmulationPortResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCORESetIDEEmulationPortResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCORESetIDEEmulationPortResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCORESetIDEEmulationPortResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCORESetIDEEmulationPortResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCORESetIDEEmulationPortResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCORESetIDEEmulationPortResponse(struct soap *soap, _vbox__IStorageController_USCORESetIDEEmulationPortResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCORESetIDEEmulationPortResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCORESetIDEEmulationPortResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCORESetIDEEmulationPortResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCORESetIDEEmulationPortResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCORESetIDEEmulationPortResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCORESetIDEEmulationPortResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCORESetIDEEmulationPortResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse, sizeof(_vbox__IStorageController_USCORESetIDEEmulationPortResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCORESetIDEEmulationPortResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCORESetIDEEmulationPortResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse, 0, sizeof(_vbox__IStorageController_USCORESetIDEEmulationPortResponse), 0, soap_copy__vbox__IStorageController_USCORESetIDEEmulationPortResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCORESetIDEEmulationPortResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCORESetIDEEmulationPortResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCORESetIDEEmulationPortResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPortResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCORESetIDEEmulationPortResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCORESetIDEEmulationPortResponse);
		((_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCORESetIDEEmulationPortResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCORESetIDEEmulationPortResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCORESetIDEEmulationPortResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCORESetIDEEmulationPortResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)p = *(_vbox__IStorageController_USCORESetIDEEmulationPortResponse*)q;
}

void _vbox__IStorageController_USCORESetIDEEmulationPort::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCORESetIDEEmulationPort::_USCOREthis);
	soap_default_int(soap, &this->_vbox__IStorageController_USCORESetIDEEmulationPort::devicePosition);
	soap_default_int(soap, &this->_vbox__IStorageController_USCORESetIDEEmulationPort::portNumber);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCORESetIDEEmulationPort::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCORESetIDEEmulationPort::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCORESetIDEEmulationPort::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCORESetIDEEmulationPort::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCORESetIDEEmulationPort(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCORESetIDEEmulationPort(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCORESetIDEEmulationPort *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCORESetIDEEmulationPort::_USCOREthis), ""))
		return soap->error;
	if (soap_out_int(soap, "devicePosition", -1, &(a->_vbox__IStorageController_USCORESetIDEEmulationPort::devicePosition), ""))
		return soap->error;
	if (soap_out_int(soap, "portNumber", -1, &(a->_vbox__IStorageController_USCORESetIDEEmulationPort::portNumber), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCORESetIDEEmulationPort::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCORESetIDEEmulationPort(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCORESetIDEEmulationPort * SOAP_FMAC4 soap_get__vbox__IStorageController_USCORESetIDEEmulationPort(struct soap *soap, _vbox__IStorageController_USCORESetIDEEmulationPort *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCORESetIDEEmulationPort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCORESetIDEEmulationPort::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCORESetIDEEmulationPort(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCORESetIDEEmulationPort * SOAP_FMAC4 soap_in__vbox__IStorageController_USCORESetIDEEmulationPort(struct soap *soap, const char *tag, _vbox__IStorageController_USCORESetIDEEmulationPort *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCORESetIDEEmulationPort *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort, sizeof(_vbox__IStorageController_USCORESetIDEEmulationPort), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCORESetIDEEmulationPort *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_devicePosition1 = 1;
	size_t soap_flag_portNumber1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCORESetIDEEmulationPort::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_devicePosition1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_int(soap, "devicePosition", &(a->_vbox__IStorageController_USCORESetIDEEmulationPort::devicePosition), "xsd:int"))
				{	soap_flag_devicePosition1--;
					continue;
				}
			if (soap_flag_portNumber1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_int(soap, "portNumber", &(a->_vbox__IStorageController_USCORESetIDEEmulationPort::portNumber), "xsd:int"))
				{	soap_flag_portNumber1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCORESetIDEEmulationPort *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort, 0, sizeof(_vbox__IStorageController_USCORESetIDEEmulationPort), 0, soap_copy__vbox__IStorageController_USCORESetIDEEmulationPort);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_devicePosition1 > 0 || soap_flag_portNumber1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCORESetIDEEmulationPort * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCORESetIDEEmulationPort(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCORESetIDEEmulationPort(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCORESetIDEEmulationPort, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCORESetIDEEmulationPort;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCORESetIDEEmulationPort);
		((_vbox__IStorageController_USCORESetIDEEmulationPort*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCORESetIDEEmulationPort[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCORESetIDEEmulationPort);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCORESetIDEEmulationPort*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCORESetIDEEmulationPort*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCORESetIDEEmulationPort(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCORESetIDEEmulationPort %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCORESetIDEEmulationPort*)p = *(_vbox__IStorageController_USCORESetIDEEmulationPort*)q;
}

void _vbox__IStorageController_USCOREGetIDEEmulationPortResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_int(soap, &this->_vbox__IStorageController_USCOREGetIDEEmulationPortResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREGetIDEEmulationPortResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREGetIDEEmulationPortResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREGetIDEEmulationPortResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREGetIDEEmulationPortResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse), type))
		return soap->error;
	if (soap_out_int(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREGetIDEEmulationPortResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREGetIDEEmulationPortResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREGetIDEEmulationPortResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(struct soap *soap, _vbox__IStorageController_USCOREGetIDEEmulationPortResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREGetIDEEmulationPortResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREGetIDEEmulationPortResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREGetIDEEmulationPortResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREGetIDEEmulationPortResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse, sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPortResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREGetIDEEmulationPortResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_int(soap, "returnval", &(a->_vbox__IStorageController_USCOREGetIDEEmulationPortResponse::returnval), "xsd:int"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREGetIDEEmulationPortResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse, 0, sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPortResponse), 0, soap_copy__vbox__IStorageController_USCOREGetIDEEmulationPortResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREGetIDEEmulationPortResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPortResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREGetIDEEmulationPortResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPortResponse);
		((_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREGetIDEEmulationPortResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPortResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREGetIDEEmulationPortResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREGetIDEEmulationPortResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)p = *(_vbox__IStorageController_USCOREGetIDEEmulationPortResponse*)q;
}

void _vbox__IStorageController_USCOREGetIDEEmulationPort::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREGetIDEEmulationPort::_USCOREthis);
	soap_default_int(soap, &this->_vbox__IStorageController_USCOREGetIDEEmulationPort::devicePosition);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREGetIDEEmulationPort::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREGetIDEEmulationPort::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREGetIDEEmulationPort::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREGetIDEEmulationPort::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREGetIDEEmulationPort(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREGetIDEEmulationPort(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREGetIDEEmulationPort *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREGetIDEEmulationPort::_USCOREthis), ""))
		return soap->error;
	if (soap_out_int(soap, "devicePosition", -1, &(a->_vbox__IStorageController_USCOREGetIDEEmulationPort::devicePosition), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREGetIDEEmulationPort::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREGetIDEEmulationPort(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREGetIDEEmulationPort * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREGetIDEEmulationPort(struct soap *soap, _vbox__IStorageController_USCOREGetIDEEmulationPort *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREGetIDEEmulationPort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREGetIDEEmulationPort::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREGetIDEEmulationPort(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREGetIDEEmulationPort * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREGetIDEEmulationPort(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREGetIDEEmulationPort *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREGetIDEEmulationPort *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort, sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPort), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREGetIDEEmulationPort *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_devicePosition1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREGetIDEEmulationPort::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_devicePosition1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_int(soap, "devicePosition", &(a->_vbox__IStorageController_USCOREGetIDEEmulationPort::devicePosition), "xsd:int"))
				{	soap_flag_devicePosition1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREGetIDEEmulationPort *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort, 0, sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPort), 0, soap_copy__vbox__IStorageController_USCOREGetIDEEmulationPort);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_devicePosition1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREGetIDEEmulationPort * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREGetIDEEmulationPort(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREGetIDEEmulationPort(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREGetIDEEmulationPort, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREGetIDEEmulationPort;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPort);
		((_vbox__IStorageController_USCOREGetIDEEmulationPort*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREGetIDEEmulationPort[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREGetIDEEmulationPort);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREGetIDEEmulationPort*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREGetIDEEmulationPort*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREGetIDEEmulationPort(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREGetIDEEmulationPort %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREGetIDEEmulationPort*)p = *(_vbox__IStorageController_USCOREGetIDEEmulationPort*)q;
}

void _vbox__IStorageController_USCOREsetControllerTypeResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREsetControllerTypeResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREsetControllerTypeResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREsetControllerTypeResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREsetControllerTypeResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREsetControllerTypeResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREsetControllerTypeResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREsetControllerTypeResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREsetControllerTypeResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetControllerTypeResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREsetControllerTypeResponse(struct soap *soap, _vbox__IStorageController_USCOREsetControllerTypeResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREsetControllerTypeResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREsetControllerTypeResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREsetControllerTypeResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetControllerTypeResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREsetControllerTypeResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREsetControllerTypeResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREsetControllerTypeResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse, sizeof(_vbox__IStorageController_USCOREsetControllerTypeResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREsetControllerTypeResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREsetControllerTypeResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse, 0, sizeof(_vbox__IStorageController_USCOREsetControllerTypeResponse), 0, soap_copy__vbox__IStorageController_USCOREsetControllerTypeResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetControllerTypeResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREsetControllerTypeResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREsetControllerTypeResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetControllerTypeResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREsetControllerTypeResponse);
		((_vbox__IStorageController_USCOREsetControllerTypeResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetControllerTypeResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREsetControllerTypeResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREsetControllerTypeResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREsetControllerTypeResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREsetControllerTypeResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREsetControllerTypeResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREsetControllerTypeResponse*)p = *(_vbox__IStorageController_USCOREsetControllerTypeResponse*)q;
}

void _vbox__IStorageController_USCOREsetControllerType::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREsetControllerType::_USCOREthis);
	soap_default_vbox__StorageControllerType(soap, &this->_vbox__IStorageController_USCOREsetControllerType::controllerType);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREsetControllerType::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREsetControllerType::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREsetControllerType::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREsetControllerType::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREsetControllerType(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREsetControllerType(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREsetControllerType *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREsetControllerType::_USCOREthis), ""))
		return soap->error;
	if (soap_out_vbox__StorageControllerType(soap, "controllerType", -1, &(a->_vbox__IStorageController_USCOREsetControllerType::controllerType), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREsetControllerType::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREsetControllerType(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetControllerType * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREsetControllerType(struct soap *soap, _vbox__IStorageController_USCOREsetControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREsetControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREsetControllerType::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREsetControllerType(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetControllerType * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREsetControllerType(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREsetControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREsetControllerType *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType, sizeof(_vbox__IStorageController_USCOREsetControllerType), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREsetControllerType *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_controllerType1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREsetControllerType::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_controllerType1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__StorageControllerType(soap, "controllerType", &(a->_vbox__IStorageController_USCOREsetControllerType::controllerType), "vbox:StorageControllerType"))
				{	soap_flag_controllerType1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREsetControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType, 0, sizeof(_vbox__IStorageController_USCOREsetControllerType), 0, soap_copy__vbox__IStorageController_USCOREsetControllerType);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_controllerType1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetControllerType * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREsetControllerType(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREsetControllerType(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetControllerType;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREsetControllerType);
		((_vbox__IStorageController_USCOREsetControllerType*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetControllerType[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREsetControllerType);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREsetControllerType*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREsetControllerType*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREsetControllerType(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREsetControllerType %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREsetControllerType*)p = *(_vbox__IStorageController_USCOREsetControllerType*)q;
}

void _vbox__IStorageController_USCOREgetControllerTypeResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__StorageControllerType(soap, &this->_vbox__IStorageController_USCOREgetControllerTypeResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetControllerTypeResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetControllerTypeResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetControllerTypeResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetControllerTypeResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetControllerTypeResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetControllerTypeResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse), type))
		return soap->error;
	if (soap_out_vbox__StorageControllerType(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetControllerTypeResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetControllerTypeResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetControllerTypeResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetControllerTypeResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetControllerTypeResponse(struct soap *soap, _vbox__IStorageController_USCOREgetControllerTypeResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetControllerTypeResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetControllerTypeResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetControllerTypeResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetControllerTypeResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetControllerTypeResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetControllerTypeResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetControllerTypeResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse, sizeof(_vbox__IStorageController_USCOREgetControllerTypeResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetControllerTypeResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__StorageControllerType(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetControllerTypeResponse::returnval), "vbox:StorageControllerType"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetControllerTypeResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse, 0, sizeof(_vbox__IStorageController_USCOREgetControllerTypeResponse), 0, soap_copy__vbox__IStorageController_USCOREgetControllerTypeResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetControllerTypeResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetControllerTypeResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetControllerTypeResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetControllerTypeResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetControllerTypeResponse);
		((_vbox__IStorageController_USCOREgetControllerTypeResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetControllerTypeResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetControllerTypeResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetControllerTypeResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetControllerTypeResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetControllerTypeResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetControllerTypeResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetControllerTypeResponse*)p = *(_vbox__IStorageController_USCOREgetControllerTypeResponse*)q;
}

void _vbox__IStorageController_USCOREgetControllerType::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetControllerType::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetControllerType::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetControllerType::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetControllerType::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetControllerType::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetControllerType(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetControllerType(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetControllerType *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetControllerType::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetControllerType::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetControllerType(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetControllerType * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetControllerType(struct soap *soap, _vbox__IStorageController_USCOREgetControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetControllerType::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetControllerType(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetControllerType * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetControllerType(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetControllerType *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType, sizeof(_vbox__IStorageController_USCOREgetControllerType), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetControllerType *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetControllerType::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType, 0, sizeof(_vbox__IStorageController_USCOREgetControllerType), 0, soap_copy__vbox__IStorageController_USCOREgetControllerType);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetControllerType * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetControllerType(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetControllerType(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetControllerType;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetControllerType);
		((_vbox__IStorageController_USCOREgetControllerType*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetControllerType[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetControllerType);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetControllerType*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetControllerType*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetControllerType(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetControllerType %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetControllerType*)p = *(_vbox__IStorageController_USCOREgetControllerType*)q;
}

void _vbox__IStorageController_USCOREgetBusResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__StorageBus(soap, &this->_vbox__IStorageController_USCOREgetBusResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetBusResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetBusResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetBusResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetBusResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetBusResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetBusResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse), type))
		return soap->error;
	if (soap_out_vbox__StorageBus(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetBusResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetBusResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetBusResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetBusResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetBusResponse(struct soap *soap, _vbox__IStorageController_USCOREgetBusResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetBusResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetBusResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetBusResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetBusResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetBusResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetBusResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetBusResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse, sizeof(_vbox__IStorageController_USCOREgetBusResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetBusResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__StorageBus(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetBusResponse::returnval), "vbox:StorageBus"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetBusResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse, 0, sizeof(_vbox__IStorageController_USCOREgetBusResponse), 0, soap_copy__vbox__IStorageController_USCOREgetBusResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetBusResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetBusResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetBusResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetBusResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetBusResponse);
		((_vbox__IStorageController_USCOREgetBusResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetBusResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetBusResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetBusResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetBusResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetBusResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetBusResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetBusResponse*)p = *(_vbox__IStorageController_USCOREgetBusResponse*)q;
}

void _vbox__IStorageController_USCOREgetBus::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetBus::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetBus::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetBus::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetBus::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetBus);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetBus::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetBus(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetBus(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetBus *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetBus), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetBus::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetBus::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetBus(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetBus * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetBus(struct soap *soap, _vbox__IStorageController_USCOREgetBus *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetBus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetBus::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetBus(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetBus * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetBus(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetBus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetBus *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetBus, sizeof(_vbox__IStorageController_USCOREgetBus), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetBus)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetBus *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetBus::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetBus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetBus, 0, sizeof(_vbox__IStorageController_USCOREgetBus), 0, soap_copy__vbox__IStorageController_USCOREgetBus);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetBus * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetBus(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetBus(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetBus, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetBus;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetBus);
		((_vbox__IStorageController_USCOREgetBus*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetBus[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetBus);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetBus*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetBus*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetBus(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetBus %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetBus*)p = *(_vbox__IStorageController_USCOREgetBus*)q;
}

void _vbox__IStorageController_USCOREsetPortCountResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREsetPortCountResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREsetPortCountResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREsetPortCountResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREsetPortCountResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREsetPortCountResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREsetPortCountResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREsetPortCountResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREsetPortCountResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetPortCountResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREsetPortCountResponse(struct soap *soap, _vbox__IStorageController_USCOREsetPortCountResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREsetPortCountResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREsetPortCountResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREsetPortCountResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetPortCountResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREsetPortCountResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREsetPortCountResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREsetPortCountResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse, sizeof(_vbox__IStorageController_USCOREsetPortCountResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREsetPortCountResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREsetPortCountResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse, 0, sizeof(_vbox__IStorageController_USCOREsetPortCountResponse), 0, soap_copy__vbox__IStorageController_USCOREsetPortCountResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetPortCountResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREsetPortCountResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREsetPortCountResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetPortCountResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREsetPortCountResponse);
		((_vbox__IStorageController_USCOREsetPortCountResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetPortCountResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREsetPortCountResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREsetPortCountResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREsetPortCountResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREsetPortCountResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREsetPortCountResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREsetPortCountResponse*)p = *(_vbox__IStorageController_USCOREsetPortCountResponse*)q;
}

void _vbox__IStorageController_USCOREsetPortCount::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREsetPortCount::_USCOREthis);
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREsetPortCount::portCount);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREsetPortCount::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREsetPortCount::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREsetPortCount::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREsetPortCount::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREsetPortCount(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREsetPortCount(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREsetPortCount *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREsetPortCount::_USCOREthis), ""))
		return soap->error;
	if (soap_out_unsignedInt(soap, "portCount", -1, &(a->_vbox__IStorageController_USCOREsetPortCount::portCount), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREsetPortCount::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREsetPortCount(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetPortCount * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREsetPortCount(struct soap *soap, _vbox__IStorageController_USCOREsetPortCount *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREsetPortCount(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREsetPortCount::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREsetPortCount(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetPortCount * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREsetPortCount(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREsetPortCount *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREsetPortCount *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount, sizeof(_vbox__IStorageController_USCOREsetPortCount), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREsetPortCount *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_portCount1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREsetPortCount::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_portCount1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "portCount", &(a->_vbox__IStorageController_USCOREsetPortCount::portCount), "xsd:unsignedInt"))
				{	soap_flag_portCount1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREsetPortCount *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount, 0, sizeof(_vbox__IStorageController_USCOREsetPortCount), 0, soap_copy__vbox__IStorageController_USCOREsetPortCount);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_portCount1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetPortCount * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREsetPortCount(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREsetPortCount(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetPortCount;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREsetPortCount);
		((_vbox__IStorageController_USCOREsetPortCount*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetPortCount[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREsetPortCount);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREsetPortCount*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREsetPortCount*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREsetPortCount(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREsetPortCount %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREsetPortCount*)p = *(_vbox__IStorageController_USCOREsetPortCount*)q;
}

void _vbox__IStorageController_USCOREgetPortCountResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREgetPortCountResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetPortCountResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetPortCountResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetPortCountResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetPortCountResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetPortCountResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetPortCountResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetPortCountResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetPortCountResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetPortCountResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetPortCountResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetPortCountResponse(struct soap *soap, _vbox__IStorageController_USCOREgetPortCountResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetPortCountResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetPortCountResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetPortCountResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetPortCountResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetPortCountResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetPortCountResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetPortCountResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse, sizeof(_vbox__IStorageController_USCOREgetPortCountResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetPortCountResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetPortCountResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetPortCountResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse, 0, sizeof(_vbox__IStorageController_USCOREgetPortCountResponse), 0, soap_copy__vbox__IStorageController_USCOREgetPortCountResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetPortCountResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetPortCountResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetPortCountResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetPortCountResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetPortCountResponse);
		((_vbox__IStorageController_USCOREgetPortCountResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetPortCountResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetPortCountResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetPortCountResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetPortCountResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetPortCountResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetPortCountResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetPortCountResponse*)q;
}

void _vbox__IStorageController_USCOREgetPortCount::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetPortCount::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetPortCount::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetPortCount::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetPortCount::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetPortCount::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetPortCount(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetPortCount(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetPortCount *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetPortCount::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetPortCount::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetPortCount(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetPortCount * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetPortCount(struct soap *soap, _vbox__IStorageController_USCOREgetPortCount *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetPortCount(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetPortCount::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetPortCount(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetPortCount * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetPortCount(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetPortCount *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetPortCount *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount, sizeof(_vbox__IStorageController_USCOREgetPortCount), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetPortCount *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetPortCount::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetPortCount *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount, 0, sizeof(_vbox__IStorageController_USCOREgetPortCount), 0, soap_copy__vbox__IStorageController_USCOREgetPortCount);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetPortCount * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetPortCount(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetPortCount(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetPortCount;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetPortCount);
		((_vbox__IStorageController_USCOREgetPortCount*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetPortCount[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetPortCount);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetPortCount*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetPortCount*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetPortCount(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetPortCount %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetPortCount*)p = *(_vbox__IStorageController_USCOREgetPortCount*)q;
}

void _vbox__IStorageController_USCOREsetInstanceResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREsetInstanceResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREsetInstanceResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREsetInstanceResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREsetInstanceResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREsetInstanceResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREsetInstanceResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREsetInstanceResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREsetInstanceResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetInstanceResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREsetInstanceResponse(struct soap *soap, _vbox__IStorageController_USCOREsetInstanceResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREsetInstanceResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREsetInstanceResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREsetInstanceResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetInstanceResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREsetInstanceResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREsetInstanceResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREsetInstanceResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse, sizeof(_vbox__IStorageController_USCOREsetInstanceResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREsetInstanceResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREsetInstanceResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse, 0, sizeof(_vbox__IStorageController_USCOREsetInstanceResponse), 0, soap_copy__vbox__IStorageController_USCOREsetInstanceResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetInstanceResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREsetInstanceResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREsetInstanceResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetInstanceResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREsetInstanceResponse);
		((_vbox__IStorageController_USCOREsetInstanceResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetInstanceResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREsetInstanceResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREsetInstanceResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREsetInstanceResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREsetInstanceResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREsetInstanceResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREsetInstanceResponse*)p = *(_vbox__IStorageController_USCOREsetInstanceResponse*)q;
}

void _vbox__IStorageController_USCOREsetInstance::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREsetInstance::_USCOREthis);
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREsetInstance::instance);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREsetInstance::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREsetInstance::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREsetInstance::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREsetInstance);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREsetInstance::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREsetInstance(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREsetInstance(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREsetInstance *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetInstance), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREsetInstance::_USCOREthis), ""))
		return soap->error;
	if (soap_out_unsignedInt(soap, "instance", -1, &(a->_vbox__IStorageController_USCOREsetInstance::instance), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREsetInstance::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREsetInstance(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetInstance * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREsetInstance(struct soap *soap, _vbox__IStorageController_USCOREsetInstance *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREsetInstance(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREsetInstance::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREsetInstance(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetInstance * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREsetInstance(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREsetInstance *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREsetInstance *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREsetInstance, sizeof(_vbox__IStorageController_USCOREsetInstance), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREsetInstance)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREsetInstance *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_instance1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREsetInstance::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_instance1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "instance", &(a->_vbox__IStorageController_USCOREsetInstance::instance), "xsd:unsignedInt"))
				{	soap_flag_instance1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREsetInstance *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREsetInstance, 0, sizeof(_vbox__IStorageController_USCOREsetInstance), 0, soap_copy__vbox__IStorageController_USCOREsetInstance);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_instance1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREsetInstance * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREsetInstance(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREsetInstance(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREsetInstance, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetInstance;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREsetInstance);
		((_vbox__IStorageController_USCOREsetInstance*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREsetInstance[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREsetInstance);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREsetInstance*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREsetInstance*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREsetInstance(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREsetInstance %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREsetInstance*)p = *(_vbox__IStorageController_USCOREsetInstance*)q;
}

void _vbox__IStorageController_USCOREgetInstanceResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREgetInstanceResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetInstanceResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetInstanceResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetInstanceResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetInstanceResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetInstanceResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetInstanceResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetInstanceResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetInstanceResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetInstanceResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetInstanceResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetInstanceResponse(struct soap *soap, _vbox__IStorageController_USCOREgetInstanceResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetInstanceResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetInstanceResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetInstanceResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetInstanceResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetInstanceResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetInstanceResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetInstanceResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse, sizeof(_vbox__IStorageController_USCOREgetInstanceResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetInstanceResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetInstanceResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetInstanceResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse, 0, sizeof(_vbox__IStorageController_USCOREgetInstanceResponse), 0, soap_copy__vbox__IStorageController_USCOREgetInstanceResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetInstanceResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetInstanceResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetInstanceResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetInstanceResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetInstanceResponse);
		((_vbox__IStorageController_USCOREgetInstanceResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetInstanceResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetInstanceResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetInstanceResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetInstanceResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetInstanceResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetInstanceResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetInstanceResponse*)p = *(_vbox__IStorageController_USCOREgetInstanceResponse*)q;
}

void _vbox__IStorageController_USCOREgetInstance::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetInstance::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetInstance::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetInstance::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetInstance::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetInstance);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetInstance::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetInstance(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetInstance(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetInstance *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetInstance), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetInstance::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetInstance::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetInstance(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetInstance * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetInstance(struct soap *soap, _vbox__IStorageController_USCOREgetInstance *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetInstance(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetInstance::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetInstance(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetInstance * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetInstance(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetInstance *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetInstance *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetInstance, sizeof(_vbox__IStorageController_USCOREgetInstance), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetInstance)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetInstance *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetInstance::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetInstance *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetInstance, 0, sizeof(_vbox__IStorageController_USCOREgetInstance), 0, soap_copy__vbox__IStorageController_USCOREgetInstance);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetInstance * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetInstance(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetInstance(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetInstance, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetInstance;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetInstance);
		((_vbox__IStorageController_USCOREgetInstance*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetInstance[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetInstance);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetInstance*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetInstance*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetInstance(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetInstance %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetInstance*)p = *(_vbox__IStorageController_USCOREgetInstance*)q;
}

void _vbox__IStorageController_USCOREgetMaxPortCountResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREgetMaxPortCountResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetMaxPortCountResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetMaxPortCountResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetMaxPortCountResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetMaxPortCountResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetMaxPortCountResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetMaxPortCountResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetMaxPortCountResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetMaxPortCountResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetMaxPortCountResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxPortCountResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetMaxPortCountResponse(struct soap *soap, _vbox__IStorageController_USCOREgetMaxPortCountResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetMaxPortCountResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetMaxPortCountResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetMaxPortCountResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxPortCountResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetMaxPortCountResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetMaxPortCountResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetMaxPortCountResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse, sizeof(_vbox__IStorageController_USCOREgetMaxPortCountResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetMaxPortCountResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetMaxPortCountResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetMaxPortCountResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse, 0, sizeof(_vbox__IStorageController_USCOREgetMaxPortCountResponse), 0, soap_copy__vbox__IStorageController_USCOREgetMaxPortCountResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxPortCountResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetMaxPortCountResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetMaxPortCountResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxPortCountResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetMaxPortCountResponse);
		((_vbox__IStorageController_USCOREgetMaxPortCountResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxPortCountResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetMaxPortCountResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetMaxPortCountResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetMaxPortCountResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetMaxPortCountResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetMaxPortCountResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetMaxPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetMaxPortCountResponse*)q;
}

void _vbox__IStorageController_USCOREgetMaxPortCount::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetMaxPortCount::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetMaxPortCount::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetMaxPortCount::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetMaxPortCount::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetMaxPortCount::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetMaxPortCount(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetMaxPortCount(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetMaxPortCount *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetMaxPortCount::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetMaxPortCount::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetMaxPortCount(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxPortCount * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetMaxPortCount(struct soap *soap, _vbox__IStorageController_USCOREgetMaxPortCount *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetMaxPortCount(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetMaxPortCount::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetMaxPortCount(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxPortCount * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetMaxPortCount(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetMaxPortCount *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetMaxPortCount *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount, sizeof(_vbox__IStorageController_USCOREgetMaxPortCount), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetMaxPortCount *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetMaxPortCount::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetMaxPortCount *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount, 0, sizeof(_vbox__IStorageController_USCOREgetMaxPortCount), 0, soap_copy__vbox__IStorageController_USCOREgetMaxPortCount);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxPortCount * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetMaxPortCount(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetMaxPortCount(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxPortCount;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetMaxPortCount);
		((_vbox__IStorageController_USCOREgetMaxPortCount*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxPortCount[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetMaxPortCount);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetMaxPortCount*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetMaxPortCount*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetMaxPortCount(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetMaxPortCount %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetMaxPortCount*)p = *(_vbox__IStorageController_USCOREgetMaxPortCount*)q;
}

void _vbox__IStorageController_USCOREgetMinPortCountResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREgetMinPortCountResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetMinPortCountResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetMinPortCountResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetMinPortCountResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetMinPortCountResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetMinPortCountResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetMinPortCountResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetMinPortCountResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetMinPortCountResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetMinPortCountResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMinPortCountResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetMinPortCountResponse(struct soap *soap, _vbox__IStorageController_USCOREgetMinPortCountResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetMinPortCountResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetMinPortCountResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetMinPortCountResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMinPortCountResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetMinPortCountResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetMinPortCountResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetMinPortCountResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse, sizeof(_vbox__IStorageController_USCOREgetMinPortCountResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetMinPortCountResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetMinPortCountResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetMinPortCountResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse, 0, sizeof(_vbox__IStorageController_USCOREgetMinPortCountResponse), 0, soap_copy__vbox__IStorageController_USCOREgetMinPortCountResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMinPortCountResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetMinPortCountResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetMinPortCountResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMinPortCountResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetMinPortCountResponse);
		((_vbox__IStorageController_USCOREgetMinPortCountResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMinPortCountResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetMinPortCountResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetMinPortCountResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetMinPortCountResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetMinPortCountResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetMinPortCountResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetMinPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetMinPortCountResponse*)q;
}

void _vbox__IStorageController_USCOREgetMinPortCount::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetMinPortCount::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetMinPortCount::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetMinPortCount::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetMinPortCount::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetMinPortCount::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetMinPortCount(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetMinPortCount(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetMinPortCount *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetMinPortCount::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetMinPortCount::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetMinPortCount(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMinPortCount * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetMinPortCount(struct soap *soap, _vbox__IStorageController_USCOREgetMinPortCount *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetMinPortCount(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetMinPortCount::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetMinPortCount(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMinPortCount * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetMinPortCount(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetMinPortCount *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetMinPortCount *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount, sizeof(_vbox__IStorageController_USCOREgetMinPortCount), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetMinPortCount *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetMinPortCount::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetMinPortCount *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount, 0, sizeof(_vbox__IStorageController_USCOREgetMinPortCount), 0, soap_copy__vbox__IStorageController_USCOREgetMinPortCount);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMinPortCount * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetMinPortCount(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetMinPortCount(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMinPortCount;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetMinPortCount);
		((_vbox__IStorageController_USCOREgetMinPortCount*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMinPortCount[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetMinPortCount);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetMinPortCount*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetMinPortCount*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetMinPortCount(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetMinPortCount %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetMinPortCount*)p = *(_vbox__IStorageController_USCOREgetMinPortCount*)q;
}

void _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(struct soap *soap, _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse, sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse, 0, sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse), 0, soap_copy__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse);
		((_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)q;
}

void _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(struct soap *soap, _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount, sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount, 0, sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount), 0, soap_copy__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount);
		((_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p = *(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)q;
}

void _vbox__IStorageController_USCOREgetNameResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetNameResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetNameResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetNameResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetNameResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetNameResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetNameResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetNameResponse(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetNameResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IStorageController_USCOREgetNameResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetNameResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetNameResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetNameResponse * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetNameResponse(struct soap *soap, _vbox__IStorageController_USCOREgetNameResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetNameResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetNameResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetNameResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetNameResponse * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetNameResponse(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetNameResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetNameResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse, sizeof(_vbox__IStorageController_USCOREgetNameResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetNameResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IStorageController_USCOREgetNameResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetNameResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse, 0, sizeof(_vbox__IStorageController_USCOREgetNameResponse), 0, soap_copy__vbox__IStorageController_USCOREgetNameResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetNameResponse * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetNameResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetNameResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetNameResponse;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetNameResponse);
		((_vbox__IStorageController_USCOREgetNameResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetNameResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetNameResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetNameResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetNameResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetNameResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetNameResponse %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetNameResponse*)p = *(_vbox__IStorageController_USCOREgetNameResponse*)q;
}

void _vbox__IStorageController_USCOREgetName::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IStorageController_USCOREgetName::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IStorageController_USCOREgetName::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IStorageController_USCOREgetName::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IStorageController_USCOREgetName::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IStorageController_USCOREgetName);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IStorageController_USCOREgetName::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IStorageController_USCOREgetName(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IStorageController_USCOREgetName(struct soap *soap, const char *tag, int id, const _vbox__IStorageController_USCOREgetName *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetName), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IStorageController_USCOREgetName::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IStorageController_USCOREgetName::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IStorageController_USCOREgetName(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetName * SOAP_FMAC4 soap_get__vbox__IStorageController_USCOREgetName(struct soap *soap, _vbox__IStorageController_USCOREgetName *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IStorageController_USCOREgetName(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IStorageController_USCOREgetName::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IStorageController_USCOREgetName(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetName * SOAP_FMAC4 soap_in__vbox__IStorageController_USCOREgetName(struct soap *soap, const char *tag, _vbox__IStorageController_USCOREgetName *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IStorageController_USCOREgetName *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IStorageController_USCOREgetName, sizeof(_vbox__IStorageController_USCOREgetName), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IStorageController_USCOREgetName)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IStorageController_USCOREgetName *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IStorageController_USCOREgetName::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IStorageController_USCOREgetName *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IStorageController_USCOREgetName, 0, sizeof(_vbox__IStorageController_USCOREgetName), 0, soap_copy__vbox__IStorageController_USCOREgetName);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IStorageController_USCOREgetName * SOAP_FMAC4 soap_instantiate__vbox__IStorageController_USCOREgetName(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IStorageController_USCOREgetName(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IStorageController_USCOREgetName, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetName;
		if (size)
			*size = sizeof(_vbox__IStorageController_USCOREgetName);
		((_vbox__IStorageController_USCOREgetName*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IStorageController_USCOREgetName[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IStorageController_USCOREgetName);
		for (int i = 0; i < n; i++)
			((_vbox__IStorageController_USCOREgetName*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IStorageController_USCOREgetName*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IStorageController_USCOREgetName(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IStorageController_USCOREgetName %p -> %p\n", q, p));
	*(_vbox__IStorageController_USCOREgetName*)p = *(_vbox__IStorageController_USCOREgetName*)q;
}

void _vbox__ISession_USCOREcloseResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__ISession_USCOREcloseResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__ISession_USCOREcloseResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREcloseResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREcloseResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREcloseResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREcloseResponse(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREcloseResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREcloseResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREcloseResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREcloseResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREcloseResponse * SOAP_FMAC4 soap_get__vbox__ISession_USCOREcloseResponse(struct soap *soap, _vbox__ISession_USCOREcloseResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREcloseResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREcloseResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREcloseResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREcloseResponse * SOAP_FMAC4 soap_in__vbox__ISession_USCOREcloseResponse(struct soap *soap, const char *tag, _vbox__ISession_USCOREcloseResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREcloseResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREcloseResponse, sizeof(_vbox__ISession_USCOREcloseResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREcloseResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREcloseResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREcloseResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREcloseResponse, 0, sizeof(_vbox__ISession_USCOREcloseResponse), 0, soap_copy__vbox__ISession_USCOREcloseResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREcloseResponse * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREcloseResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREcloseResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREcloseResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREcloseResponse;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREcloseResponse);
		((_vbox__ISession_USCOREcloseResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREcloseResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREcloseResponse);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREcloseResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREcloseResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREcloseResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREcloseResponse %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREcloseResponse*)p = *(_vbox__ISession_USCOREcloseResponse*)q;
}

void _vbox__ISession_USCOREclose::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREclose::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREclose::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREclose::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREclose::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREclose);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREclose::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREclose(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREclose(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREclose *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREclose), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__ISession_USCOREclose::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREclose::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREclose(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREclose * SOAP_FMAC4 soap_get__vbox__ISession_USCOREclose(struct soap *soap, _vbox__ISession_USCOREclose *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREclose(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREclose::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREclose(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREclose * SOAP_FMAC4 soap_in__vbox__ISession_USCOREclose(struct soap *soap, const char *tag, _vbox__ISession_USCOREclose *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREclose *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREclose, sizeof(_vbox__ISession_USCOREclose), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREclose)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREclose *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__ISession_USCOREclose::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREclose *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREclose, 0, sizeof(_vbox__ISession_USCOREclose), 0, soap_copy__vbox__ISession_USCOREclose);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREclose * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREclose(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREclose(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREclose, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREclose;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREclose);
		((_vbox__ISession_USCOREclose*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREclose[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREclose);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREclose*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREclose*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREclose(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREclose %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREclose*)p = *(_vbox__ISession_USCOREclose*)q;
}

void _vbox__ISession_USCOREgetConsoleResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREgetConsoleResponse::returnval);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetConsoleResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREgetConsoleResponse::returnval);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetConsoleResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetConsoleResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetConsoleResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetConsoleResponse(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetConsoleResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__ISession_USCOREgetConsoleResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetConsoleResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetConsoleResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetConsoleResponse * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetConsoleResponse(struct soap *soap, _vbox__ISession_USCOREgetConsoleResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetConsoleResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetConsoleResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetConsoleResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetConsoleResponse * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetConsoleResponse(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetConsoleResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetConsoleResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse, sizeof(_vbox__ISession_USCOREgetConsoleResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetConsoleResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__ISession_USCOREgetConsoleResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetConsoleResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse, 0, sizeof(_vbox__ISession_USCOREgetConsoleResponse), 0, soap_copy__vbox__ISession_USCOREgetConsoleResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetConsoleResponse * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetConsoleResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetConsoleResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetConsoleResponse;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetConsoleResponse);
		((_vbox__ISession_USCOREgetConsoleResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetConsoleResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetConsoleResponse);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetConsoleResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetConsoleResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetConsoleResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetConsoleResponse %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetConsoleResponse*)p = *(_vbox__ISession_USCOREgetConsoleResponse*)q;
}

void _vbox__ISession_USCOREgetConsole::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREgetConsole::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetConsole::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREgetConsole::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetConsole::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetConsole);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetConsole::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetConsole(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetConsole(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetConsole *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetConsole), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__ISession_USCOREgetConsole::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetConsole::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetConsole(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetConsole * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetConsole(struct soap *soap, _vbox__ISession_USCOREgetConsole *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetConsole(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetConsole::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetConsole(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetConsole * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetConsole(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetConsole *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetConsole *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetConsole, sizeof(_vbox__ISession_USCOREgetConsole), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetConsole)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetConsole *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__ISession_USCOREgetConsole::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetConsole *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetConsole, 0, sizeof(_vbox__ISession_USCOREgetConsole), 0, soap_copy__vbox__ISession_USCOREgetConsole);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetConsole * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetConsole(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetConsole(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetConsole, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetConsole;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetConsole);
		((_vbox__ISession_USCOREgetConsole*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetConsole[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetConsole);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetConsole*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetConsole*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetConsole(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetConsole %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetConsole*)p = *(_vbox__ISession_USCOREgetConsole*)q;
}

void _vbox__ISession_USCOREgetMachineResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREgetMachineResponse::returnval);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetMachineResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREgetMachineResponse::returnval);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetMachineResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetMachineResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetMachineResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetMachineResponse(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetMachineResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__ISession_USCOREgetMachineResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetMachineResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetMachineResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetMachineResponse * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetMachineResponse(struct soap *soap, _vbox__ISession_USCOREgetMachineResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetMachineResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetMachineResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetMachineResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetMachineResponse * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetMachineResponse(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetMachineResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetMachineResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse, sizeof(_vbox__ISession_USCOREgetMachineResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetMachineResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__ISession_USCOREgetMachineResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetMachineResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse, 0, sizeof(_vbox__ISession_USCOREgetMachineResponse), 0, soap_copy__vbox__ISession_USCOREgetMachineResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetMachineResponse * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetMachineResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetMachineResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetMachineResponse;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetMachineResponse);
		((_vbox__ISession_USCOREgetMachineResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetMachineResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetMachineResponse);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetMachineResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetMachineResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetMachineResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetMachineResponse %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetMachineResponse*)p = *(_vbox__ISession_USCOREgetMachineResponse*)q;
}

void _vbox__ISession_USCOREgetMachine::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREgetMachine::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetMachine::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREgetMachine::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetMachine::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetMachine);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetMachine::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetMachine(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetMachine(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetMachine *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetMachine), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__ISession_USCOREgetMachine::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetMachine::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetMachine(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetMachine * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetMachine(struct soap *soap, _vbox__ISession_USCOREgetMachine *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetMachine(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetMachine::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetMachine(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetMachine * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetMachine(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetMachine *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetMachine *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetMachine, sizeof(_vbox__ISession_USCOREgetMachine), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetMachine)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetMachine *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__ISession_USCOREgetMachine::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetMachine *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetMachine, 0, sizeof(_vbox__ISession_USCOREgetMachine), 0, soap_copy__vbox__ISession_USCOREgetMachine);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetMachine * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetMachine(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetMachine(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetMachine, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetMachine;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetMachine);
		((_vbox__ISession_USCOREgetMachine*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetMachine[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetMachine);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetMachine*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetMachine*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetMachine(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetMachine %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetMachine*)p = *(_vbox__ISession_USCOREgetMachine*)q;
}

void _vbox__ISession_USCOREgetTypeResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__SessionType(soap, &this->_vbox__ISession_USCOREgetTypeResponse::returnval);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetTypeResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetTypeResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetTypeResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetTypeResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetTypeResponse(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetTypeResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse), type))
		return soap->error;
	if (soap_out_vbox__SessionType(soap, "returnval", -1, &(a->_vbox__ISession_USCOREgetTypeResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetTypeResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetTypeResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetTypeResponse * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetTypeResponse(struct soap *soap, _vbox__ISession_USCOREgetTypeResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetTypeResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetTypeResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetTypeResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetTypeResponse * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetTypeResponse(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetTypeResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetTypeResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse, sizeof(_vbox__ISession_USCOREgetTypeResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetTypeResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__SessionType(soap, "returnval", &(a->_vbox__ISession_USCOREgetTypeResponse::returnval), "vbox:SessionType"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetTypeResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse, 0, sizeof(_vbox__ISession_USCOREgetTypeResponse), 0, soap_copy__vbox__ISession_USCOREgetTypeResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetTypeResponse * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetTypeResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetTypeResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetTypeResponse;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetTypeResponse);
		((_vbox__ISession_USCOREgetTypeResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetTypeResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetTypeResponse);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetTypeResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetTypeResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetTypeResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetTypeResponse %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetTypeResponse*)p = *(_vbox__ISession_USCOREgetTypeResponse*)q;
}

void _vbox__ISession_USCOREgetType::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREgetType::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetType::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREgetType::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetType::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetType);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetType::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetType(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetType(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetType *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetType), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__ISession_USCOREgetType::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetType::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetType(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetType * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetType(struct soap *soap, _vbox__ISession_USCOREgetType *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetType::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetType(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetType * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetType(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetType *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetType, sizeof(_vbox__ISession_USCOREgetType), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetType)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetType *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__ISession_USCOREgetType::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetType, 0, sizeof(_vbox__ISession_USCOREgetType), 0, soap_copy__vbox__ISession_USCOREgetType);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetType * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetType(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetType(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetType, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetType;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetType);
		((_vbox__ISession_USCOREgetType*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetType[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetType);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetType*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetType*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetType(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetType %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetType*)p = *(_vbox__ISession_USCOREgetType*)q;
}

void _vbox__ISession_USCOREgetStateResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__SessionState(soap, &this->_vbox__ISession_USCOREgetStateResponse::returnval);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetStateResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetStateResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetStateResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetStateResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetStateResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetStateResponse(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetStateResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetStateResponse), type))
		return soap->error;
	if (soap_out_vbox__SessionState(soap, "returnval", -1, &(a->_vbox__ISession_USCOREgetStateResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetStateResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetStateResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetStateResponse * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetStateResponse(struct soap *soap, _vbox__ISession_USCOREgetStateResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetStateResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetStateResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetStateResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetStateResponse * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetStateResponse(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetStateResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetStateResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetStateResponse, sizeof(_vbox__ISession_USCOREgetStateResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetStateResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetStateResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__SessionState(soap, "returnval", &(a->_vbox__ISession_USCOREgetStateResponse::returnval), "vbox:SessionState"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetStateResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetStateResponse, 0, sizeof(_vbox__ISession_USCOREgetStateResponse), 0, soap_copy__vbox__ISession_USCOREgetStateResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetStateResponse * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetStateResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetStateResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetStateResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetStateResponse;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetStateResponse);
		((_vbox__ISession_USCOREgetStateResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetStateResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetStateResponse);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetStateResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetStateResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetStateResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetStateResponse %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetStateResponse*)p = *(_vbox__ISession_USCOREgetStateResponse*)q;
}

void _vbox__ISession_USCOREgetState::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__ISession_USCOREgetState::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__ISession_USCOREgetState::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__ISession_USCOREgetState::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__ISession_USCOREgetState::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__ISession_USCOREgetState);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__ISession_USCOREgetState::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__ISession_USCOREgetState(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__ISession_USCOREgetState(struct soap *soap, const char *tag, int id, const _vbox__ISession_USCOREgetState *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__ISession_USCOREgetState), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__ISession_USCOREgetState::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__ISession_USCOREgetState::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__ISession_USCOREgetState(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetState * SOAP_FMAC4 soap_get__vbox__ISession_USCOREgetState(struct soap *soap, _vbox__ISession_USCOREgetState *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__ISession_USCOREgetState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__ISession_USCOREgetState::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__ISession_USCOREgetState(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__ISession_USCOREgetState * SOAP_FMAC4 soap_in__vbox__ISession_USCOREgetState(struct soap *soap, const char *tag, _vbox__ISession_USCOREgetState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__ISession_USCOREgetState *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__ISession_USCOREgetState, sizeof(_vbox__ISession_USCOREgetState), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__ISession_USCOREgetState)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__ISession_USCOREgetState *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__ISession_USCOREgetState::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__ISession_USCOREgetState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__ISession_USCOREgetState, 0, sizeof(_vbox__ISession_USCOREgetState), 0, soap_copy__vbox__ISession_USCOREgetState);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__ISession_USCOREgetState * SOAP_FMAC4 soap_instantiate__vbox__ISession_USCOREgetState(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__ISession_USCOREgetState(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__ISession_USCOREgetState, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetState;
		if (size)
			*size = sizeof(_vbox__ISession_USCOREgetState);
		((_vbox__ISession_USCOREgetState*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__ISession_USCOREgetState[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__ISession_USCOREgetState);
		for (int i = 0; i < n; i++)
			((_vbox__ISession_USCOREgetState*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__ISession_USCOREgetState*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__ISession_USCOREgetState(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__ISession_USCOREgetState %p -> %p\n", q, p));
	*(_vbox__ISession_USCOREgetState*)p = *(_vbox__ISession_USCOREgetState*)q;
}

void _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse, sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse);
		((_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)p = *(_vbox__IVRDPServer_USCOREsetReuseSingleConnectionResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetReuseSingleConnection::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::_USCOREthis);
	soap_default_bool(soap, &this->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::reuseSingleConnection);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetReuseSingleConnection::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetReuseSingleConnection::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetReuseSingleConnection::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetReuseSingleConnection(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetReuseSingleConnection(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetReuseSingleConnection *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::_USCOREthis), ""))
		return soap->error;
	if (soap_out_bool(soap, "reuseSingleConnection", -1, &(a->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::reuseSingleConnection), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetReuseSingleConnection::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetReuseSingleConnection(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetReuseSingleConnection * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetReuseSingleConnection(struct soap *soap, _vbox__IVRDPServer_USCOREsetReuseSingleConnection *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetReuseSingleConnection(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetReuseSingleConnection::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetReuseSingleConnection(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetReuseSingleConnection * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetReuseSingleConnection(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetReuseSingleConnection *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetReuseSingleConnection *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection, sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnection), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetReuseSingleConnection *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_reuseSingleConnection1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_reuseSingleConnection1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "reuseSingleConnection", &(a->_vbox__IVRDPServer_USCOREsetReuseSingleConnection::reuseSingleConnection), "xsd:boolean"))
				{	soap_flag_reuseSingleConnection1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetReuseSingleConnection *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection, 0, sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnection), 0, soap_copy__vbox__IVRDPServer_USCOREsetReuseSingleConnection);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_reuseSingleConnection1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetReuseSingleConnection * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetReuseSingleConnection(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetReuseSingleConnection(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetReuseSingleConnection, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetReuseSingleConnection;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnection);
		((_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetReuseSingleConnection[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetReuseSingleConnection);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetReuseSingleConnection(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetReuseSingleConnection %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)p = *(_vbox__IVRDPServer_USCOREsetReuseSingleConnection*)q;
}

void _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_bool(soap, &this->_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse), type))
		return soap->error;
	if (soap_out_bool(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse, sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse::returnval), "xsd:boolean"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse);
		((_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)p = *(_vbox__IVRDPServer_USCOREgetReuseSingleConnectionResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetReuseSingleConnection::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetReuseSingleConnection::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetReuseSingleConnection::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetReuseSingleConnection::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetReuseSingleConnection::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetReuseSingleConnection::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetReuseSingleConnection(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetReuseSingleConnection(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetReuseSingleConnection *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetReuseSingleConnection::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetReuseSingleConnection::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetReuseSingleConnection(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetReuseSingleConnection * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetReuseSingleConnection(struct soap *soap, _vbox__IVRDPServer_USCOREgetReuseSingleConnection *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetReuseSingleConnection(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetReuseSingleConnection::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetReuseSingleConnection(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetReuseSingleConnection * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetReuseSingleConnection(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetReuseSingleConnection *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetReuseSingleConnection *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection, sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnection), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetReuseSingleConnection *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetReuseSingleConnection::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetReuseSingleConnection *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection, 0, sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnection), 0, soap_copy__vbox__IVRDPServer_USCOREgetReuseSingleConnection);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetReuseSingleConnection * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetReuseSingleConnection(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetReuseSingleConnection(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetReuseSingleConnection, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetReuseSingleConnection;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnection);
		((_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetReuseSingleConnection[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetReuseSingleConnection);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetReuseSingleConnection(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetReuseSingleConnection %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)p = *(_vbox__IVRDPServer_USCOREgetReuseSingleConnection*)q;
}

void _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse, sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse);
		((_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)p = *(_vbox__IVRDPServer_USCOREsetAllowMultiConnectionResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetAllowMultiConnection::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::_USCOREthis);
	soap_default_bool(soap, &this->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::allowMultiConnection);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetAllowMultiConnection::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetAllowMultiConnection::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetAllowMultiConnection::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetAllowMultiConnection(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetAllowMultiConnection(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetAllowMultiConnection *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::_USCOREthis), ""))
		return soap->error;
	if (soap_out_bool(soap, "allowMultiConnection", -1, &(a->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::allowMultiConnection), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetAllowMultiConnection::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetAllowMultiConnection(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAllowMultiConnection * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetAllowMultiConnection(struct soap *soap, _vbox__IVRDPServer_USCOREsetAllowMultiConnection *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetAllowMultiConnection(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetAllowMultiConnection::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetAllowMultiConnection(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAllowMultiConnection * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetAllowMultiConnection(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetAllowMultiConnection *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetAllowMultiConnection *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection, sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnection), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetAllowMultiConnection *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_allowMultiConnection1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_allowMultiConnection1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "allowMultiConnection", &(a->_vbox__IVRDPServer_USCOREsetAllowMultiConnection::allowMultiConnection), "xsd:boolean"))
				{	soap_flag_allowMultiConnection1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetAllowMultiConnection *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection, 0, sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnection), 0, soap_copy__vbox__IVRDPServer_USCOREsetAllowMultiConnection);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_allowMultiConnection1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAllowMultiConnection * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetAllowMultiConnection(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetAllowMultiConnection(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAllowMultiConnection, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAllowMultiConnection;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnection);
		((_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAllowMultiConnection[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetAllowMultiConnection);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetAllowMultiConnection(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetAllowMultiConnection %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)p = *(_vbox__IVRDPServer_USCOREsetAllowMultiConnection*)q;
}

void _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_bool(soap, &this->_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse), type))
		return soap->error;
	if (soap_out_bool(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse, sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse::returnval), "xsd:boolean"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse);
		((_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)p = *(_vbox__IVRDPServer_USCOREgetAllowMultiConnectionResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetAllowMultiConnection::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetAllowMultiConnection::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetAllowMultiConnection::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetAllowMultiConnection::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetAllowMultiConnection::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetAllowMultiConnection::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetAllowMultiConnection(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetAllowMultiConnection(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetAllowMultiConnection *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetAllowMultiConnection::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetAllowMultiConnection::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetAllowMultiConnection(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAllowMultiConnection * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetAllowMultiConnection(struct soap *soap, _vbox__IVRDPServer_USCOREgetAllowMultiConnection *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetAllowMultiConnection(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetAllowMultiConnection::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetAllowMultiConnection(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAllowMultiConnection * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetAllowMultiConnection(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetAllowMultiConnection *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetAllowMultiConnection *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection, sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnection), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetAllowMultiConnection *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetAllowMultiConnection::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetAllowMultiConnection *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection, 0, sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnection), 0, soap_copy__vbox__IVRDPServer_USCOREgetAllowMultiConnection);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAllowMultiConnection * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetAllowMultiConnection(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetAllowMultiConnection(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAllowMultiConnection, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAllowMultiConnection;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnection);
		((_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAllowMultiConnection[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetAllowMultiConnection);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetAllowMultiConnection(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetAllowMultiConnection %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)p = *(_vbox__IVRDPServer_USCOREgetAllowMultiConnection*)q;
}

void _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse, sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse);
		((_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetAuthTimeoutResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetAuthTimeoutResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)p = *(_vbox__IVRDPServer_USCOREsetAuthTimeoutResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetAuthTimeout::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetAuthTimeout::_USCOREthis);
	soap_default_unsignedInt(soap, &this->_vbox__IVRDPServer_USCOREsetAuthTimeout::authTimeout);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetAuthTimeout::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetAuthTimeout::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetAuthTimeout::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetAuthTimeout::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetAuthTimeout(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetAuthTimeout(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetAuthTimeout *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetAuthTimeout::_USCOREthis), ""))
		return soap->error;
	if (soap_out_unsignedInt(soap, "authTimeout", -1, &(a->_vbox__IVRDPServer_USCOREsetAuthTimeout::authTimeout), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetAuthTimeout::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetAuthTimeout(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTimeout * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetAuthTimeout(struct soap *soap, _vbox__IVRDPServer_USCOREsetAuthTimeout *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetAuthTimeout(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetAuthTimeout::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetAuthTimeout(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTimeout * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetAuthTimeout(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetAuthTimeout *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetAuthTimeout *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout, sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeout), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetAuthTimeout *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_authTimeout1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetAuthTimeout::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_authTimeout1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "authTimeout", &(a->_vbox__IVRDPServer_USCOREsetAuthTimeout::authTimeout), "xsd:unsignedInt"))
				{	soap_flag_authTimeout1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetAuthTimeout *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout, 0, sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeout), 0, soap_copy__vbox__IVRDPServer_USCOREsetAuthTimeout);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_authTimeout1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTimeout * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTimeout(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTimeout(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTimeout, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthTimeout;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeout);
		((_vbox__IVRDPServer_USCOREsetAuthTimeout*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthTimeout[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetAuthTimeout);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetAuthTimeout*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetAuthTimeout*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetAuthTimeout(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetAuthTimeout %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetAuthTimeout*)p = *(_vbox__IVRDPServer_USCOREsetAuthTimeout*)q;
}

void _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse, sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse);
		((_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetAuthTimeoutResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetAuthTimeoutResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)p = *(_vbox__IVRDPServer_USCOREgetAuthTimeoutResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetAuthTimeout::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetAuthTimeout::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetAuthTimeout::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetAuthTimeout::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetAuthTimeout::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetAuthTimeout::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetAuthTimeout(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetAuthTimeout(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetAuthTimeout *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetAuthTimeout::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetAuthTimeout::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetAuthTimeout(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTimeout * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetAuthTimeout(struct soap *soap, _vbox__IVRDPServer_USCOREgetAuthTimeout *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetAuthTimeout(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetAuthTimeout::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetAuthTimeout(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTimeout * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetAuthTimeout(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetAuthTimeout *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetAuthTimeout *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout, sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeout), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetAuthTimeout *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetAuthTimeout::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetAuthTimeout *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout, 0, sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeout), 0, soap_copy__vbox__IVRDPServer_USCOREgetAuthTimeout);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTimeout * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTimeout(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTimeout(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTimeout, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthTimeout;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeout);
		((_vbox__IVRDPServer_USCOREgetAuthTimeout*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthTimeout[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetAuthTimeout);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetAuthTimeout*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetAuthTimeout*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetAuthTimeout(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetAuthTimeout %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetAuthTimeout*)p = *(_vbox__IVRDPServer_USCOREgetAuthTimeout*)q;
}

void _vbox__IVRDPServer_USCOREsetAuthTypeResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetAuthTypeResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetAuthTypeResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetAuthTypeResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetAuthTypeResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetAuthTypeResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetAuthTypeResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetAuthTypeResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetAuthTypeResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTypeResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetAuthTypeResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetAuthTypeResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetAuthTypeResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetAuthTypeResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetAuthTypeResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTypeResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetAuthTypeResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetAuthTypeResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetAuthTypeResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse, sizeof(_vbox__IVRDPServer_USCOREsetAuthTypeResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetAuthTypeResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetAuthTypeResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetAuthTypeResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetAuthTypeResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthTypeResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTypeResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetAuthTypeResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthTypeResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthTypeResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetAuthTypeResponse);
		((_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthTypeResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetAuthTypeResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetAuthTypeResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetAuthTypeResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)p = *(_vbox__IVRDPServer_USCOREsetAuthTypeResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetAuthType::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetAuthType::_USCOREthis);
	soap_default_vbox__VRDPAuthType(soap, &this->_vbox__IVRDPServer_USCOREsetAuthType::authType);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetAuthType::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetAuthType::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetAuthType::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetAuthType::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetAuthType(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetAuthType(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetAuthType *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetAuthType::_USCOREthis), ""))
		return soap->error;
	if (soap_out_vbox__VRDPAuthType(soap, "authType", -1, &(a->_vbox__IVRDPServer_USCOREsetAuthType::authType), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetAuthType::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetAuthType(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthType * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetAuthType(struct soap *soap, _vbox__IVRDPServer_USCOREsetAuthType *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetAuthType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetAuthType::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetAuthType(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthType * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetAuthType(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetAuthType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetAuthType *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType, sizeof(_vbox__IVRDPServer_USCOREsetAuthType), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetAuthType *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_authType1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetAuthType::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_authType1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__VRDPAuthType(soap, "authType", &(a->_vbox__IVRDPServer_USCOREsetAuthType::authType), "vbox:VRDPAuthType"))
				{	soap_flag_authType1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetAuthType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType, 0, sizeof(_vbox__IVRDPServer_USCOREsetAuthType), 0, soap_copy__vbox__IVRDPServer_USCOREsetAuthType);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_authType1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetAuthType * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetAuthType(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetAuthType(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetAuthType, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthType;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetAuthType);
		((_vbox__IVRDPServer_USCOREsetAuthType*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetAuthType[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetAuthType);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetAuthType*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetAuthType*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetAuthType(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetAuthType %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetAuthType*)p = *(_vbox__IVRDPServer_USCOREsetAuthType*)q;
}

void _vbox__IVRDPServer_USCOREgetAuthTypeResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__VRDPAuthType(soap, &this->_vbox__IVRDPServer_USCOREgetAuthTypeResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetAuthTypeResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetAuthTypeResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetAuthTypeResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetAuthTypeResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetAuthTypeResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetAuthTypeResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse), type))
		return soap->error;
	if (soap_out_vbox__VRDPAuthType(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetAuthTypeResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetAuthTypeResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetAuthTypeResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTypeResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetAuthTypeResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetAuthTypeResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetAuthTypeResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetAuthTypeResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetAuthTypeResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTypeResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetAuthTypeResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetAuthTypeResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetAuthTypeResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse, sizeof(_vbox__IVRDPServer_USCOREgetAuthTypeResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetAuthTypeResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__VRDPAuthType(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetAuthTypeResponse::returnval), "vbox:VRDPAuthType"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetAuthTypeResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetAuthTypeResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetAuthTypeResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthTypeResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTypeResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetAuthTypeResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthTypeResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthTypeResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetAuthTypeResponse);
		((_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthTypeResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetAuthTypeResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetAuthTypeResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetAuthTypeResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)p = *(_vbox__IVRDPServer_USCOREgetAuthTypeResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetAuthType::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetAuthType::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetAuthType::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetAuthType::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetAuthType::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetAuthType::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetAuthType(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetAuthType(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetAuthType *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetAuthType::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetAuthType::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetAuthType(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthType * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetAuthType(struct soap *soap, _vbox__IVRDPServer_USCOREgetAuthType *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetAuthType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetAuthType::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetAuthType(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthType * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetAuthType(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetAuthType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetAuthType *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType, sizeof(_vbox__IVRDPServer_USCOREgetAuthType), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetAuthType *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetAuthType::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetAuthType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType, 0, sizeof(_vbox__IVRDPServer_USCOREgetAuthType), 0, soap_copy__vbox__IVRDPServer_USCOREgetAuthType);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetAuthType * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetAuthType(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetAuthType(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetAuthType, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthType;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetAuthType);
		((_vbox__IVRDPServer_USCOREgetAuthType*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetAuthType[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetAuthType);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetAuthType*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetAuthType*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetAuthType(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetAuthType %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetAuthType*)p = *(_vbox__IVRDPServer_USCOREgetAuthType*)q;
}

void _vbox__IVRDPServer_USCOREsetNetAddressResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetNetAddressResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetNetAddressResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetNetAddressResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetNetAddressResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetNetAddressResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetNetAddressResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetNetAddressResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetNetAddressResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetNetAddressResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetNetAddressResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetNetAddressResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetNetAddressResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetNetAddressResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetNetAddressResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetNetAddressResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetNetAddressResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetNetAddressResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetNetAddressResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse, sizeof(_vbox__IVRDPServer_USCOREsetNetAddressResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetNetAddressResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetNetAddressResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetNetAddressResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetNetAddressResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetNetAddressResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetNetAddressResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetNetAddressResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddressResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetNetAddressResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetNetAddressResponse);
		((_vbox__IVRDPServer_USCOREsetNetAddressResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetNetAddressResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetNetAddressResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetNetAddressResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetNetAddressResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetNetAddressResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetNetAddressResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetNetAddressResponse*)p = *(_vbox__IVRDPServer_USCOREsetNetAddressResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetNetAddress::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetNetAddress::_USCOREthis);
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetNetAddress::netAddress);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetNetAddress::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetNetAddress::_USCOREthis);
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetNetAddress::netAddress);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetNetAddress::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetNetAddress::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetNetAddress(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetNetAddress(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetNetAddress *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetNetAddress::_USCOREthis), ""))
		return soap->error;
	if (soap_out_std__string(soap, "netAddress", -1, &(a->_vbox__IVRDPServer_USCOREsetNetAddress::netAddress), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetNetAddress::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetNetAddress(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetNetAddress * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetNetAddress(struct soap *soap, _vbox__IVRDPServer_USCOREsetNetAddress *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetNetAddress(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetNetAddress::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetNetAddress(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetNetAddress * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetNetAddress(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetNetAddress *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetNetAddress *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress, sizeof(_vbox__IVRDPServer_USCOREsetNetAddress), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetNetAddress *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_netAddress1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetNetAddress::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_netAddress1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "netAddress", &(a->_vbox__IVRDPServer_USCOREsetNetAddress::netAddress), "xsd:string"))
				{	soap_flag_netAddress1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetNetAddress *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress, 0, sizeof(_vbox__IVRDPServer_USCOREsetNetAddress), 0, soap_copy__vbox__IVRDPServer_USCOREsetNetAddress);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_netAddress1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetNetAddress * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetNetAddress(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetNetAddress(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetNetAddress, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetNetAddress;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetNetAddress);
		((_vbox__IVRDPServer_USCOREsetNetAddress*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetNetAddress[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetNetAddress);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetNetAddress*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetNetAddress*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetNetAddress(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetNetAddress %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetNetAddress*)p = *(_vbox__IVRDPServer_USCOREsetNetAddress*)q;
}

void _vbox__IVRDPServer_USCOREgetNetAddressResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetNetAddressResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetNetAddressResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetNetAddressResponse::returnval);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetNetAddressResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetNetAddressResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetNetAddressResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetNetAddressResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetNetAddressResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse), type))
		return soap->error;
	if (soap_out_std__string(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetNetAddressResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetNetAddressResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetNetAddressResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetNetAddressResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetNetAddressResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetNetAddressResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetNetAddressResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetNetAddressResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetNetAddressResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetNetAddressResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetNetAddressResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetNetAddressResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetNetAddressResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse, sizeof(_vbox__IVRDPServer_USCOREgetNetAddressResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetNetAddressResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetNetAddressResponse::returnval), "xsd:string"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetNetAddressResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetNetAddressResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetNetAddressResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetNetAddressResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetNetAddressResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetNetAddressResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddressResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetNetAddressResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetNetAddressResponse);
		((_vbox__IVRDPServer_USCOREgetNetAddressResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetNetAddressResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetNetAddressResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetNetAddressResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetNetAddressResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetNetAddressResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetNetAddressResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetNetAddressResponse*)p = *(_vbox__IVRDPServer_USCOREgetNetAddressResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetNetAddress::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetNetAddress::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetNetAddress::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetNetAddress::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetNetAddress::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetNetAddress::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetNetAddress(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetNetAddress(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetNetAddress *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetNetAddress::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetNetAddress::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetNetAddress(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetNetAddress * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetNetAddress(struct soap *soap, _vbox__IVRDPServer_USCOREgetNetAddress *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetNetAddress(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetNetAddress::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetNetAddress(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetNetAddress * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetNetAddress(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetNetAddress *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetNetAddress *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress, sizeof(_vbox__IVRDPServer_USCOREgetNetAddress), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetNetAddress *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetNetAddress::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetNetAddress *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress, 0, sizeof(_vbox__IVRDPServer_USCOREgetNetAddress), 0, soap_copy__vbox__IVRDPServer_USCOREgetNetAddress);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetNetAddress * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetNetAddress(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetNetAddress(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetNetAddress, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetNetAddress;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetNetAddress);
		((_vbox__IVRDPServer_USCOREgetNetAddress*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetNetAddress[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetNetAddress);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetNetAddress*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetNetAddress*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetNetAddress(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetNetAddress %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetNetAddress*)p = *(_vbox__IVRDPServer_USCOREgetNetAddress*)q;
}

void _vbox__IVRDPServer_USCOREsetPortResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetPortResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetPortResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetPortResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetPortResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetPortResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetPortResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetPortResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetPortResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetPortResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetPortResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetPortResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetPortResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetPortResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetPortResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetPortResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetPortResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetPortResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetPortResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortResponse, sizeof(_vbox__IVRDPServer_USCOREsetPortResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetPortResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetPortResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetPortResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetPortResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetPortResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetPortResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetPortResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPortResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetPortResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetPortResponse);
		((_vbox__IVRDPServer_USCOREsetPortResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetPortResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetPortResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetPortResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetPortResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetPortResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetPortResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetPortResponse*)p = *(_vbox__IVRDPServer_USCOREsetPortResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetPort::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetPort::_USCOREthis);
	soap_default_unsignedInt(soap, &this->_vbox__IVRDPServer_USCOREsetPort::port);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetPort::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetPort::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetPort::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPort);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetPort::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetPort(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetPort(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetPort *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPort), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetPort::_USCOREthis), ""))
		return soap->error;
	if (soap_out_unsignedInt(soap, "port", -1, &(a->_vbox__IVRDPServer_USCOREsetPort::port), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetPort::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetPort(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetPort * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetPort(struct soap *soap, _vbox__IVRDPServer_USCOREsetPort *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetPort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetPort::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetPort(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetPort * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetPort(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetPort *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetPort *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPort, sizeof(_vbox__IVRDPServer_USCOREsetPort), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetPort)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetPort *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_port1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetPort::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_port1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "port", &(a->_vbox__IVRDPServer_USCOREsetPort::port), "xsd:unsignedInt"))
				{	soap_flag_port1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetPort *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPort, 0, sizeof(_vbox__IVRDPServer_USCOREsetPort), 0, soap_copy__vbox__IVRDPServer_USCOREsetPort);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_port1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetPort * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetPort(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetPort(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetPort, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetPort;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetPort);
		((_vbox__IVRDPServer_USCOREsetPort*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetPort[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetPort);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetPort*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetPort*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetPort(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetPort %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetPort*)p = *(_vbox__IVRDPServer_USCOREsetPort*)q;
}

void _vbox__IVRDPServer_USCOREgetPortResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_unsignedInt(soap, &this->_vbox__IVRDPServer_USCOREgetPortResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetPortResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetPortResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetPortResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetPortResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetPortResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetPortResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortResponse), type))
		return soap->error;
	if (soap_out_unsignedInt(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetPortResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetPortResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetPortResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetPortResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetPortResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetPortResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetPortResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetPortResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetPortResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetPortResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetPortResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetPortResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetPortResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortResponse, sizeof(_vbox__IVRDPServer_USCOREgetPortResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetPortResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_unsignedInt(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetPortResponse::returnval), "xsd:unsignedInt"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetPortResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetPortResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetPortResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetPortResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetPortResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetPortResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPortResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetPortResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetPortResponse);
		((_vbox__IVRDPServer_USCOREgetPortResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetPortResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetPortResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetPortResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetPortResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetPortResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetPortResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetPortResponse*)p = *(_vbox__IVRDPServer_USCOREgetPortResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetPort::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetPort::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetPort::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetPort::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetPort::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPort);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetPort::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetPort(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetPort(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetPort *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPort), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetPort::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetPort::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetPort(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetPort * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetPort(struct soap *soap, _vbox__IVRDPServer_USCOREgetPort *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetPort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetPort::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetPort(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetPort * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetPort(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetPort *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetPort *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPort, sizeof(_vbox__IVRDPServer_USCOREgetPort), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetPort)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetPort *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetPort::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetPort *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPort, 0, sizeof(_vbox__IVRDPServer_USCOREgetPort), 0, soap_copy__vbox__IVRDPServer_USCOREgetPort);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetPort * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetPort(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetPort(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetPort, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetPort;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetPort);
		((_vbox__IVRDPServer_USCOREgetPort*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetPort[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetPort);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetPort*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetPort*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetPort(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetPort %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetPort*)p = *(_vbox__IVRDPServer_USCOREgetPort*)q;
}

void _vbox__IVRDPServer_USCOREsetEnabledResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetEnabledResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetEnabledResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetEnabledResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetEnabledResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetEnabledResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetEnabledResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetEnabledResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetEnabledResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetEnabledResponse(struct soap *soap, _vbox__IVRDPServer_USCOREsetEnabledResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetEnabledResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetEnabledResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetEnabledResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetEnabledResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetEnabledResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetEnabledResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse, sizeof(_vbox__IVRDPServer_USCOREsetEnabledResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetEnabledResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetEnabledResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse, 0, sizeof(_vbox__IVRDPServer_USCOREsetEnabledResponse), 0, soap_copy__vbox__IVRDPServer_USCOREsetEnabledResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetEnabledResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetEnabledResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetEnabledResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabledResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetEnabledResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetEnabledResponse);
		((_vbox__IVRDPServer_USCOREsetEnabledResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetEnabledResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetEnabledResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetEnabledResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetEnabledResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetEnabledResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetEnabledResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetEnabledResponse*)p = *(_vbox__IVRDPServer_USCOREsetEnabledResponse*)q;
}

void _vbox__IVRDPServer_USCOREsetEnabled::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetEnabled::_USCOREthis);
	soap_default_bool(soap, &this->_vbox__IVRDPServer_USCOREsetEnabled::enabled);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREsetEnabled::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREsetEnabled::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREsetEnabled::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREsetEnabled::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREsetEnabled(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREsetEnabled(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREsetEnabled *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREsetEnabled::_USCOREthis), ""))
		return soap->error;
	if (soap_out_bool(soap, "enabled", -1, &(a->_vbox__IVRDPServer_USCOREsetEnabled::enabled), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREsetEnabled::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREsetEnabled(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetEnabled * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREsetEnabled(struct soap *soap, _vbox__IVRDPServer_USCOREsetEnabled *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREsetEnabled(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREsetEnabled::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREsetEnabled(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetEnabled * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREsetEnabled(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREsetEnabled *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREsetEnabled *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled, sizeof(_vbox__IVRDPServer_USCOREsetEnabled), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREsetEnabled *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_enabled1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREsetEnabled::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_enabled1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "enabled", &(a->_vbox__IVRDPServer_USCOREsetEnabled::enabled), "xsd:boolean"))
				{	soap_flag_enabled1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREsetEnabled *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled, 0, sizeof(_vbox__IVRDPServer_USCOREsetEnabled), 0, soap_copy__vbox__IVRDPServer_USCOREsetEnabled);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_enabled1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREsetEnabled * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREsetEnabled(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREsetEnabled(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREsetEnabled, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetEnabled;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREsetEnabled);
		((_vbox__IVRDPServer_USCOREsetEnabled*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREsetEnabled[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREsetEnabled);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREsetEnabled*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREsetEnabled*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREsetEnabled(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREsetEnabled %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREsetEnabled*)p = *(_vbox__IVRDPServer_USCOREsetEnabled*)q;
}

void _vbox__IVRDPServer_USCOREgetEnabledResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_bool(soap, &this->_vbox__IVRDPServer_USCOREgetEnabledResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetEnabledResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetEnabledResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetEnabledResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetEnabledResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetEnabledResponse(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse), type))
		return soap->error;
	if (soap_out_bool(soap, "returnval", -1, &(a->_vbox__IVRDPServer_USCOREgetEnabledResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetEnabledResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetEnabledResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetEnabledResponse * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetEnabledResponse(struct soap *soap, _vbox__IVRDPServer_USCOREgetEnabledResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetEnabledResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetEnabledResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetEnabledResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetEnabledResponse * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetEnabledResponse(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetEnabledResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse, sizeof(_vbox__IVRDPServer_USCOREgetEnabledResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetEnabledResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "returnval", &(a->_vbox__IVRDPServer_USCOREgetEnabledResponse::returnval), "xsd:boolean"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetEnabledResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse, 0, sizeof(_vbox__IVRDPServer_USCOREgetEnabledResponse), 0, soap_copy__vbox__IVRDPServer_USCOREgetEnabledResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetEnabledResponse * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetEnabledResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetEnabledResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabledResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetEnabledResponse;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetEnabledResponse);
		((_vbox__IVRDPServer_USCOREgetEnabledResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetEnabledResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetEnabledResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetEnabledResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetEnabledResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetEnabledResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetEnabledResponse %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetEnabledResponse*)p = *(_vbox__IVRDPServer_USCOREgetEnabledResponse*)q;
}

void _vbox__IVRDPServer_USCOREgetEnabled::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetEnabled::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IVRDPServer_USCOREgetEnabled::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IVRDPServer_USCOREgetEnabled::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IVRDPServer_USCOREgetEnabled::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IVRDPServer_USCOREgetEnabled::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IVRDPServer_USCOREgetEnabled(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IVRDPServer_USCOREgetEnabled(struct soap *soap, const char *tag, int id, const _vbox__IVRDPServer_USCOREgetEnabled *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IVRDPServer_USCOREgetEnabled::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IVRDPServer_USCOREgetEnabled::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IVRDPServer_USCOREgetEnabled(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetEnabled * SOAP_FMAC4 soap_get__vbox__IVRDPServer_USCOREgetEnabled(struct soap *soap, _vbox__IVRDPServer_USCOREgetEnabled *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IVRDPServer_USCOREgetEnabled(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IVRDPServer_USCOREgetEnabled::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IVRDPServer_USCOREgetEnabled(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetEnabled * SOAP_FMAC4 soap_in__vbox__IVRDPServer_USCOREgetEnabled(struct soap *soap, const char *tag, _vbox__IVRDPServer_USCOREgetEnabled *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IVRDPServer_USCOREgetEnabled *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled, sizeof(_vbox__IVRDPServer_USCOREgetEnabled), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IVRDPServer_USCOREgetEnabled *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IVRDPServer_USCOREgetEnabled::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IVRDPServer_USCOREgetEnabled *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled, 0, sizeof(_vbox__IVRDPServer_USCOREgetEnabled), 0, soap_copy__vbox__IVRDPServer_USCOREgetEnabled);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IVRDPServer_USCOREgetEnabled * SOAP_FMAC4 soap_instantiate__vbox__IVRDPServer_USCOREgetEnabled(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IVRDPServer_USCOREgetEnabled(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IVRDPServer_USCOREgetEnabled, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetEnabled;
		if (size)
			*size = sizeof(_vbox__IVRDPServer_USCOREgetEnabled);
		((_vbox__IVRDPServer_USCOREgetEnabled*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IVRDPServer_USCOREgetEnabled[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IVRDPServer_USCOREgetEnabled);
		for (int i = 0; i < n; i++)
			((_vbox__IVRDPServer_USCOREgetEnabled*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IVRDPServer_USCOREgetEnabled*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IVRDPServer_USCOREgetEnabled(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IVRDPServer_USCOREgetEnabled %p -> %p\n", q, p));
	*(_vbox__IVRDPServer_USCOREgetEnabled*)p = *(_vbox__IVRDPServer_USCOREgetEnabled*)q;
}

void _vbox__IAudioAdapter_USCOREsetAudioDriverResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREsetAudioDriverResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREsetAudioDriverResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREsetAudioDriverResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREsetAudioDriverResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREsetAudioDriverResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioDriverResponse * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(struct soap *soap, _vbox__IAudioAdapter_USCOREsetAudioDriverResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREsetAudioDriverResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioDriverResponse * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREsetAudioDriverResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREsetAudioDriverResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse, sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREsetAudioDriverResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREsetAudioDriverResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse, 0, sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse), 0, soap_copy__vbox__IAudioAdapter_USCOREsetAudioDriverResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioDriverResponse * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioDriverResponse;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse);
		((_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioDriverResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREsetAudioDriverResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREsetAudioDriverResponse %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)p = *(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)q;
}

void _vbox__IAudioAdapter_USCOREsetAudioDriver::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IAudioAdapter_USCOREsetAudioDriver::_USCOREthis);
	soap_default_vbox__AudioDriverType(soap, &this->_vbox__IAudioAdapter_USCOREsetAudioDriver::audioDriver);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREsetAudioDriver::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IAudioAdapter_USCOREsetAudioDriver::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREsetAudioDriver::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREsetAudioDriver::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREsetAudioDriver(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREsetAudioDriver(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREsetAudioDriver *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IAudioAdapter_USCOREsetAudioDriver::_USCOREthis), ""))
		return soap->error;
	if (soap_out_vbox__AudioDriverType(soap, "audioDriver", -1, &(a->_vbox__IAudioAdapter_USCOREsetAudioDriver::audioDriver), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREsetAudioDriver::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREsetAudioDriver(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioDriver * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREsetAudioDriver(struct soap *soap, _vbox__IAudioAdapter_USCOREsetAudioDriver *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREsetAudioDriver(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREsetAudioDriver::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREsetAudioDriver(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioDriver * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREsetAudioDriver(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREsetAudioDriver *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREsetAudioDriver *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver, sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriver), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREsetAudioDriver *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_audioDriver1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IAudioAdapter_USCOREsetAudioDriver::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_audioDriver1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__AudioDriverType(soap, "audioDriver", &(a->_vbox__IAudioAdapter_USCOREsetAudioDriver::audioDriver), "vbox:AudioDriverType"))
				{	soap_flag_audioDriver1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREsetAudioDriver *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver, 0, sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriver), 0, soap_copy__vbox__IAudioAdapter_USCOREsetAudioDriver);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_audioDriver1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioDriver * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioDriver(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioDriver(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioDriver;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriver);
		((_vbox__IAudioAdapter_USCOREsetAudioDriver*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioDriver[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREsetAudioDriver);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREsetAudioDriver*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREsetAudioDriver*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREsetAudioDriver(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREsetAudioDriver %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREsetAudioDriver*)p = *(_vbox__IAudioAdapter_USCOREsetAudioDriver*)q;
}

void _vbox__IAudioAdapter_USCOREgetAudioDriverResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__AudioDriverType(soap, &this->_vbox__IAudioAdapter_USCOREgetAudioDriverResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREgetAudioDriverResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREgetAudioDriverResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREgetAudioDriverResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREgetAudioDriverResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse), type))
		return soap->error;
	if (soap_out_vbox__AudioDriverType(soap, "returnval", -1, &(a->_vbox__IAudioAdapter_USCOREgetAudioDriverResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREgetAudioDriverResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioDriverResponse * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(struct soap *soap, _vbox__IAudioAdapter_USCOREgetAudioDriverResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREgetAudioDriverResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioDriverResponse * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREgetAudioDriverResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREgetAudioDriverResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse, sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREgetAudioDriverResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__AudioDriverType(soap, "returnval", &(a->_vbox__IAudioAdapter_USCOREgetAudioDriverResponse::returnval), "vbox:AudioDriverType"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREgetAudioDriverResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse, 0, sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse), 0, soap_copy__vbox__IAudioAdapter_USCOREgetAudioDriverResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioDriverResponse * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioDriverResponse;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse);
		((_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioDriverResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREgetAudioDriverResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREgetAudioDriverResponse %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)p = *(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)q;
}

void _vbox__IAudioAdapter_USCOREgetAudioDriver::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IAudioAdapter_USCOREgetAudioDriver::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREgetAudioDriver::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IAudioAdapter_USCOREgetAudioDriver::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREgetAudioDriver::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREgetAudioDriver::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREgetAudioDriver(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREgetAudioDriver(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREgetAudioDriver *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IAudioAdapter_USCOREgetAudioDriver::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREgetAudioDriver::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREgetAudioDriver(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioDriver * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREgetAudioDriver(struct soap *soap, _vbox__IAudioAdapter_USCOREgetAudioDriver *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREgetAudioDriver(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREgetAudioDriver::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREgetAudioDriver(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioDriver * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREgetAudioDriver(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREgetAudioDriver *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREgetAudioDriver *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver, sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriver), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREgetAudioDriver *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IAudioAdapter_USCOREgetAudioDriver::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREgetAudioDriver *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver, 0, sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriver), 0, soap_copy__vbox__IAudioAdapter_USCOREgetAudioDriver);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioDriver * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioDriver(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioDriver(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioDriver;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriver);
		((_vbox__IAudioAdapter_USCOREgetAudioDriver*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioDriver[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREgetAudioDriver);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREgetAudioDriver*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREgetAudioDriver*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREgetAudioDriver(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREgetAudioDriver %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREgetAudioDriver*)p = *(_vbox__IAudioAdapter_USCOREgetAudioDriver*)q;
}

void _vbox__IAudioAdapter_USCOREsetAudioControllerResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREsetAudioControllerResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREsetAudioControllerResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREsetAudioControllerResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREsetAudioControllerResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREsetAudioControllerResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioControllerResponse * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(struct soap *soap, _vbox__IAudioAdapter_USCOREsetAudioControllerResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREsetAudioControllerResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioControllerResponse * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREsetAudioControllerResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREsetAudioControllerResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse, sizeof(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREsetAudioControllerResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREsetAudioControllerResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse, 0, sizeof(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse), 0, soap_copy__vbox__IAudioAdapter_USCOREsetAudioControllerResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioControllerResponse * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioControllerResponse;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse);
		((_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioControllerResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREsetAudioControllerResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREsetAudioControllerResponse %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)p = *(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)q;
}

void _vbox__IAudioAdapter_USCOREsetAudioController::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IAudioAdapter_USCOREsetAudioController::_USCOREthis);
	soap_default_vbox__AudioControllerType(soap, &this->_vbox__IAudioAdapter_USCOREsetAudioController::audioController);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREsetAudioController::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IAudioAdapter_USCOREsetAudioController::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREsetAudioController::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREsetAudioController::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREsetAudioController(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREsetAudioController(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREsetAudioController *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IAudioAdapter_USCOREsetAudioController::_USCOREthis), ""))
		return soap->error;
	if (soap_out_vbox__AudioControllerType(soap, "audioController", -1, &(a->_vbox__IAudioAdapter_USCOREsetAudioController::audioController), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREsetAudioController::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREsetAudioController(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioController * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREsetAudioController(struct soap *soap, _vbox__IAudioAdapter_USCOREsetAudioController *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREsetAudioController(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREsetAudioController::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREsetAudioController(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioController * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREsetAudioController(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREsetAudioController *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREsetAudioController *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController, sizeof(_vbox__IAudioAdapter_USCOREsetAudioController), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREsetAudioController *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_audioController1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IAudioAdapter_USCOREsetAudioController::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_audioController1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__AudioControllerType(soap, "audioController", &(a->_vbox__IAudioAdapter_USCOREsetAudioController::audioController), "vbox:AudioControllerType"))
				{	soap_flag_audioController1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREsetAudioController *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController, 0, sizeof(_vbox__IAudioAdapter_USCOREsetAudioController), 0, soap_copy__vbox__IAudioAdapter_USCOREsetAudioController);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_audioController1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetAudioController * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioController(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREsetAudioController(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioController;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREsetAudioController);
		((_vbox__IAudioAdapter_USCOREsetAudioController*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetAudioController[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREsetAudioController);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREsetAudioController*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREsetAudioController*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREsetAudioController(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREsetAudioController %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREsetAudioController*)p = *(_vbox__IAudioAdapter_USCOREsetAudioController*)q;
}

void _vbox__IAudioAdapter_USCOREgetAudioControllerResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__AudioControllerType(soap, &this->_vbox__IAudioAdapter_USCOREgetAudioControllerResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREgetAudioControllerResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREgetAudioControllerResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREgetAudioControllerResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREgetAudioControllerResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse), type))
		return soap->error;
	if (soap_out_vbox__AudioControllerType(soap, "returnval", -1, &(a->_vbox__IAudioAdapter_USCOREgetAudioControllerResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREgetAudioControllerResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioControllerResponse * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(struct soap *soap, _vbox__IAudioAdapter_USCOREgetAudioControllerResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREgetAudioControllerResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioControllerResponse * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREgetAudioControllerResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREgetAudioControllerResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse, sizeof(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREgetAudioControllerResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__AudioControllerType(soap, "returnval", &(a->_vbox__IAudioAdapter_USCOREgetAudioControllerResponse::returnval), "vbox:AudioControllerType"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREgetAudioControllerResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse, 0, sizeof(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse), 0, soap_copy__vbox__IAudioAdapter_USCOREgetAudioControllerResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioControllerResponse * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioControllerResponse;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse);
		((_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioControllerResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREgetAudioControllerResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREgetAudioControllerResponse %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)p = *(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)q;
}

void _vbox__IAudioAdapter_USCOREgetAudioController::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IAudioAdapter_USCOREgetAudioController::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREgetAudioController::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IAudioAdapter_USCOREgetAudioController::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREgetAudioController::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREgetAudioController::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREgetAudioController(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREgetAudioController(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREgetAudioController *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IAudioAdapter_USCOREgetAudioController::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREgetAudioController::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREgetAudioController(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioController * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREgetAudioController(struct soap *soap, _vbox__IAudioAdapter_USCOREgetAudioController *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREgetAudioController(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREgetAudioController::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREgetAudioController(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioController * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREgetAudioController(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREgetAudioController *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREgetAudioController *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController, sizeof(_vbox__IAudioAdapter_USCOREgetAudioController), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREgetAudioController *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IAudioAdapter_USCOREgetAudioController::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREgetAudioController *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController, 0, sizeof(_vbox__IAudioAdapter_USCOREgetAudioController), 0, soap_copy__vbox__IAudioAdapter_USCOREgetAudioController);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetAudioController * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioController(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREgetAudioController(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioController;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREgetAudioController);
		((_vbox__IAudioAdapter_USCOREgetAudioController*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetAudioController[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREgetAudioController);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREgetAudioController*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREgetAudioController*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREgetAudioController(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREgetAudioController %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREgetAudioController*)p = *(_vbox__IAudioAdapter_USCOREgetAudioController*)q;
}

void _vbox__IAudioAdapter_USCOREsetEnabledResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREsetEnabledResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREsetEnabledResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREsetEnabledResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREsetEnabledResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREsetEnabledResponse(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREsetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREsetEnabledResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREsetEnabledResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetEnabledResponse * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREsetEnabledResponse(struct soap *soap, _vbox__IAudioAdapter_USCOREsetEnabledResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREsetEnabledResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREsetEnabledResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREsetEnabledResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetEnabledResponse * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREsetEnabledResponse(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREsetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREsetEnabledResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse, sizeof(_vbox__IAudioAdapter_USCOREsetEnabledResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREsetEnabledResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREsetEnabledResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse, 0, sizeof(_vbox__IAudioAdapter_USCOREsetEnabledResponse), 0, soap_copy__vbox__IAudioAdapter_USCOREsetEnabledResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetEnabledResponse * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREsetEnabledResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREsetEnabledResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetEnabledResponse;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREsetEnabledResponse);
		((_vbox__IAudioAdapter_USCOREsetEnabledResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetEnabledResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREsetEnabledResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREsetEnabledResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREsetEnabledResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREsetEnabledResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREsetEnabledResponse %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREsetEnabledResponse*)p = *(_vbox__IAudioAdapter_USCOREsetEnabledResponse*)q;
}

void _vbox__IAudioAdapter_USCOREsetEnabled::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IAudioAdapter_USCOREsetEnabled::_USCOREthis);
	soap_default_bool(soap, &this->_vbox__IAudioAdapter_USCOREsetEnabled::enabled);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREsetEnabled::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IAudioAdapter_USCOREsetEnabled::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREsetEnabled::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREsetEnabled::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREsetEnabled(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREsetEnabled(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREsetEnabled *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IAudioAdapter_USCOREsetEnabled::_USCOREthis), ""))
		return soap->error;
	if (soap_out_bool(soap, "enabled", -1, &(a->_vbox__IAudioAdapter_USCOREsetEnabled::enabled), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREsetEnabled::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREsetEnabled(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetEnabled * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREsetEnabled(struct soap *soap, _vbox__IAudioAdapter_USCOREsetEnabled *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREsetEnabled(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREsetEnabled::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREsetEnabled(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetEnabled * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREsetEnabled(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREsetEnabled *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREsetEnabled *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled, sizeof(_vbox__IAudioAdapter_USCOREsetEnabled), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREsetEnabled *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_enabled1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IAudioAdapter_USCOREsetEnabled::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_enabled1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "enabled", &(a->_vbox__IAudioAdapter_USCOREsetEnabled::enabled), "xsd:boolean"))
				{	soap_flag_enabled1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREsetEnabled *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled, 0, sizeof(_vbox__IAudioAdapter_USCOREsetEnabled), 0, soap_copy__vbox__IAudioAdapter_USCOREsetEnabled);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_enabled1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREsetEnabled * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREsetEnabled(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREsetEnabled(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetEnabled;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREsetEnabled);
		((_vbox__IAudioAdapter_USCOREsetEnabled*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREsetEnabled[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREsetEnabled);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREsetEnabled*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREsetEnabled*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREsetEnabled(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREsetEnabled %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREsetEnabled*)p = *(_vbox__IAudioAdapter_USCOREsetEnabled*)q;
}

void _vbox__IAudioAdapter_USCOREgetEnabledResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_bool(soap, &this->_vbox__IAudioAdapter_USCOREgetEnabledResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREgetEnabledResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREgetEnabledResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREgetEnabledResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREgetEnabledResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREgetEnabledResponse(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREgetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse), type))
		return soap->error;
	if (soap_out_bool(soap, "returnval", -1, &(a->_vbox__IAudioAdapter_USCOREgetEnabledResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREgetEnabledResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREgetEnabledResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetEnabledResponse * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREgetEnabledResponse(struct soap *soap, _vbox__IAudioAdapter_USCOREgetEnabledResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREgetEnabledResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREgetEnabledResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREgetEnabledResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetEnabledResponse * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREgetEnabledResponse(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREgetEnabledResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREgetEnabledResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse, sizeof(_vbox__IAudioAdapter_USCOREgetEnabledResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREgetEnabledResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "returnval", &(a->_vbox__IAudioAdapter_USCOREgetEnabledResponse::returnval), "xsd:boolean"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREgetEnabledResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse, 0, sizeof(_vbox__IAudioAdapter_USCOREgetEnabledResponse), 0, soap_copy__vbox__IAudioAdapter_USCOREgetEnabledResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetEnabledResponse * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREgetEnabledResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREgetEnabledResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetEnabledResponse;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREgetEnabledResponse);
		((_vbox__IAudioAdapter_USCOREgetEnabledResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetEnabledResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREgetEnabledResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREgetEnabledResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREgetEnabledResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREgetEnabledResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREgetEnabledResponse %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREgetEnabledResponse*)p = *(_vbox__IAudioAdapter_USCOREgetEnabledResponse*)q;
}

void _vbox__IAudioAdapter_USCOREgetEnabled::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IAudioAdapter_USCOREgetEnabled::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IAudioAdapter_USCOREgetEnabled::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IAudioAdapter_USCOREgetEnabled::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IAudioAdapter_USCOREgetEnabled::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IAudioAdapter_USCOREgetEnabled::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IAudioAdapter_USCOREgetEnabled(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IAudioAdapter_USCOREgetEnabled(struct soap *soap, const char *tag, int id, const _vbox__IAudioAdapter_USCOREgetEnabled *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IAudioAdapter_USCOREgetEnabled::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IAudioAdapter_USCOREgetEnabled::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IAudioAdapter_USCOREgetEnabled(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetEnabled * SOAP_FMAC4 soap_get__vbox__IAudioAdapter_USCOREgetEnabled(struct soap *soap, _vbox__IAudioAdapter_USCOREgetEnabled *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IAudioAdapter_USCOREgetEnabled(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IAudioAdapter_USCOREgetEnabled::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IAudioAdapter_USCOREgetEnabled(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetEnabled * SOAP_FMAC4 soap_in__vbox__IAudioAdapter_USCOREgetEnabled(struct soap *soap, const char *tag, _vbox__IAudioAdapter_USCOREgetEnabled *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IAudioAdapter_USCOREgetEnabled *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled, sizeof(_vbox__IAudioAdapter_USCOREgetEnabled), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IAudioAdapter_USCOREgetEnabled *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IAudioAdapter_USCOREgetEnabled::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IAudioAdapter_USCOREgetEnabled *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled, 0, sizeof(_vbox__IAudioAdapter_USCOREgetEnabled), 0, soap_copy__vbox__IAudioAdapter_USCOREgetEnabled);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IAudioAdapter_USCOREgetEnabled * SOAP_FMAC4 soap_instantiate__vbox__IAudioAdapter_USCOREgetEnabled(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IAudioAdapter_USCOREgetEnabled(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetEnabled;
		if (size)
			*size = sizeof(_vbox__IAudioAdapter_USCOREgetEnabled);
		((_vbox__IAudioAdapter_USCOREgetEnabled*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IAudioAdapter_USCOREgetEnabled[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IAudioAdapter_USCOREgetEnabled);
		for (int i = 0; i < n; i++)
			((_vbox__IAudioAdapter_USCOREgetEnabled*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IAudioAdapter_USCOREgetEnabled*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IAudioAdapter_USCOREgetEnabled(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IAudioAdapter_USCOREgetEnabled %p -> %p\n", q, p));
	*(_vbox__IAudioAdapter_USCOREgetEnabled*)p = *(_vbox__IAudioAdapter_USCOREgetEnabled*)q;
}

void _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(struct soap *soap, const char *tag, int id, const _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse), type))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse * SOAP_FMAC4 soap_get__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(struct soap *soap, _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse * SOAP_FMAC4 soap_in__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(struct soap *soap, const char *tag, _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse, sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse *)a->soap_in(soap, tag, type);
		}
	}
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse, 0, sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse), 0, soap_copy__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse * SOAP_FMAC4 soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse;
		if (size)
			*size = sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse);
		((_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse %p -> %p\n", q, p));
	*(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)p = *(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)q;
}

void _vbox__IHostUSBDeviceFilter_USCOREsetAction::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IHostUSBDeviceFilter_USCOREsetAction::_USCOREthis);
	soap_default_vbox__USBDeviceFilterAction(soap, &this->_vbox__IHostUSBDeviceFilter_USCOREsetAction::action);
	/* transient soap skipped */
}

void _vbox__IHostUSBDeviceFilter_USCOREsetAction::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IHostUSBDeviceFilter_USCOREsetAction::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IHostUSBDeviceFilter_USCOREsetAction::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IHostUSBDeviceFilter_USCOREsetAction::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostUSBDeviceFilter_USCOREsetAction(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostUSBDeviceFilter_USCOREsetAction(struct soap *soap, const char *tag, int id, const _vbox__IHostUSBDeviceFilter_USCOREsetAction *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IHostUSBDeviceFilter_USCOREsetAction::_USCOREthis), ""))
		return soap->error;
	if (soap_out_vbox__USBDeviceFilterAction(soap, "action", -1, &(a->_vbox__IHostUSBDeviceFilter_USCOREsetAction::action), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostUSBDeviceFilter_USCOREsetAction::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IHostUSBDeviceFilter_USCOREsetAction(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREsetAction * SOAP_FMAC4 soap_get__vbox__IHostUSBDeviceFilter_USCOREsetAction(struct soap *soap, _vbox__IHostUSBDeviceFilter_USCOREsetAction *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IHostUSBDeviceFilter_USCOREsetAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IHostUSBDeviceFilter_USCOREsetAction::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostUSBDeviceFilter_USCOREsetAction(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREsetAction * SOAP_FMAC4 soap_in__vbox__IHostUSBDeviceFilter_USCOREsetAction(struct soap *soap, const char *tag, _vbox__IHostUSBDeviceFilter_USCOREsetAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostUSBDeviceFilter_USCOREsetAction *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction, sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetAction), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IHostUSBDeviceFilter_USCOREsetAction *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	size_t soap_flag_action1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IHostUSBDeviceFilter_USCOREsetAction::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			if (soap_flag_action1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__USBDeviceFilterAction(soap, "action", &(a->_vbox__IHostUSBDeviceFilter_USCOREsetAction::action), "vbox:USBDeviceFilterAction"))
				{	soap_flag_action1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IHostUSBDeviceFilter_USCOREsetAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction, 0, sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetAction), 0, soap_copy__vbox__IHostUSBDeviceFilter_USCOREsetAction);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0 || soap_flag_action1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREsetAction * SOAP_FMAC4 soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREsetAction(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREsetAction(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREsetAction;
		if (size)
			*size = sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetAction);
		((_vbox__IHostUSBDeviceFilter_USCOREsetAction*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREsetAction[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IHostUSBDeviceFilter_USCOREsetAction);
		for (int i = 0; i < n; i++)
			((_vbox__IHostUSBDeviceFilter_USCOREsetAction*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IHostUSBDeviceFilter_USCOREsetAction*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IHostUSBDeviceFilter_USCOREsetAction(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IHostUSBDeviceFilter_USCOREsetAction %p -> %p\n", q, p));
	*(_vbox__IHostUSBDeviceFilter_USCOREsetAction*)p = *(_vbox__IHostUSBDeviceFilter_USCOREsetAction*)q;
}

void _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__USBDeviceFilterAction(soap, &this->_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(struct soap *soap, const char *tag, int id, const _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse), type))
		return soap->error;
	if (soap_out_vbox__USBDeviceFilterAction(soap, "returnval", -1, &(a->_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse * SOAP_FMAC4 soap_get__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(struct soap *soap, _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse * SOAP_FMAC4 soap_in__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(struct soap *soap, const char *tag, _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse, sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__USBDeviceFilterAction(soap, "returnval", &(a->_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse::returnval), "vbox:USBDeviceFilterAction"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse, 0, sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse), 0, soap_copy__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse * SOAP_FMAC4 soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse;
		if (size)
			*size = sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse);
		((_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse %p -> %p\n", q, p));
	*(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)p = *(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)q;
}

void _vbox__IHostUSBDeviceFilter_USCOREgetAction::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IHostUSBDeviceFilter_USCOREgetAction::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IHostUSBDeviceFilter_USCOREgetAction::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IHostUSBDeviceFilter_USCOREgetAction::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IHostUSBDeviceFilter_USCOREgetAction::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IHostUSBDeviceFilter_USCOREgetAction::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostUSBDeviceFilter_USCOREgetAction(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostUSBDeviceFilter_USCOREgetAction(struct soap *soap, const char *tag, int id, const _vbox__IHostUSBDeviceFilter_USCOREgetAction *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IHostUSBDeviceFilter_USCOREgetAction::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostUSBDeviceFilter_USCOREgetAction::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IHostUSBDeviceFilter_USCOREgetAction(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREgetAction * SOAP_FMAC4 soap_get__vbox__IHostUSBDeviceFilter_USCOREgetAction(struct soap *soap, _vbox__IHostUSBDeviceFilter_USCOREgetAction *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IHostUSBDeviceFilter_USCOREgetAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IHostUSBDeviceFilter_USCOREgetAction::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostUSBDeviceFilter_USCOREgetAction(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREgetAction * SOAP_FMAC4 soap_in__vbox__IHostUSBDeviceFilter_USCOREgetAction(struct soap *soap, const char *tag, _vbox__IHostUSBDeviceFilter_USCOREgetAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostUSBDeviceFilter_USCOREgetAction *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction, sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetAction), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IHostUSBDeviceFilter_USCOREgetAction *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IHostUSBDeviceFilter_USCOREgetAction::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IHostUSBDeviceFilter_USCOREgetAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction, 0, sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetAction), 0, soap_copy__vbox__IHostUSBDeviceFilter_USCOREgetAction);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IHostUSBDeviceFilter_USCOREgetAction * SOAP_FMAC4 soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREgetAction(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IHostUSBDeviceFilter_USCOREgetAction(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREgetAction;
		if (size)
			*size = sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetAction);
		((_vbox__IHostUSBDeviceFilter_USCOREgetAction*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IHostUSBDeviceFilter_USCOREgetAction[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IHostUSBDeviceFilter_USCOREgetAction);
		for (int i = 0; i < n; i++)
			((_vbox__IHostUSBDeviceFilter_USCOREgetAction*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IHostUSBDeviceFilter_USCOREgetAction*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IHostUSBDeviceFilter_USCOREgetAction(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IHostUSBDeviceFilter_USCOREgetAction %p -> %p\n", q, p));
	*(_vbox__IHostUSBDeviceFilter_USCOREgetAction*)p = *(_vbox__IHostUSBDeviceFilter_USCOREgetAction*)q;
}

void _vbox__IHostUSBDevice_USCOREgetStateResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_vbox__USBDeviceState(soap, &this->_vbox__IHostUSBDevice_USCOREgetStateResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IHostUSBDevice_USCOREgetStateResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IHostUSBDevice_USCOREgetStateResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IHostUSBDevice_USCOREgetStateResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostUSBDevice_USCOREgetStateResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostUSBDevice_USCOREgetStateResponse(struct soap *soap, const char *tag, int id, const _vbox__IHostUSBDevice_USCOREgetStateResponse *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse), type))
		return soap->error;
	if (soap_out_vbox__USBDeviceState(soap, "returnval", -1, &(a->_vbox__IHostUSBDevice_USCOREgetStateResponse::returnval), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostUSBDevice_USCOREgetStateResponse::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IHostUSBDevice_USCOREgetStateResponse(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IHostUSBDevice_USCOREgetStateResponse * SOAP_FMAC4 soap_get__vbox__IHostUSBDevice_USCOREgetStateResponse(struct soap *soap, _vbox__IHostUSBDevice_USCOREgetStateResponse *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IHostUSBDevice_USCOREgetStateResponse(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IHostUSBDevice_USCOREgetStateResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostUSBDevice_USCOREgetStateResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostUSBDevice_USCOREgetStateResponse * SOAP_FMAC4 soap_in__vbox__IHostUSBDevice_USCOREgetStateResponse(struct soap *soap, const char *tag, _vbox__IHostUSBDevice_USCOREgetStateResponse *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostUSBDevice_USCOREgetStateResponse *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse, sizeof(_vbox__IHostUSBDevice_USCOREgetStateResponse), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IHostUSBDevice_USCOREgetStateResponse *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_vbox__USBDeviceState(soap, "returnval", &(a->_vbox__IHostUSBDevice_USCOREgetStateResponse::returnval), "vbox:USBDeviceState"))
				{	soap_flag_returnval1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IHostUSBDevice_USCOREgetStateResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse, 0, sizeof(_vbox__IHostUSBDevice_USCOREgetStateResponse), 0, soap_copy__vbox__IHostUSBDevice_USCOREgetStateResponse);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IHostUSBDevice_USCOREgetStateResponse * SOAP_FMAC4 soap_instantiate__vbox__IHostUSBDevice_USCOREgetStateResponse(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IHostUSBDevice_USCOREgetStateResponse(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IHostUSBDevice_USCOREgetStateResponse;
		if (size)
			*size = sizeof(_vbox__IHostUSBDevice_USCOREgetStateResponse);
		((_vbox__IHostUSBDevice_USCOREgetStateResponse*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IHostUSBDevice_USCOREgetStateResponse[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IHostUSBDevice_USCOREgetStateResponse);
		for (int i = 0; i < n; i++)
			((_vbox__IHostUSBDevice_USCOREgetStateResponse*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IHostUSBDevice_USCOREgetStateResponse*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IHostUSBDevice_USCOREgetStateResponse(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IHostUSBDevice_USCOREgetStateResponse %p -> %p\n", q, p));
	*(_vbox__IHostUSBDevice_USCOREgetStateResponse*)p = *(_vbox__IHostUSBDevice_USCOREgetStateResponse*)q;
}

void _vbox__IHostUSBDevice_USCOREgetState::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_std__string(soap, &this->_vbox__IHostUSBDevice_USCOREgetState::_USCOREthis);
	/* transient soap skipped */
}

void _vbox__IHostUSBDevice_USCOREgetState::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	soap_serialize_std__string(soap, &this->_vbox__IHostUSBDevice_USCOREgetState::_USCOREthis);
	/* transient soap skipped */
}

int _vbox__IHostUSBDevice_USCOREgetState::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IHostUSBDevice_USCOREgetState::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostUSBDevice_USCOREgetState(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostUSBDevice_USCOREgetState(struct soap *soap, const char *tag, int id, const _vbox__IHostUSBDevice_USCOREgetState *a, const char *type)
{
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState), type))
		return soap->error;
	if (soap_out_std__string(soap, "_this", -1, &(a->_vbox__IHostUSBDevice_USCOREgetState::_USCOREthis), ""))
		return soap->error;
	/* transient soap skipped */
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostUSBDevice_USCOREgetState::soap_get(struct soap *soap, const char *tag, const char *type)
{
	return soap_get__vbox__IHostUSBDevice_USCOREgetState(soap, this, tag, type);
}

SOAP_FMAC3 _vbox__IHostUSBDevice_USCOREgetState * SOAP_FMAC4 soap_get__vbox__IHostUSBDevice_USCOREgetState(struct soap *soap, _vbox__IHostUSBDevice_USCOREgetState *p, const char *tag, const char *type)
{
	if ((p = soap_in__vbox__IHostUSBDevice_USCOREgetState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void *_vbox__IHostUSBDevice_USCOREgetState::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostUSBDevice_USCOREgetState(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostUSBDevice_USCOREgetState * SOAP_FMAC4 soap_in__vbox__IHostUSBDevice_USCOREgetState(struct soap *soap, const char *tag, _vbox__IHostUSBDevice_USCOREgetState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostUSBDevice_USCOREgetState *)soap_class_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState, sizeof(_vbox__IHostUSBDevice_USCOREgetState), soap->type, soap->arrayType);
	if (!a)
		return NULL;
	if (soap->alloced)
	{	a->soap_default(soap);
		if (soap->clist->type != SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState)
		{	soap_revert(soap);
			*soap->id = '\0';
			return (_vbox__IHostUSBDevice_USCOREgetState *)a->soap_in(soap, tag, type);
		}
	}
	size_t soap_flag__USCOREthis1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag__USCOREthis1 && (soap->error == SOAP_TAG_MISMATCH || soap->error == SOAP_NO_TAG))
				if (soap_in_std__string(soap, "_this", &(a->_vbox__IHostUSBDevice_USCOREgetState::_USCOREthis), "xsd:string"))
				{	soap_flag__USCOREthis1--;
					continue;
				}
			/* transient soap skipped */
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (_vbox__IHostUSBDevice_USCOREgetState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState, 0, sizeof(_vbox__IHostUSBDevice_USCOREgetState), 0, soap_copy__vbox__IHostUSBDevice_USCOREgetState);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	if ((soap->mode & SOAP_XML_STRICT) && (soap_flag__USCOREthis1 > 0))
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	return a;
}

SOAP_FMAC3 _vbox__IHostUSBDevice_USCOREgetState * SOAP_FMAC4 soap_instantiate__vbox__IHostUSBDevice_USCOREgetState(struct soap *soap, int n, const char *type, const char *arrayType, size_t *size)
{
	(void)type; (void)arrayType; /* appease -Wall -Werror */
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "soap_instantiate__vbox__IHostUSBDevice_USCOREgetState(%d, %s, %s)\n", n, type?type:"", arrayType?arrayType:""));
	struct soap_clist *cp = soap_link(soap, NULL, SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState, n, soap_fdelete);
	if (!cp)
		return NULL;
	if (n < 0)
	{	cp->ptr = (void*)new _vbox__IHostUSBDevice_USCOREgetState;
		if (size)
			*size = sizeof(_vbox__IHostUSBDevice_USCOREgetState);
		((_vbox__IHostUSBDevice_USCOREgetState*)cp->ptr)->soap = soap;
	}
	else
	{	cp->ptr = (void*)new _vbox__IHostUSBDevice_USCOREgetState[n];
		if (!cp->ptr)
		{	soap->error = SOAP_EOM;
			return NULL;
		}
		if (size)
			*size = n * sizeof(_vbox__IHostUSBDevice_USCOREgetState);
		for (int i = 0; i < n; i++)
			((_vbox__IHostUSBDevice_USCOREgetState*)cp->ptr)[i].soap = soap;
	}
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Instantiated location=%p\n", cp->ptr));
	return (_vbox__IHostUSBDevice_USCOREgetState*)cp->ptr;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_copy__vbox__IHostUSBDevice_USCOREgetState(struct soap *soap, int st, int tt, void *p, size_t len, const void *q, size_t n)
{
	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copying _vbox__IHostUSBDevice_USCOREgetState %p -> %p\n", q, p));
	*(_vbox__IHostUSBDevice_USCOREgetState*)p = *(_vbox__IHostUSBDevice_USCOREgetState*)q;
}

void _vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	/* transient soap skipped */
}

void _vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
	/* transient soap skipped */
}

int _vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse::soap_put(struct soap *soap, const char *tag, const  char *type) const
{
	register int id = soap_embed(soap, (void*)this, NULL, 0, tag, SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse);
	if (this->soap_out(soap, tag, id, type))
		return soap->error;
	return soap_putindependent(soap);
}

int _vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse(soap, tag, id, this, type);
}

